//*****************************************************************************
//*****************************************************************************
//  FILENAME: SmartSense_EMCplus.h
//   Version: 1.00, Updated on 2012/3/2 at 9:15:19
//  Generated by PSoC Designer 5.2.2551
//
//  DESCRIPTION: SmartSense_EMCplus User Module C Language interface file
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
//*****************************************************************************
#ifndef SmartSense_EMCplus_INCLUDE
#define SmartSense_EMCplus_INCLUDE

#include <m8c.h>

//--------------------------------------------------
// Constants for SmartSense_EMCplus
//--------------------------------------------------
#if (0x1)
#define SmartSense_EMCplus_TOTALSENSORCOUNT           0x1
#else
#define SmartSense_EMCplus_TOTALSENSORCOUNT           1
#endif
#define SmartSense_EMCplus_BUTTONCOUNT                0x1
#define SmartSense_EMCplus_SLIDERCOUNT                0x0 + 0x0
#define SmartSense_EMCplus_PROXIMITYCOUNT             0x0

#define SmartSense_EMCplus_BUTTONS_EXIST              0x1
#define SmartSense_EMCplus_SLIDERS_EXIST              0x0 | 0x0
#define SmartSense_EMCplus_LIN_SLIDERS_EXIST          0x0
#define SmartSense_EMCplus_ROT_SLIDERS_EXIST          0x0

#define SmartSense_EMCplus_AUTOCAL_ENABLE             0x2
#define SmartSense_EMCplus_AUTOCAL_NONE               0x00
#define SmartSense_EMCplus_AUTOCAL_AUTORANGE          0x01
#define SmartSense_EMCplus_AUTOCAL_FULL               0x02
#define SmartSense_EMCplus_AUTO_THRESHOLD_ENABLED     0x1

#define SmartSense_EMCplus_IMMUNITY_LEVEL             1

//--------------------------------------------------
// Constants for Scan Speed values
//--------------------------------------------------
#define SmartSense_EMCplus_ULTRA_FAST_SPEED           0x00
#define SmartSense_EMCplus_FAST_SPEED                 0x01
#define SmartSense_EMCplus_NORMAL_SPEED               0x02
#define SmartSense_EMCplus_SLOW_SPEED                 0x03
#define SmartSense_EMCplus_SCANNING_SPEED             0x2

//--------------------------------------------------
// Constants for Prescaler values
//--------------------------------------------------
#define SmartSense_EMCplus_PRESCALER                  0x1
#define SmartSense_EMCplus_PRESCALER_1                0x00
#define SmartSense_EMCplus_PRESCALER_2                0x01
#define SmartSense_EMCplus_PRESCALER_4                0x02
#define SmartSense_EMCplus_PRESCALER_8                0x03
#define SmartSense_EMCplus_PRESCALER_16               0x04
#define SmartSense_EMCplus_PRESCALER_32               0x05
#define SmartSense_EMCplus_PRESCALER_64               0x06
#define SmartSense_EMCplus_PRESCALER_128              0x07
#define SmartSense_EMCplus_PRESCALER_256              0x08

//--------------------------------------------------
// Constants for Resolution values
//--------------------------------------------------
#define SmartSense_EMCplus_RESOLUTION                0xc
#define SmartSense_EMCplus_PROXIMITY_RESOLUTION      16

// Definitions below are for consistency with old CapSense UMs
// Not Recommended for using in new designs 
#define SmartSense_EMCplus_TotalSensorCount           0x1
#define SmartSense_EMCplus_ButtonCount                0x1
#define SmartSense_EMCplus_SliderCount                0x0 + 0x0 
#define SmartSense_EMCplus_ProximityCount             0x0
//End of old definitions

//--------------------------------------------------
// Variables for SmartSense_EMCplus.
//--------------------------------------------------

extern WORD SmartSense_EMCplus_waSnsResult[];
extern WORD SmartSense_EMCplus_waSnsBaseline[];
extern WORD SmartSense_EMCplus_waSnsDiff[];
extern BYTE SmartSense_EMCplus_baSnsOnMask[];
extern BYTE SmartSense_EMCplus_baDAC[];
extern BYTE SmartSense_EMCplus_baCompensationDAC[];
extern BYTE SmartSense_EMCplus_baSnsSignal[];

extern BYTE baPrescaler[];
extern BYTE baN[];
extern BYTE baSpeed[];
extern BYTE baK[];
extern BYTE baSensorSensitivity[];
extern BYTE baNoiseEnvelope[];
extern WORD waPreviousSample[];
extern BYTE baNoiseResetCounter[];
extern BYTE baSignRegister[];
extern BYTE baRunningDifference[];
extern WORD waSampleMin[];
extern WORD waSampleMax[];
extern BYTE baNoiseThreshold[];
extern BYTE baBtnFThreshold[];

extern BYTE SmartSense_EMCplus_bLowBaselineReset;
extern BYTE SmartSense_EMCplus_bHysteresis;
extern BYTE SmartSense_EMCplus_bNoiseThreshold;
extern BYTE SmartSense_EMCplus_bNegativeNoiseThreshold;
extern BYTE SmartSense_EMCplus_bBaselineUpdateThreshold;
extern BYTE SmartSense_EMCplus_bHysteresis;
extern BYTE SmartSense_EMCplus_bDebounce;


// Low Level scan API
#pragma fastcall16 SmartSense_EMCplus_Start
#pragma fastcall16 SmartSense_EMCplus_Stop
#pragma fastcall16 SmartSense_EMCplus_Resume
#pragma fastcall16 SmartSense_EMCplus_ScanSensor
#pragma fastcall16 SmartSense_EMCplus_ScanAllSensors
#pragma fastcall16 SmartSense_EMCplus_ClearSensors
#pragma fastcall16 SmartSense_EMCplus_wReadSensor
#pragma fastcall16 SmartSense_EMCplus_wGetPortPin
#pragma fastcall16 SmartSense_EMCplus_EnableSensor
#pragma fastcall16 SmartSense_EMCplus_DisableSensor


// High Level API
#pragma fastcall16 SmartSense_EMCplus_UpdateSensorBaseline
#pragma fastcall16 SmartSense_EMCplus_UpdateSensorSignal
#pragma fastcall16 SmartSense_EMCplus_bIsSensorActive
#pragma fastcall16 SmartSense_EMCplus_bIsAnySensorActive
#pragma fastcall16 SmartSense_EMCplus_InitializeSensorBaseline
#pragma fastcall16 SmartSense_EMCplus_InitializeBaselines
#pragma fastcall16 SmartSense_EMCplus_UpdateAllBaselines
#pragma fastcall16 SmartSense_EMCplus_wGetCentroidPos
#pragma fastcall16 SmartSense_EMCplus_wGetRadialPos
#pragma fastcall16 SmartSense_EMCplus_wGetRadialInc

//-------------------------------------------------
// C prototypes of the SmartSense_EMCplus API.
//-------------------------------------------------

//-------------------------------------------------
// Low Level scan API
//-------------------------------------------------

extern void SmartSense_EMCplus_Start(void);
extern void SmartSense_EMCplus_Stop(void);
extern void SmartSense_EMCplus_Resume(void);
extern void SmartSense_EMCplus_ScanSensor(BYTE bSensor);
extern void SmartSense_EMCplus_ScanAllSensors(void);
extern void SmartSense_EMCplus_ClearSensors(void);
extern WORD SmartSense_EMCplus_wReadSensor(BYTE bSensor);
extern WORD SmartSense_EMCplus_wGetPortPin(BYTE bSensor);
extern void SmartSense_EMCplus_EnableSensor(BYTE bMask, BYTE bPort);
extern void SmartSense_EMCplus_DisableSensor(BYTE bMask, BYTE bPort);

//-------------------------------------------------
// High level functions
//-------------------------------------------------

extern void SmartSense_EMCplus_UpdateSensorBaseline(BYTE bSensorNum);
extern BYTE SmartSense_EMCplus_UpdateSensorSignal(BYTE bSensorNum);
extern BYTE SmartSense_EMCplus_bIsSensorActive(BYTE bSensorNum);
extern BYTE SmartSense_EMCplus_bIsAnySensorActive(void);
extern void SmartSense_EMCplus_InitializeSensorBaseline(BYTE bSensorNum);
extern void SmartSense_EMCplus_InitializeBaselines(void);
extern void SmartSense_EMCplus_UpdateAllBaselines(void);
#if SmartSense_EMCplus_LIN_SLIDERS_EXIST
  extern WORD SmartSense_EMCplus_wGetCentroidPos(BYTE bSnsGroup);
#endif  
#if SmartSense_EMCplus_ROT_SLIDERS_EXIST
  extern WORD SmartSense_EMCplus_wGetRadialPos(BYTE bSnsGroup);
  extern WORD SmartSense_EMCplus_wGetRadialInc(BYTE bSnsGroup);   
#endif

//-------------------------------------------------
// Register Addresses for SmartSense_EMCplus
//-------------------------------------------------
#pragma ioport  SmartSense_EMCplus_CapSense_CR0_REG:    0x0a0       // CS block control Register 0
BYTE            SmartSense_EMCplus_CapSense_CR0_REG;
#pragma ioport  SmartSense_EMCplus_CapSense_CR1_REG:    0x0a1       // CS block control Register 1
BYTE            SmartSense_EMCplus_CapSense_CR1_REG;
#pragma ioport  SmartSense_EMCplus_CapSense_CR2_REG:    0x0a2       // CS block control Register 2
BYTE            SmartSense_EMCplus_CapSense_CR2_REG;
#pragma ioport  SmartSense_EMCplus_CapSense_CR3_REG:    0x0a3       // CS block control Register 3
BYTE            SmartSense_EMCplus_CapSense_CR3_REG;
#pragma ioport  SmartSense_EMCplus_CapSense_STAT_REG:   0x0a6      
BYTE            SmartSense_EMCplus_CapSense_STAT_REG;
#pragma ioport  SmartSense_EMCplus_CapSense_CNTH_REG:   0x0a5      
BYTE            SmartSense_EMCplus_CapSense_CNTH_REG;
#pragma ioport  SmartSense_EMCplus_CapSense_CNTL_REG:   0x0a4      
BYTE            SmartSense_EMCplus_CapSense_CNTL_REG;
#pragma ioport  SmartSense_EMCplus_CapSense_SLEW_REG:   0x0a8      
BYTE            SmartSense_EMCplus_CapSense_SLEW_REG;
#pragma ioport  SmartSense_EMCplus_CapSense_PRS_CR_REG: 0x0a9    
BYTE            SmartSense_EMCplus_CapSense_PRS_CR_REG;
#pragma ioport  SmartSense_EMCplus_CMP_CR0_REG: 0x07a            
BYTE            SmartSense_EMCplus_CMP_CR0_REG;
#pragma ioport  SmartSense_EMCplus_CMP_CR1_REG: 0x07b            
BYTE            SmartSense_EMCplus_CMP_CR1_REG;
#pragma ioport  SmartSense_EMCplus_CMP_MUX_REG: 0x079            
BYTE            SmartSense_EMCplus_CMP_MUX_REG;
#pragma ioport  SmartSense_EMCplus_P0_MUX_REG:  0x1d8             
BYTE            SmartSense_EMCplus_P0_MUX_REG;
#pragma ioport  SmartSense_EMCplus_P1_MUX_REG:  0x1d9             
BYTE            SmartSense_EMCplus_P1_MUX_REG;
#pragma ioport  SmartSense_EMCplus_P2_MUX_REG:  0x1da             
BYTE            SmartSense_EMCplus_P2_MUX_REG;
#pragma ioport  SmartSense_EMCplus_P3_MUX_REG:  0x1db             
BYTE            SmartSense_EMCplus_P3_MUX_REG;
#pragma ioport  SmartSense_EMCplus_P4_MUX_REG:  0x1df             
BYTE            SmartSense_EMCplus_P4_MUX_REG;
#pragma ioport  SmartSense_EMCplus_CONFIG_REG:  0x0b3             // Timer config
BYTE            SmartSense_EMCplus_CONFIG_REG;
#pragma ioport  SmartSense_EMCplus_DATA_1_REG:  0x0b4             // Timer Data Hi
BYTE            SmartSense_EMCplus_DATA_1_REG;
#pragma ioport  SmartSense_EMCplus_DATA_0_REG:  0x0b5             // Timer Data Lo
BYTE            SmartSense_EMCplus_DATA_0_REG;

#endif
