;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: SmartSense.asm
;;   Version: 1.00, Updated on 2012/3/2 at 9:15:19
;;  Generated by PSoC Designer 5.3.2710
;;
;;  DESCRIPTION: SmartSense_EMCplus User Module software implementation file.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "m8ssc.inc"
include "memory.inc"
include "GlobalParams.inc"
include "SmartSense.inc"

;-----------------------------------------------
;  Global Labels
;-----------------------------------------------

; Exported functions
export _SmartSense_Start
export  SmartSense_Start
export _SmartSense_Stop
export  SmartSense_Stop
export _SmartSense_Resume
export  SmartSense_Resume
export _SmartSense_SetScanMode
export  SmartSense_SetScanMode
export _SmartSense_ClearSensors
export  SmartSense_ClearSensors
export _SmartSense_wReadSensor
export  SmartSense_wReadSensor
export _SmartSense_wGetPortPin
export  SmartSense_wGetPortPin
export _SmartSense_EnableSensor
export  SmartSense_EnableSensor
export _SmartSense_DisableSensor
export  SmartSense_DisableSensor
export ScanSingleSensor
export _SmartSense_ScanSingleSensor
export  SmartSense_ScanSingleSensor
export _SmartSense_ScanSensor
export  SmartSense_ScanSensor
export _SmartSense_ScanAllSensors
export  SmartSense_ScanAllSensors
export CopyIdacValue
export _SmartSense_CopyIdacValue
export  SmartSense_CopyIdacValue
export CopywADCResultToBaseline
export _SmartSense_CopywADCResultToBaseline
export  SmartSense_CopywADCResultToBaseline
export _SmartSense_SetPrescaler
export  SmartSense_SetPrescaler
IF (SmartSense_AUTOCAL_ENABLE)
  export _CalibrateSensors
  export  CalibrateSensors
  export _SmartSense_CalibrateSensors
  export  SmartSense_CalibrateSensors
IF (SmartSense_SLIDERS_EXIST)
  export _SmartSense_SetSliderIdac
  export  SmartSense_SetSliderIdac
ENDIF
ENDIF

; Exported variables
export  bSensorNum
export  SmartSense_bSensorNum
export _SmartSense_bSensorNum

export _waSnsResult
export  SmartSense_waSnsResult
export _SmartSense_waSnsResult

export  SmartSense_bADCStatus
export _SmartSense_bADCStatus

export  wADC_Result
export  SmartSense_wADC_Result
export _SmartSense_wADC_Result

export  TotalSensorCount
export _baDAC
export  baDAC
export _SmartSense_baDAC
export  SmartSense_baDAC
IF (SmartSense_DUAL_IDAC)
export _SmartSense_baCompensationDAC
export  SmartSense_baCompensationDAC
ENDIF
export _bIDACComp
export  bIDACComp
export _bSensitivitySeed
export  bSensitivitySeed

export _Prescaler_Table
export  Prescaler_Table
export _Speed_Table
export  Speed_Table

export  bFreq
export  SmartSense_bFreq

; LIB variables
export  _baPrescaler
export  baPrescaler
export _SmartSense_baPrescaler
export  SmartSense_baPrescaler
export  _baN
export  baN
export _SmartSense_baN
export  SmartSense_baN
export  _baSpeed
export  baSpeed
export _SmartSense_baSpeed
export  SmartSense_baSpeed
export  _baK
export  baK
export _SmartSense_baK
export  SmartSense_baK

export  _baSensorSensitivity
export  baSensorSensitivity
export _SmartSense_baSensorSensitivity
export  SmartSense_baSensorSensitivity
export  _baNoiseEnvelope
export  baNoiseEnvelope
export _SmartSense_baNoiseEnvelope
export  SmartSense_baNoiseEnvelope
export  _waPreviousSample
export  waPreviousSample
export _SmartSense_waPreviousSample
export  SmartSense_waPreviousSample
export  _baNoiseResetCounter
export  baNoiseResetCounter
export _SmartSense_baNoiseResetCounter
export  SmartSense_baNoiseResetCounter
export  _baSignRegister
export  baSignRegister
export _SmartSense_baSignRegister
export  SmartSense_baSignRegister
export  _baRunningDifference
export  baRunningDifference
export _SmartSense_baRunningDifference
export  SmartSense_baRunningDifference
export  _waSampleMin
export  waSampleMin
export _SmartSense_waSampleMin
export  SmartSense_waSampleMin
export  _waSampleMax
export  waSampleMax
export _SmartSense_waSampleMax
export  SmartSense_waSampleMax

export  _baNoiseThreshold
export  baNoiseThreshold
export _SmartSense_baNoiseThreshold
export  SmartSense_baNoiseThreshold

export _SSC_Buffer
export  SSC_Buffer

AREA ABSRAM (RAM, ABS, CON)
ORG  f8h
 SSC_Buffer:                 
_SSC_Buffer:   BLK  8     ; reserve 8 bytes: F8 - FF for supervisory operation

AREA bss

;@PSoC_UserCode_INIT@ (Do not change this line.)
;---------------------------------------------------
; Insert your custom declarations below this banner
;---------------------------------------------------

;------------------------
; User Includes
;------------------------


;------------------------
; User Constant Definitions
;------------------------


;------------------------
; User Variable Allocation
;------------------------


;---------------------------------------------------
; Insert your custom declarations above this banner
;---------------------------------------------------
;@PSoC_UserCode_END@ (Do not change this line.)


;-----------------------------------------------
; Variable Allocation
;-----------------------------------------------
AREA InterruptRAM (RAM, REL, CON)
wADC_Result:
 SmartSense_wADC_Result:
_SmartSense_wADC_Result:                BLK  3

 SmartSense_bADCStatus:
_SmartSense_bADCStatus:                 BLK  1

 SmartSense_bBitMask:                   BLK  1  ; Temp bitmask byte
 
  bSensorNum: 
_SmartSense_bSensorNum:                         ; Current sensor to scan
 SmartSense_bSensorNum:                 BLK  1
 
  bIdacValue:
 SmartSense_bIdacValue:
_SmartSense_bIdacValue:                 BLK  1
IF (SmartSense_DUAL_IDAC)
 SmartSense_bCompensationIdacValue:
_SmartSense_bCompensationIdacValue:     BLK  1
ENDIF
 SmartSense_bResolution:                BLK  1
 SmartSense_bScanSpeed:                 BLK  1
 SmartSense_bPrescaler:                 BLK  1
 SmartSense_bScanCnt:                   BLK  1
 bFreq:
 SmartSense_bFreq:                      BLK  (SmartSense_IMMUNITY_LEVEL)

_baDAC:
  baDAC:
_SmartSense_baDAC:                     ;iDAC calibration values
 SmartSense_baDAC:                      BLK  (SmartSense_TOTALSENSORCOUNT*SmartSense_IMMUNITY_LEVEL)
IF (SmartSense_DUAL_IDAC) 
_SmartSense_baCompensationDAC:         ;iDAC calibration values
 SmartSense_baCompensationDAC:          BLK  (SmartSense_TOTALSENSORCOUNT*SmartSense_IMMUNITY_LEVEL) 
ENDIF
 SmartSense_wTmp1:                      BLK  2   ; Temporaly variable 1 
 SmartSense_wTmp2:                      BLK  2   ; Temporaly variable 2 

 TotalSensorCount: 
_TOTALSENSORCOUNT:                         BLK  1 
 bIDACComp:        
_bIDACComp:                                BLK  1
 bSensitivitySeed:
_bSensitivitySeed:                         BLK  2

AREA SmartSense_SnsRes (RAM, REL, CON)

_waSnsResult:
_SmartSense_waSnsResult:
 SmartSense_waSnsResult:                BLK  (2*SmartSense_TOTALSENSORCOUNT*SmartSense_IMMUNITY_LEVEL)

AREA SmartSense_ram4 (RAM, REL, CON)

_baPrescaler:
 baPrescaler:
_SmartSense_baPrescaler:
 SmartSense_baPrescaler:                BLK  (SmartSense_TOTALSENSORCOUNT)
 
_baN:
 baN:
_SmartSense_baN:
 SmartSense_baN:                        BLK  (SmartSense_TOTALSENSORCOUNT)  
 
_baSpeed:
 baSpeed:
_SmartSense_baSpeed:
 SmartSense_baSpeed:                    BLK  (SmartSense_TOTALSENSORCOUNT) 

_baK:
 baK:
_SmartSense_baK:
 SmartSense_baK:                        BLK  (SmartSense_TOTALSENSORCOUNT)
 
_baSensorSensitivity:
 baSensorSensitivity:
_SmartSense_baSensorSensitivity:
 SmartSense_baSensorSensitivity:        BLK  (SmartSense_TOTALSENSORCOUNT) 
 
AREA SmartSense_ram5 (RAM, REL, CON)

_baNoiseEnvelope:
 baNoiseEnvelope:
_SmartSense_baNoiseEnvelope:
 SmartSense_baNoiseEnvelope:            BLK  (SmartSense_TOTALSENSORCOUNT)  
 
_waPreviousSample:
 waPreviousSample:
_SmartSense_waPreviousSample:
 SmartSense_waPreviousSample:           BLK  (2*SmartSense_TOTALSENSORCOUNT) 
 
_baNoiseResetCounter:
 baNoiseResetCounter:
_SmartSense_baNoiseResetCounter:
 SmartSense_baNoiseResetCounter:        BLK  (SmartSense_TOTALSENSORCOUNT)
 
_baSignRegister:
 baSignRegister:
_SmartSense_baSignRegister:
 SmartSense_baSignRegister:             BLK  (SmartSense_TOTALSENSORCOUNT) 
 
_baRunningDifference:
 baRunningDifference:
_SmartSense_baRunningDifference:
 SmartSense_baRunningDifference:        BLK  (SmartSense_TOTALSENSORCOUNT)
 
_baNoiseThreshold:
 baNoiseThreshold:
_SmartSense_baNoiseThreshold:
 SmartSense_baNoiseThreshold:           BLK  (SmartSense_TOTALSENSORCOUNT) 

AREA SmartSense_ramSample (RAM, REL, CON)

_waSampleMin:
 waSampleMin:
_SmartSense_waSampleMin:
 SmartSense_waSampleMin:                BLK  (2*SmartSense_TOTALSENSORCOUNT) 

_waSampleMax:
 waSampleMax:
_SmartSense_waSampleMax:
 SmartSense_waSampleMax:                BLK  (2*SmartSense_TOTALSENSORCOUNT) 
 
AREA UserModules (ROM, REL, CON)

LSB:  equ  1
MSB:  equ  0

MMSB: equ 0
MLSB: equ 1
LMSB: equ 2
LLSB: equ 3

.LITERAL

SmartSense_PRS_CR_Table:
  db    0x98, 0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97  ;  Values for PRS_CR reg initialization

SmartSense_MUX_Table:                                  ; Analog Mux Enables Register address
  db    MUX_CR0, MUX_CR1, MUX_CR2, MUX_CR3, MUX_CR4

SmartSense_MaxADC_Table:                               ; High (2^resolution-1)
  DB    0x00, 0x01, 0x03, 0x07, 0x0F, 0x1F, 0x3F, 0x7F, 0xFF
 
 Prescaler_Table:
_Prescaler_Table:  
IF (IMO_SETTING & IMO_SET_24MHZ)                             
  DB    0,     0,     1,    1,    2,    2,    2,    2,    2,    3,    3,    3,    3,    3,    3,    3
ELSE
IF (IMO_SETTING & IMO_SET_6MHZ)  
  DB    0,     0,     0,    0,    0,    0,    0,    0,    0,    1,    1,    1,    1,    1,    1,    1
ELSE                             
  DB    0,     0,     0,    0,    1,    1,    1,    1,    1,    2,    2,    2,    2,    2,    2,    2
ENDIF
ENDIF

 Speed_Table:
_Speed_Table:                             
  DB    1,     1,     1,    1,    1,    1,    1,    1,    1,    1,    1,    2,    2,    2,    3,    3

.ENDLITERAL

IF (TOOLCHAIN & HITECH)
AREA text (ROM,REL,CON)
ELSE
AREA text (ROM,REL,CON,CODE)
ENDIF

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_Start(void)
;
;  DESCRIPTION:
;  Connects external cap; sets up comparator
;  disables all possible analog mux bus
;  connections; shunts all sensor pins to ground.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;    None
;
;  RETURNS:      None.
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_Start:
_SmartSense_Start:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   
   REG_PRESERVE MVW_PP
   REG_PRESERVE CUR_PP
   mov   reg[MVW_PP], 0
   mov   reg[CUR_PP], 0
   mov   [bSSC_TABLE_TableId], 2
   SSC_Action( TABLE_READ )                                                                            ;Retrieve iDAC offset from trim rows
   mov   A, [0xfe]
   mov   [bIDACComp], A
   REG_RESTORE CUR_PP
   REG_RESTORE MVW_PP  
   tst   [bIDACComp], 0x80
   jz    .PositiveOffset
   mov   A, 0
   and   [bIDACComp], ~0x80
   sub   A, [bIDACComp]
   mov   [bIDACComp], A
.PositiveOffset:
   add   [bIDACComp], 190 
   
   
   RAM_SETPAGE_IDX >SmartSense_baSnsOnMask
   mov   X, (SmartSense_TOTALSENSORCOUNT-1)/8
.NullingCycle:
   mov   [X + <SmartSense_baSnsOnMask], 0
   dec   X
   jnc   .NullingCycle
    
   mov   [TotalSensorCount], SmartSense_TOTALSENSORCOUNT  
   
IF (SmartSense_IMMUNITY_LEVEL / 3)                                                                 ; Immunity Level = High
   lcall SetImmunityHigh
ELSE
IF (SmartSense_IMMUNITY_LEVEL / 2)                                                                 ; Immunity Level = Medium   
   lcall SetImmunityMedium    
ENDIF
ENDIF

   mov   X,(SmartSense_TOTALSENSORCOUNT - 1)
.InitLoop:                                                                                                 ; Loop through all sensors
IF (SmartSense_DUAL_IDAC)    
   RAM_SETPAGE_IDX >SmartSense_baCompensationDAC   
   mov   [X + SmartSense_baCompensationDAC], 0
ENDIF   
   RAM_SETPAGE_IDX >SmartSense_baSnsDebounce
   mov   [X + SmartSense_baSnsDebounce], SmartSense_DEBOUNCE
   
   RAM_SETPAGE_IDX >SmartSense_baLowBaselineReset
   mov   [X + <SmartSense_baLowBaselineReset], SmartSense_LOW_BASELINE_RESET
   
IF (SmartSense_IMMUNITY_LEVEL / 3)                                                                   ; Immunity Level = High
   mov   [X + 2*SmartSense_TOTALSENSORCOUNT + <SmartSense_baLowBaselineReset], SmartSense_LOW_BASELINE_RESET
ENDIF
IF (SmartSense_IMMUNITY_LEVEL / 2)                                                                   ; Immunity Level = Medium   
   mov   [X + SmartSense_TOTALSENSORCOUNT + <SmartSense_baLowBaselineReset], SmartSense_LOW_BASELINE_RESET    
ENDIF

   
   RAM_SETPAGE_IDX >_baSensorSensitivity
   push  X 
   mov   A, X       
   mov   X, 0    ; Empty Carry flag   
   add   A, <SmartSense_Sensitivity_Level_Table                                                        ; Get string LSB address
   swap  A, X
   adc   A, >SmartSense_Sensitivity_Level_Table                                                        ; Get string MSB address   
   romx 
   pop   X   
   mov   [X + _baSensorSensitivity], A

   RAM_SETPAGE_IDX >_baPrescaler
IF (IMO_SETTING & IMO_SET_24MHZ)
   mov   [X + _baPrescaler], SmartSense_PRESCALER_16
ELSE
IF (IMO_SETTING & IMO_SET_6MHZ)
   mov   [X + _baPrescaler], SmartSense_PRESCALER_4
ELSE
   mov   [X + _baPrescaler], SmartSense_PRESCALER_8
ENDIF
ENDIF

   RAM_SETPAGE_IDX >_baN
   mov   [X + _baN], SmartSense_RESOLUTION                                                              ; Set defaut resolution 
   
   RAM_SETPAGE_IDX >_baSpeed
   mov   [X + _baSpeed],   SmartSense_ULTRA_FAST_SPEED
   
   dec   X
   jnc   .InitLoop

   mov   [SmartSense_bNegativeNoiseThreshold], 0
   mov   [SmartSense_bDebounce], SmartSense_DEBOUNCE
   
IF (SmartSense_CAPACITOR_PIN & SmartSense_CAPACITOR_P0_1)
   mov   X, 00h                                       ; connect modulator capacitor
   mov   A, 02h
   lcall SmartSense_EnableSensor
ENDIF
IF (SmartSense_CAPACITOR_PIN & SmartSense_CAPACITOR_P0_3) 
   mov   X, 00h                                       ; connect modulator capacitor
   mov   A, 08h
   lcall SmartSense_EnableSensor
ENDIF
 
   mov   reg[SmartSense_CapSense_CR0_REG], (SmartSense_CSD_MODE |SmartSense_PRCH_IMO_P)     ; Initialize CSD mode and select Prescaler clock source    
   mov   reg[SmartSense_CapSense_CR2_REG], (SmartSense_PXD_EN)                                    ; Enable precharge switching   
   or    reg[SmartSense_CapSense_CR3_REG], (SmartSense_REF_EN | SmartSense_REFMODE)         ; Set VREF to 1.2 V, Enable and connect it to bus  
   or    reg[SmartSense_CMP_CR0_REG], SmartSense_CMP0EN                                           ; Enable Comparator 0
   
   M8C_EnableIntMask    SmartSense_INT_REG, SmartSense_INT_MASK                                   ; Enable the timer's interrupt

   
IF (IMO_SETTING & IMO_SET_24MHZ)
   mov   [bSensitivitySeed + MSB], 0x8B
   mov   [bSensitivitySeed + LSB], 0xEB
ELSE
IF (IMO_SETTING & IMO_SET_6MHZ)
   mov   [bSensitivitySeed + MSB], 0x22
   mov   [bSensitivitySeed + LSB], 0xFA
ELSE
   mov   [bSensitivitySeed + MSB], 0x45
   mov   [bSensitivitySeed + LSB], 0xF5
ENDIF
ENDIF   
   
   lcall SmartSense_ClearSensors                                               ; Loop through all sensors and deactivates them

   mov   A, 0                                                                        ; First calibration
   RAM_EPILOGUE RAM_USE_CLASS_3   
   lcall SmartSense_CalibrateSensors
   
   
IF (SmartSense_SLIDERS_EXIST)
   lcall SmartSense_SetSliderIdac
ENDIF
      
   mov   A,SmartSense_TOTALSENSORCOUNT
   push  A
   lcall _TunePrescalers
   RAM_SETPAGE_CUR 0
   pop   A
   
   mov   reg[SmartSense_CapSense_CR0_REG], (SmartSense_CSD_MODE | SmartSense_PRCH_PRS)         ; Initialize CSD mode and select PRS clock source
 
   mov   A, 1                                                                        ; Calibration for immunity
   lcall SmartSense_CalibrateSensors 
   
IF (SmartSense_SLIDERS_EXIST)
   lcall SmartSense_SetSliderIdac
ENDIF
   
   mov   A,SmartSense_TOTALSENSORCOUNT
   push  A
   lcall _TuneSensitivity
   RAM_SETPAGE_CUR 0
   pop   A
   
IF (SmartSense_DUAL_IDAC)   
   or    reg[SmartSense_CapSense_TIMER_REG], SmartSense_IDAC7D_SW        ; Split the 8bit iDAC to two 7 bit iDACs

   RAM_PROLOGUE RAM_USE_CLASS_3
   mov   X, ((SmartSense_TOTALSENSORCOUNT *SmartSense_IMMUNITY_LEVEL) - 1)
.UpdateDAloop:    
   RAM_SETPAGE_IDX >SmartSense_baDAC   
   mov   A, [X+SmartSense_baDAC]
   asr   A
   mov   [X+SmartSense_baCompensationDAC], A 
   mov   [X+SmartSense_baDAC], A 
  
   dec   X
   jnc   .UpdateDAloop
   RAM_EPILOGUE RAM_USE_CLASS_3	  
ENDIF
	  
IF (SmartSense_PROXIMITYCOUNT)
   RAM_PROLOGUE RAM_USE_CLASS_3
   mov   X, SmartSense_TOTALSENSORCOUNT
   RAM_SETPAGE_IDX >_baN
.SetProximityRes:   
   dec   X
   mov   [X + _baN], SmartSense_PROXIMITY_RESOLUTION
   mov   A, X
   cmp   A, (SmartSense_TOTALSENSORCOUNT - SmartSense_PROXIMITYCOUNT)
   jnz   .SetProximityRes
   RAM_EPILOGUE RAM_USE_CLASS_3   
ENDIF

IF (SmartSense_AUTO_THRESHOLD_ENABLED)        
ELSE
   lcall SmartSense_SetDefaultFingerThreshold 
ENDIF

   lcall SmartSense_ClearSensors                      ; Loop through all sensors and deactivates them
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

AREA UserModules (ROM, REL, CON)

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_SetPrescaler
;
;  DESCRIPTION:
;  Sets the prescaler ratio and determines the precharge switch output frequency
;  INPUT:
;  A - BYTE bPrescaler  - new prescaler value. Allowed values are:
;     SmartSense_PRESCALER_1      0x00
;     SmartSense_PRESCALER_2      0x01
;     SmartSense_PRESCALER_4      0x02
;     SmartSense_PRESCALER_8      0x03
;     SmartSense_PRESCALER_16     0x04
;     SmartSense_PRESCALER_32     0x05
;     SmartSense_PRESCALER_64     0x06
;     SmartSense_PRESCALER_128    0x07
;     SmartSense_PRESCALER_256    0x08
;
;  RETURNS:      None.
;
;-----------------------------------------------------------------------------
_SmartSense_SetPrescaler:
 SmartSense_SetPrescaler:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR  0

   cmp   A, 0x09                              ; Check range
   jc    .ValueOk
   mov   A, 0x08
.ValueOk:
   mov   [SmartSense_bPrescaler], A
   index SmartSense_PRS_CR_Table

IF (SmartSense_AUTOCAL_ENABLE & SmartSense_AUTOCAL_FULL)
   cmp   [SmartSense_bResolution], 13
   jc    .PRS8
   or    A, SmartSense_PRCH_PRS12
.PRS8:
ELSE
   or    A, SmartSense_PRS_RES
ENDIF

   mov   reg[SmartSense_PRS_CR_REG], A  ; Set PRS resolution and Prescaler value
   mov   A, [SmartSense_bScanSpeed]
   mov   X, [SmartSense_bResolution]
   call  SmartSense_SetScanMode
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_SetScanMode
;
;  DESCRIPTION:
;  Sets Capsense clock and Timer value accordig to required Scan Speed and Resolution
;  INPUT:
;  A - BYTE bSpeed  - scan speed code (see  Constants for Scan Speed values)
;  X - BYTE bResolution - resolution [9..16]
;
;  RETURNS:      None.
;
;-----------------------------------------------------------------------------
_SmartSense_SetScanMode:
 SmartSense_SetScanMode:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR  0

   and   A, 0x03                                                              ; clear unused bits
   mov   [SmartSense_bScanSpeed], A

IF (SmartSense_AUTOCAL_ENABLE & SmartSense_AUTOCAL_FULL)
   mov   reg[SmartSense_CapSense_CR1_REG], SmartSense_CHAIN
ELSE

   asl   A
   asl   A
   asl   A
   asl   A
   asl   A

   or    A, SmartSense_CHAIN                                            ; Set Chain bit
   mov   reg[SmartSense_CapSense_CR1_REG], A                            ; Set ClkSel bits according to selected ScanSpeed
ENDIF

   mov   A, X                                                                 ; A := Resolution
   dec   A
   and   A, 0x0F                                                              ; clear unused bits
   or    A, 0x08                                                              ; be sure the rsolution is in 9..16 range
   inc   A
   mov   [SmartSense_bResolution], A

   sub   A, [SmartSense_bPrescaler]
   add   A, [SmartSense_bScanSpeed]

.L0:
   mov   X, A
   mov   A, 0
   mov   [SmartSense_bBitMask], A
   mov   [SmartSense_bScanCnt], A
.L1:
   or    A, 1
   dec   X
   jz    .L2
   asl   A
   rlc   [SmartSense_bBitMask]
   rlc   [SmartSense_bScanCnt]
   jmp   .L1

.L2:
   mov   reg[SmartSense_DATA0_REG], A
   mov   A, [SmartSense_bBitMask]
   mov   reg[SmartSense_DATA1_REG], A

   RAM_EPILOGUE RAM_USE_CLASS_4
   ret

.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_CopyIdacValue
;
;  DESCRIPTION: Updates bIdacValue value
;
;  INPUT:
;  A  => Sensor Index
;
;  RETURNS:      None.
;  SIDE EFFECTS:
;
;-----------------------------------------------------------------------------
CopyIdacValue:
_SmartSense_CopyIdacValue:
 SmartSense_CopyIdacValue:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR  0
   RAM_SETPAGE_IDX >SmartSense_baDAC
   mov   X, A
   mov   A, [X+SmartSense_baDAC]
   mov   [SmartSense_bIdacValue], A  
IF (SmartSense_DUAL_IDAC)   
   mov   A, [X+SmartSense_baCompensationDAC]
   mov   [SmartSense_bCompensationIdacValue], A  
ENDIF   
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_CopywADCResultToBaseline
;
;  DESCRIPTION: Updates Baseline value
;
;  INPUT:
;  A  => Sensor Index
;
;  RETURNS:      None.
;  SIDE EFFECTS:
;
;-----------------------------------------------------------------------------
CopywADCResultToBaseline:
_SmartSense_CopywADCResultToBaseline:
 SmartSense_CopywADCResultToBaseline:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR  0
   RAM_SETPAGE_IDX >SmartSense_waSnsBaseline

   asl   A                                                 ; Set Int Offset  
   mov   X, A
   mov   A, [SmartSense_wADC_Result + LMSB]
   mov   [X + SmartSense_waSnsBaseline + LSB], A

   mov   A, [SmartSense_wADC_Result + MLSB]
   mov   [X + SmartSense_waSnsBaseline + MSB], A   
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_ClearSensors(void)
;
;  DESCRIPTION:
;    Clears all sensor connections to the analog mux bus and shunts all sensor
;    pins to ground.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_ClearSensors:
_SmartSense_ClearSensors:
   RAM_PROLOGUE RAM_USE_CLASS_4
   mov   A, (SmartSense_TOTALSENSORCOUNT-1)
.InitLoop:                                              ; Loop through all sensors and deactivate
   push  A
   call  SmartSense_wGetPortPin
   call  SmartSense_DisableSensor
   pop   A
   dec   A
   jnc   .InitLoop
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_Stop(void)
;
;  DESCRIPTION:
;
;  Disables the CapSense interrupt, disconnects the external capacitor, disables
;  internal capacitor, disbales precharge switching, disconnects IDAC, disconnects VRef buffer
;  disables PRS
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      Nothing.
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_Stop:
_SmartSense_Stop:
    RAM_PROLOGUE RAM_USE_CLASS_1
    M8C_DisableIntMask    SmartSense_INT_REG, SmartSense_INT_MASK                              ; Disable the CapSense Timer interrupt
    M8C_SetBank1
IF (SmartSense_CAPACITOR_PIN & SmartSense_CAPACITOR_P0_1)
   and   reg[SmartSense_MUX_CR0_REG], ~02h                                                           ;Disconnect external capacitor
ENDIF
IF (SmartSense_CAPACITOR_PIN & SmartSense_CAPACITOR_P0_3)
   and   reg[SmartSense_MUX_CR0_REG], ~08h                                                           ;Disconnect external capacitor
ENDIF
   M8C_SetBank0
   and   reg[SmartSense_CapSense_CR2_REG], ~(SmartSense_PXD_EN)                                ; Disable precharge switching and disconnect IDAC
   and   reg[SmartSense_CapSense_CR3_REG], ~(SmartSense_REF_EN | SmartSense_REFMODE )    ; Power down and disconnect VRef Buffer
   mov   reg[SmartSense_PRS_CR_REG], 0   ; Disable PRS

   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_Resume(void)
;
;  DESCRIPTION:
;
;  Resumes the user module operation after SmartSense_Stop call. 
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      Nothing.
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_Resume:
_SmartSense_Resume:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   or   reg[SmartSense_CapSense_CR3_REG], (SmartSense_REF_EN | SmartSense_REFMODE )          ; Power up VRef Buffer
   mov   A, [SmartSense_bPrescaler]
   index SmartSense_PRS_CR_Table
   or    A, SmartSense_PRS_RES
   mov   reg[SmartSense_PRS_CR_REG], A                                                                   ; Set PRS resolution and Prescaler value

IF (SmartSense_CAPACITOR_PIN & SmartSense_CAPACITOR_P0_1)
   mov   X, 00h                                                                                                ; connect modulator capacitor
   mov   A, 02h
   call  SmartSense_EnableSensor
ENDIF
IF (SmartSense_CAPACITOR_PIN & SmartSense_CAPACITOR_P0_3)
   mov   X, 00h                                                                                                ; connect modulator capacitor
   mov   A, 08h
   call  SmartSense_EnableSensor
ENDIF

   or    reg[SmartSense_CapSense_CR2_REG], SmartSense_PXD_EN                                        ; Enable precharge switching and reconnect iDAC

   M8C_EnableIntMask    SmartSense_INT_REG, SmartSense_INT_MASK                                     ; Enable the CapSense Timer interrupt
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

IF (1h)
.LITERAL
ENDIF
 SmartSense_Sensor_Table2:
_SmartSense_Sensor_Table2:
	dw	0x0104	// Port 1 Bit 2

IF (1h)
.ENDLITERAL
ENDIF

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_wGetPortPin(BYTE bSensor)
;
;  DESCRIPTION:
;      Returns the port and pin mask from a given key number.  This function
;      uses the table SmartSense_Sensor_Table to retreive this
;      information.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;        A => Sensor Number  ( 0 to n )
;  RETURNS:
;        A  <=  Sensor Bitmap
;        X  <=  Port Number
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_wGetPortPin:
_SmartSense_wGetPortPin:
   RAM_PROLOGUE RAM_USE_CLASS_1
   asl   A                                       ; multiply key by 2 since table is 2 bytes per key
   mov   X,A                                     ; Copy index*2 in x for next value
   index SmartSense_Sensor_Table2                ; A contains the port value
   swap  A,X                                     ; Place port value in X and index*2 in A
   inc   A                                       ; Advance to next value (bitMask)
   index SmartSense_Sensor_Table2                ; A contains bitMask, X has port number

   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_EnableSensor(BYTE bSensorMask, BYTE bPort)
;
;  DESCRIPTION:
;    Configures sensor to be an input to be measured during next measurement
;    cycle; places sensor pin's drive mode in Analog Hi-Z mode and connects
;    to the analog mux bus.
;
;    This function does not do anything with the previous sensor.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;          X =>  Port Number for given sensor
;          A =>  Bit mask for given sensor
;
;  RETURNS:      none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_EnableSensor:
_SmartSense_EnableSensor:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   ; Setup Mux for sensor
   mov   [SmartSense_bBitMask],A                           ; Store bit mask in temp location
   push  X

   mov   A,X                                               ; Multiply port number by four for registor addresses
   asl   A
   asl   A
   mov   X,A                                               ; Restore Port address in X

   ; Set mode do 10 (Hi-Z Analog) and connect to analog mux bus
   M8C_SetBank1
   mov   A, reg[X+DM1_OFFSET]                              ; Set DM1 to 1
   or    A, [SmartSense_bBitMask]
   mov   reg[X+DM1_OFFSET], A
   xor   [SmartSense_bBitMask],FFh                         ; Invert bitmask
   mov   A, reg[X+DM0_OFFSET]                              ; Clear DM0 bit to 0
   and   A, [SmartSense_bBitMask]
   mov   reg[X+DM0_OFFSET], A
   xor   [SmartSense_bBitMask],FFh                         ; Invert bitmask to get original mask
   pop   A

   index SmartSense_MUX_Table
   mov   X, A
   mov   A, reg[X]
   or    A, [SmartSense_bBitMask]
   mov   reg[X], A
   M8C_SetBank0

   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_DisableSensor(BYTE bMask, BYTE bPort)
;
;  DESCRIPTION:
;    Disconnects the desired sensor from the analog mux bus and shunts to
;    ground.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;          X =>  Port Number for given sensor
;          A =>  Bit mask for given sensor
;
;  RETURNS:      none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_DisableSensor:
_SmartSense_DisableSensor:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   ; Disconnect sensor from mux
   push  X                                       ; Store Port Number
   cpl   A                                       ; Invert bitmask
   mov   [SmartSense_bBitMask], A                ; Store bit mask in temp location
   M8C_SetBank1
   mov   A, X
   index  SmartSense_MUX_Table
   mov   X, A
   mov   A, reg[X]
   and   A, [SmartSense_bBitMask]
   mov   reg[X], A
   M8C_SetBank0

   pop   A                                       ; restore Port Number
   asl   A
   asl   A
   mov   X, A                                    ; Restore Port address in X

   ; Set mode to 01 (Digital Strong)
   M8C_SetBank1
   mov   A, reg[X+DM1_OFFSET]                    ; Set DM1 to 0
   and   A, [SmartSense_bBitMask]
   mov   reg[X+DM1_OFFSET], A
   xor   [SmartSense_bBitMask], FFh              ; Invert bitmask back to normal
   mov   A, reg[X+DM0_OFFSET]                    ; Set DM0 bit to 1
   or    A, [SmartSense_bBitMask]
   mov   reg[X+DM0_OFFSET], A
   M8C_SetBank0

   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;----------------------------INTERNAL FUNCTION-------------------------
;  FUNCTION NAME: SmartSense_ScanSingleSensor(void)
;
;  DESCRIPTION:
;  Uses the CapSense switching circuitry to charge to the starting voltage.
;  Then a fixed slope ramp is used to measure the starting voltage with a
;  16 bit timer.
;
;---------------------------------------------------------------------------------------
;
;  ARGUMENTS:
;      None
;
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
ScanSingleSensor:
 SmartSense_ScanSingleSensor:
_SmartSense_ScanSingleSensor:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

IF (SmartSense_AUTOCAL_ENABLE & SmartSense_AUTOCAL_FULL)
   mov   X, [SmartSense_bSensorNum]
   RAM_SETPAGE_IDX >_baSpeed
   mov   A, [X + _baSpeed]
   mov   [SmartSense_bScanSpeed], A
   RAM_SETPAGE_IDX >_baN
   mov   A, [X + _baN]
   mov   [SmartSense_bResolution], A
   RAM_SETPAGE_IDX >_baPrescaler
   mov   A, [X + _baPrescaler]
   call  SmartSense_SetPrescaler
ENDIF

   mov   A, 0
   mov   [SmartSense_wADC_Result+MMSB], A
   mov   [SmartSense_wADC_Result+MLSB], A
   mov   [SmartSense_wADC_Result+LMSB], A
  
  or    reg[SmartSense_CapSense_CR0_REG], (SmartSense_CSD_EN)       ; Start capsense block   
  
   mov   A, [SmartSense_bIdacValue]
   mov   reg[SmartSense_IDAC_REG], A                                     ; Turn on iDAC
IF (SmartSense_DUAL_IDAC)     
   mov   A, [SmartSense_bCompensationIdacValue]   
   mov   reg[SmartSense_IDAC0_REG], A                                    ; Turn on Comp iDAC
ENDIF   
   and   reg[SmartSense_CapSense_CR3_REG], ~SmartSense_REFMODE     ; Disconnect VRef from AMUX bus
   mov   A, [SmartSense_bSensorNum]                                      ; Connect sensor to AMUX bus
   call  SmartSense_wGetPortPin
   call  SmartSense_EnableSensor
   
   mov   X, [SmartSense_bScanCnt]                                        ; Slow and/or high resolution scan modes require several scans

   mov   A, SmartSense_SETTLING_DELAY                                    ; Delay for AMUX bus voltage settling
.SettlingLoop:
   dec   A
   jnc   .SettlingLoop
 
;@PSoC_UserCode_ClearWDT@ (Do not change this line.) 
   M8C_ClearWDT
; You can comment the line above if Watchdog is not used. 
;@PSoC_UserCode_END@ (Do not change this line.)
 
.L0:
    mov  A, 0
    mov  [SmartSense_bADCStatus], A
    mov  reg[SmartSense_CapSense_CNTH_REG], A
    mov  reg[SmartSense_CapSense_CNTL_REG], A
    or   reg[SmartSense_CONFIG_REG], 0x01                                ; Start timer - enable measurement
.L1:
    mov  A, [SmartSense_bADCStatus]
    jz   .L1                                                                   ;  Wait for timer's interrupt

    dec  X
    jnc  .L0                                                                   ; Loop back to repeat scan if needed for slow and/or high resolution scan modes

    mov  A, [SmartSense_bSensorNum]                                      ; Disconnect sensor from AMUX bus
    call SmartSense_wGetPortPin
    call SmartSense_DisableSensor
    or   reg[SmartSense_CapSense_CR3_REG], SmartSense_REFMODE      ;  Connect VRef to AMUX bus
	
    and  reg[SmartSense_CapSense_CR0_REG], ~(SmartSense_CSD_EN)    ;  Stop capsense block
	
    mov  reg[SmartSense_IDAC_REG], 0                                     ;  Disable iDAC
IF (SmartSense_DUAL_IDAC) 	
    mov  reg[SmartSense_IDAC0_REG], 0                                    ;  Disable Comp iDAC
ENDIF  
IF (SmartSense_AUTOCAL_ENABLE & SmartSense_AUTOCAL_FULL)
   and   reg[SmartSense_PRS_CR_REG], ~0x10

   mov   X, [SmartSense_bScanSpeed]
.ShiftResult:
   dec   X
   jc    .Normalize
   and   F, ~0x04
   rrc   [SmartSense_wADC_Result+MMSB]
   rrc   [SmartSense_wADC_Result+MLSB]
   rrc   [SmartSense_wADC_Result+LMSB]
   jmp   .ShiftResult
   
.Normalize:
ENDIF
   mov   A, 0xFF                                                               ; Result normalization - on touch raw count shall increase
   swap  A, [SmartSense_wADC_Result+LMSB]
   sub   [SmartSense_wADC_Result+LMSB], A
   mov   A, [SmartSense_bResolution]
   sub   A, 8
   index SmartSense_MaxADC_Table
   swap  A, [SmartSense_wADC_Result+MLSB]
   sbb   [SmartSense_wADC_Result+MLSB], A
   jnc   .Cont
   mov   A, 0
   mov   [SmartSense_wADC_Result+MMSB], A
   mov   [SmartSense_wADC_Result+MLSB], A
   mov   [SmartSense_wADC_Result+LMSB], A
.Cont:  
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret

.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_ScanSensor(BYTE bSensorNum)
;
;  DESCRIPTION:
;  Uses the CapSense switching circuitry to charge to the starting voltage.
;  Then a fixed slope ramp is used to measure the starting voltage with a
;  16 bit timer.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;      A  => Sensor Index
;
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_ScanSensor:
_SmartSense_ScanSensor:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   
   mov   [SmartSense_bSensorNum], A
   
   lcall SmartSense_CopyIdacValue 
  
   lcall SmartSense_ScanSingleSensor
   
   mov   A, [SmartSense_bSensorNum]                   ; Get sensor index      
   lcall SmartSense_ProcessData 
      
IF (SmartSense_IMMUNITY_LEVEL / 3)                    ; Immunity Level = High
   lcall ProcessDataHigh
   lcall RestoreNormalScan 
ELSE
IF (SmartSense_IMMUNITY_LEVEL / 2)                    ; Immunity Level = Medium
   lcall ProcessDataMedium 
   lcall RestoreNormalScan   
ELSE                                                  ; Immunity Level = Low 
 
ENDIF
ENDIF

   RAM_EPILOGUE RAM_USE_CLASS_3
   ret

.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_ScanAllSensors(void)
;
;  DESCRIPTION:
;    Scans all sensors to find their raw count values
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_ScanAllSensors:
_SmartSense_ScanAllSensors:
   RAM_PROLOGUE RAM_USE_CLASS_4
   mov   A, (SmartSense_TOTALSENSORCOUNT-1)           ; Check if key value in range.
.ScanLoop:                                                 ; Loop through all sensors and scan
   push  A   
   call  SmartSense_ScanSensor
   pop   A
   dec   A
   jnc   .ScanLoop
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_wReadSensor(BYTE bSensor)
;
;  DESCRIPTION:
;     Returns the sensor scan value in A (LSB) and X (MSB)
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;    A = Sensor number
;  RETURNS:
;    Scan value of sensor LSB in A and MSB in X
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to preserve their values across calls to fastcall16
;    functions.
;
 SmartSense_wReadSensor:
_SmartSense_wReadSensor:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_IDX >SmartSense_waSnsResult
   asl   A                                            ; Multiply by two since results are INTs
   mov   X, A
   mov   A, [X + (SmartSense_waSnsResult+LSB)]
   mov   X, [X + (SmartSense_waSnsResult+MSB)]
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_SingleTimeCalibrateSensors(wLevel)
;
;  DESCRIPTION:
;   Adjusts iDAC current to obtain raw count near wLevel value.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    A - wLevel (LSB)
;                X - wLevel (MSB)
;  RETURNS:      None. Calibration setting are stored in the global array SmartSense_baDAC[]
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 
 SingleTimeCalibrateSensors:
_SingleTimeCalibrateSensors:
 SmartSense_SingleTimeCalibrateSensors:
_SmartSense_SingleTimeCalibrateSensors:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0
   RAM_SETPAGE_IDX >SmartSense_baDAC  
   mov   [X+SmartSense_baDAC], 80h
   mov   [SmartSense_wTmp2+LSB], 8
   mov   [SmartSense_wTmp2+MSB], 80h
.L0:
   push  X
   mov   A, [X+SmartSense_baDAC]
   mov   [SmartSense_bIdacValue], A
   RAM_EPILOGUE RAM_USE_CLASS_3   
   lcall SmartSense_ScanSingleSensor
   pop   X
   RAM_PROLOGUE RAM_USE_CLASS_3                      ; Restore paging mode after function call

   RAM_SETPAGE_IDX >SmartSense_baDAC
   mov   A, [SmartSense_wADC_Result+LMSB]
   cmp   A, [SmartSense_wTmp1 + LSB]
   mov   A, [SmartSense_wADC_Result+MLSB]
   sbb   A, [SmartSense_wTmp1 + MSB]             ; if wADC_Result <= wLevel
   jnc   .L1
   mov   A, [SmartSense_wTmp2+MSB]               ; below the target, clear the bit
   cpl   A
   and   [X+SmartSense_baDAC], A
.L1:
   asr   [SmartSense_wTmp2+MSB]                  ; above the target, keep the bit
   and   [SmartSense_wTmp2+MSB], ~80h
   mov   A, [SmartSense_wTmp2+MSB]
   or    [X+SmartSense_baDAC], A
   dec   [SmartSense_wTmp2+LSB]
   jnz   .L0

   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_CalibrateSensors(bILevel)
;
;  DESCRIPTION:
;   Adjusts iDAC current to obtain raw count near 85% of 12-bit scan.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    Immunity Level -> A
;                
;  RETURNS:      None. Calibration setting are stored in the global array SmartSense_baDAC[]
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 
 CalibrateSensors:
_CalibrateSensors:
 SmartSense_CalibrateSensors:
_SmartSense_CalibrateSensors:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0
   
   mov   [SmartSense_wTmp1 + LSB], 0x99
   mov   [SmartSense_wTmp1 + MSB], 0x0D

   mov   [SmartSense_bSensorNum], SmartSense_TOTALSENSORCOUNT-1  
  
.ScanLoop:                                                        ; Loop through all sensors and scan
   mov   X, [SmartSense_bSensorNum]
   push  A 
   call  SmartSense_SingleTimeCalibrateSensors
   
   pop   A
   jz    .SkipImmunity
   
IF (SmartSense_IMMUNITY_LEVEL / 3)                          ; Immunity Level = High  
   lcall ConfigureMedium
   mov   A, X                                         
   add   A, SmartSense_TOTALSENSORCOUNT        
   mov   X, A      
   call  SmartSense_SingleTimeCalibrateSensors
   lcall ConfigureHigh
   mov   A, X                                         
   add   A, SmartSense_TOTALSENSORCOUNT        
   mov   X, A    
   call  SmartSense_SingleTimeCalibrateSensors   
   lcall RestoreNormalScan   
ELSE
IF (SmartSense_IMMUNITY_LEVEL / 2)                          ; Immunity Level = Medium   
   lcall ConfigureMedium 
   mov   A, X                                         
   add   A, SmartSense_TOTALSENSORCOUNT        
   mov   X, A 
   call  SmartSense_SingleTimeCalibrateSensors
   lcall RestoreNormalScan   
ENDIF
ENDIF      
.SkipImmunity:

   dec   [SmartSense_bSensorNum]
   jnc   .ScanLoop

   
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION


IF(SmartSense_SLIDERS_EXIST)

.LITERAL
 SmartSense_Group_Table2:
 ; Group Table:
;    Origin    Count    Diplex?    DivBtwSw(wholeMSB, wholeLSB, fractByte)
 db   0x0,      0x01,	 0x00,	 0x00,	 0x00,	 0x00 ; Buttons

.ENDLITERAL

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_SetSliderIdac(void)
;
;  DESCRIPTION:
;   Sets iDAC current for slider elements to the highest for each slider group.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None.
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_SetSliderIdac:
_SmartSense_SetSliderIdac:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   RAM_SETPAGE_IDX >SmartSense_baDAC

   mov   A, SmartSense_SLIDERCOUNT

.StartSliderAdjustment:
   push  A                                           ;Store Slider Count Index
   asl   A
   mov   [SmartSense_wTmp1+MSB], A
   asl   A
   add   A, [SmartSense_wTmp1+MSB]               ;A contains Slider Count multiplied by 6
   mov   X, A
   index SmartSense_Group_Table2                 ;Get the Slider Start Position
   mov   [SmartSense_wTmp2+LSB], A               ;[SmartSense_wTmp2+LSB] contains the start of this slider group
   mov   [SmartSense_wTmp2+MSB], A
   mov   A, X
   inc   A                                           ;Increment to get the slider size
   index SmartSense_Group_Table2
   add   [SmartSense_wTmp2+MSB], A               ;[SmartSense_wTmp2+MSB] contains the end of this slider group
   
   call SmartSense_UpdateSingleSliderIdac
 
IF (SmartSense_IMMUNITY_LEVEL / 2)                    ; Immunity Level = Medium
   mov  A, SmartSense_TOTALSENSORCOUNT 
   add  [SmartSense_wTmp2+LSB], A
   add  [SmartSense_wTmp2+MSB], A   
   call SmartSense_UpdateSingleSliderIdac   
ENDIF 
IF (SmartSense_IMMUNITY_LEVEL / 3)                    ; Immunity Level = High
   mov  A, SmartSense_TOTALSENSORCOUNT 
   add  [SmartSense_wTmp2+LSB], A
   add  [SmartSense_wTmp2+MSB], A   
   call SmartSense_UpdateSingleSliderIdac    
ENDIF
   
.EndSliderSdjustment:
   pop   A                                            ;Get the Slider Count Index
   dec   A
   jnz   .StartSliderAdjustment

   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_UpdateSingleSliderIdac(void)
;
;  DESCRIPTION:
;   Sets iDAC current for one slider.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None.
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_UpdateSingleSliderIdac:
_SmartSense_UpdateSingleSliderIdac:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   RAM_SETPAGE_IDX >SmartSense_baDAC
   
   mov   [SmartSense_bCurPos], 0                 ;[SmartSense_bCurPos] used as temp to store max iDAC setting found.  Clear variable.   
   mov   A, [SmartSense_wTmp2+MSB]               ;[SmartSense_wTmp2+MSB] contains the end of this slider group
.StartIDACSearch:
   push  A
   dec   A
   mov   X, A
   mov   A, [X+SmartSense_baDAC]
   cmp   A, [SmartSense_bCurPos]                 ;Is [SmartSense_baDAC+X] < [SmartSense_bCurPos]
   jc    .NoStore
   mov   [SmartSense_bCurPos], A                 ;Store current iDAC as highest
.NoStore:
   pop   A
   dec   A
   cmp   A, [SmartSense_wTmp2+LSB]
   jnz   .StartIDACSearch

   mov   A, [SmartSense_wTmp2+MSB]               ;[SmartSense_wTmp2+MSB] contains the end of this slider group
.StartSetIDAC:
   push  A
   dec   A
   mov   X, A
   mov   A, [SmartSense_bCurPos]                 ;Set all iDAC settings to highest.
   mov   [X+SmartSense_baDAC], A
   pop   A
   dec   A
   cmp   A, [SmartSense_wTmp2+LSB]
   jnz   .StartSetIDAC
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

ENDIF
