;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME:   SmartSense.inc
;;   Version: 1.00, Updated on 2011/12/15 at 17:29:43
;;  Generated by PSoC Designer 5.3.2710
;;
;;  DESCRIPTION:
;;    Assembler declarations for the SmartSense_EMCplus user module interface.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2011. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************
include "GlobalParams.inc"

SmartSense_CAPACITOR_PIN:              equ 2h
SmartSense_CAPACITOR_NONE:             equ 0h
SmartSense_CAPACITOR_P0_1:             equ 1h
SmartSense_CAPACITOR_P0_3:             equ 2h

SmartSense_AUTORESET:                  equ 0h

SmartSense_AUTOCAL_ENABLE:             equ 2h
SmartSense_AUTOCAL_NONE:               equ 0h
SmartSense_AUTOCAL_AUTORANGE:          equ 1h
SmartSense_AUTOCAL_FULL:               equ 2h
SmartSense_AUTO_THRESHOLD_ENABLED:     equ 01h

SmartSense_IMMUNITY_LEVEL:             equ 1h
SmartSense_DUAL_IDAC:                  equ 1

; delay constant for 9 cycles, generated by .JS file
SmartSense_SETTLING_DELAY:             equ 50h  ; 30uS delay

;--------------------------------------------------
; Constants for Scan Speed values
;--------------------------------------------------
SmartSense_SCANNING_SPEED:             equ 2h
SmartSense_ULTRA_FAST_SPEED:           equ 00h
SmartSense_FAST_SPEED:                 equ 01h
SmartSense_NORMAL_SPEED:               equ 02h
SmartSense_SLOW_SPEED:                 equ 03h

;--------------------------------------------------
; Constants for Prescaler values
;--------------------------------------------------
SmartSense_PRESCALER:                  equ 1h
SmartSense_PRESCALER_1:                equ 00h
SmartSense_PRESCALER_2:                equ 01h
SmartSense_PRESCALER_4:                equ 02h
SmartSense_PRESCALER_8:                equ 03h
SmartSense_PRESCALER_16:               equ 04h
SmartSense_PRESCALER_32:               equ 05h
SmartSense_PRESCALER_64:               equ 06h
SmartSense_PRESCALER_128:              equ 07h
SmartSense_PRESCALER_256:              equ 08h

;--------------------------------------------------
; Constants for Resolution values
;--------------------------------------------------
SmartSense_RESOLUTION:                 equ ch
SmartSense_PROXIMITY_RESOLUTION:       equ 16

;--------------------------------------------------
; Constants for Precharge clock source values
;--------------------------------------------------
SmartSense_PRCH_SRC:                   equ 20h
SmartSense_PRCH_IMO_P:                 equ 0h
SmartSense_PRCH_PRS:                   equ 20h

;--------------------------------------------------
; Constants for PRS values
;--------------------------------------------------
SmartSense_PRS_RES:                    equ 0h
SmartSense_PRCH_PRS8:                  equ 0h
SmartSense_PRCH_PRS12:                 equ 20h

;--------------------------------------------------
; Constants for parameterts
;--------------------------------------------------
SmartSense_LOW_BASELINE_RESET:         equ 30

;--------------------------------------------------
; Flag Constants  
;--------------------------------------------------
SmartSense_ADC_STATUS:                 equ 01h
SmartSense_CALIBRATION_FLAG:           equ 02h

;--------------------------------------------------
; Constants for SmartSense API's
;--------------------------------------------------

SmartSense_BUTTONCOUNT:                equ 1h
SmartSense_SLIDERCOUNT:                equ 0h  + 0h
SmartSense_PROXIMITYCOUNT:             equ 0h
IF 1h
SmartSense_TOTALSENSORCOUNT:           equ 1h
ELSE
SmartSense_TOTALSENSORCOUNT:           equ 1
ENDIF 

SmartSense_BUTTONS_EXIST:              equ 1h
SmartSense_SLIDERS_EXIST:              equ 0h | 0h
SmartSense_LIN_SLIDERS_EXIST:          equ 0h 
SmartSense_ROT_SLIDERS_EXIST:          equ 0h

SmartSense_DEBOUNCE:                   equ 3h
SmartSense_DIPLEXUSED:                 equ 0

SmartSense_IDAC:                       equ 14h
SmartSense_PRESCALER:                  equ 1h

SmartSense_INT_REG:                    equ 0x0df
SmartSense_INT_MASK:                   equ 0x01

;--------------------------------------------------
; SmartSense Registers values
;--------------------------------------------------
; bank 0

; AMUXCFG  Analog Mux Configuration Register masks
SmartSense_INTCAP_P0_1:                equ 01h  ; P0[1] pin enabled in the charge integration mode.
SmartSense_INTCAP_P0_3:                equ 02h  ; P0[3] pin enabled in the charge integration mode.

; CS_CR0 CapSense Control Register 0 masks
SmartSense_CSD_MODE:                   equ 08h  ;  Enable CSD mode. When this bit is set to 1, Programmable Timer1 works on IMO-P.
SmartSense_CSD_EN:                     equ 01h  ;  Counters are enabled for counting.

; CS_CR1 CapSenseTrueTouch Control Register 1 masks
SmartSense_CHAIN:                      equ 80h  ;  High/low counters operate as a 16-bit synchronous block..


; CS_CR2 CapSense Control Register 2 masks
SmartSense_IRANGE_10:                  equ 80h  ;  IDAC output scaled to 4X range.
SmartSense_PXD_EN:                     equ 04h  ;  Enabled pins switch between ground and the analog global bus.

; CS_CR3 CapSense Control Register 3 masks
SmartSense_REF_EN:                     equ 10h  ;  Reference buffer is enabled.
SmartSense_REFMODE:                    equ 20h  ;  Reference buffer connected to the analog global bus.
SmartSense_REFMUX:                     equ 40h  ;  Select VREF (1.0V).

; CMP_CR0 Comparator Control Register 0 masks
SmartSense_CMP0EN:                     equ 01h  ;  Comparator 0 enabled.

; CS_TIMER CS_TIMER Register masks
SmartSense_IDAC7D_SW:                  equ 80h  ; Enable Dual IDAC mode (Two 7-bit DAC mode)

; bank 1

;; Definitions below are for consistency with old CapSense UMs
;; Not Recommended for using in new designs 
SmartSense_DiplexUsed:                 equ 0
SmartSense_ButtonCount:                equ 1h
SmartSense_SliderCount:                equ 0h  + 0h
SmartSense_TotalSensorCount:           equ 1h  
SmartSense_Debounce:                   equ 3h
;; End of old definitions

;--------------------------------------------------
; Registers Address Constants for SmartSense
;--------------------------------------------------

SmartSense_CapSense_CR0_REG:                     equ a0h              ; CS_CR0 Reg
SmartSense_CapSense_CR1_REG:                     equ a1h              ; CS_CR1 Reg
SmartSense_CapSense_CR2_REG:                     equ a2h              ; CS_CR2 Reg
SmartSense_CapSense_CR3_REG:                     equ a3h              ; CS_CR3 Reg
SmartSense_CapSense_CNTH_REG:                    equ a5h              ; CS_Counter Reg
SmartSense_CapSense_CNTL_REG:                    equ a4h              ; CS_Countert Reg
SmartSense_CapSense_STAT_REG:                    equ a6h              ; CS_Stat Reg
SmartSense_CapSense_TIMER_REG:                   equ a7h              ; CS_Timer Reg
SmartSense_CONFIG_REG:                           equ b3h              ; Timer Control register
SmartSense_DATA1_REG:                            equ b4h              ; Timer Data Hi Reg
SmartSense_DATA0_REG:                            equ b5h              ; Timer Data Lo Reg
SmartSense_CMP_CR0_REG:                          equ 7ah              ; CMP_CR0 Reg
SmartSense_CMP_CR1_REG:                          equ 7bh              ; CMP_CR1 Reg
SmartSense_CMP_MUX_REG:                          equ 79h              ; CMP_MUX Reg
SmartSense_PRS_CR_REG:                           equ a9h              ; PRS_CR Reg
SmartSense_IDAC_REG:                             equ fdh              ; Current DAC Data Register
SmartSense_IDAC0_REG:                            equ 31h              ; Current DAC Data Register
SmartSense_AMUX_CFG_REG:                         equ 61h              ; Analog Mux Configuration Register
SmartSense_MUX_CR0_REG:                          equ d8h              ; Analog Mux Port 0 Bit Enable Register
SmartSense_MUX_CR1_REG:                          equ d9h              ; Analog Mux Port 1 Bit Enable Register
SmartSense_MUX_CR2_REG:                          equ dah              ; Analog Mux Port 2 Bit Enable Register
SmartSense_MUX_CR3_REG:                          equ dbh              ; Analog Mux Port 3 Bit Enable Register
SmartSense_MUX_CR4_REG:                          equ dfh              ; Analog Mux Port 4 Bit Enable Register
DR_OFFSET:                                       equ 00h
DM0_OFFSET:                                      equ 00h              ; Bank 1
DM1_OFFSET:                                      equ 01h              ; Bank 1


; end of file SmartSense.inc
