//----------------------------------------------------------------------------
// C main line
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules

struct I2C_Regs
{
WORD wSensorRawCount;
WORD wSensorBaseline; 	
WORD wSensorDiffCount;
}
MyI2C_Regs;

void main(void)
{
 M8C_EnableGInt;      // Turn ON global interrupts
 
 //Set up RAM buffer
 EzI2Cs_SetRamBuffer(sizeof(MyI2C_Regs), 0, (BYTE *)&MyI2C_Regs);
 EzI2Cs_Start(); //Turn ON I2C
 
 SmartSense_Start(); //Start SmartSense user module.
 SmartSense_InitializeBaselines(); //Initialize BaseLines for all the Sensors.

	while (1) 
	{ 
		SmartSense_ScanAllSensors(); //Scan all the Capacitive sensors
		SmartSense_UpdateAllBaselines(); //Update the baselines of all sensors
		SmartSense_bIsAnySensorActive(); // Detect if any sensor is pressed
		
		EzI2Cs_DisableInt(); //Disable I2C interrupt while the buffer is being updated		
		if(!(EzI2Cs_bBusy_Flag == EzI2Cs_I2C_BUSY_RAM_READ))
		{			 
		MyI2C_Regs.wSensorRawCount = SmartSense_waSnsResult[0]; // Storing Sensor RawCounts
		MyI2C_Regs.wSensorBaseline = SmartSense_waSnsBaseline[0]; // Storing Sensor Baseline
		MyI2C_Regs.wSensorDiffCount = SmartSense_waSnsDiff[0]; // Storing Sensor DiffCounts
		}
		EzI2Cs_ResumeInt(); //Re-enable the I2C interrupt
		
		if (SmartSense_bIsAnySensorActive()) // turn ON the LED if button is active
		{
		PRT1DR |= 0x08;
		}
		else
		{
		PRT1DR &= ~0x08;
		}
	
	}
		
}