;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: CSDPLUS.asm
;;  Version: 1.10, Updated on 2012/9/21 at 11:58:32
;;  Generated by PSoC Designer 5.3.2710
;;
;;  DESCRIPTION: CSDPLUS User Module software implementation file.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "GlobalParams.inc"
include "CSDPLUS.inc"

;-----------------------------------------------
;  Global Labels
;-----------------------------------------------

; Exported functions
export _CSDPLUS_Start
export  CSDPLUS_Start
export _CSDPLUS_Stop
export  CSDPLUS_Stop
export _CSDPLUS_Resume
export  CSDPLUS_Resume
export _CSDPLUS_SetScanMode
export  CSDPLUS_SetScanMode
export _CSDPLUS_ClearSensors
export  CSDPLUS_ClearSensors
export _CSDPLUS_wReadSensor
export  CSDPLUS_wReadSensor
export _CSDPLUS_wGetPortPin
export  CSDPLUS_wGetPortPin
export _CSDPLUS_EnableSensor
export  CSDPLUS_EnableSensor
export _CSDPLUS_DisableSensor
export  CSDPLUS_DisableSensor
export _CSDPLUS_ScanSensor
export  CSDPLUS_ScanSensor
export _CSDPLUS_ScanAllSensors
export  CSDPLUS_ScanAllSensors
export _CSDPLUS_SetIdacValue
export  CSDPLUS_SetIdacValue
export _CSDPLUS_SetPrescaler
export  CSDPLUS_SetPrescaler
IF (CSDPLUS_AUTOCAL_ENABLE)
  export _CSDPLUS_CalibrateSensors
  export  CSDPLUS_CalibrateSensors
IF (CSDPLUS_SLIDERS_EXIST)
  export _CSDPLUS_SetSliderIdac
  export  CSDPLUS_SetSliderIdac
ENDIF
ENDIF

; Exported variables
export  CSDPLUS_bSensorNum
export _CSDPLUS_bSensorNum
export  CSDPLUS_waSnsResult
export _CSDPLUS_waSnsResult
export  CSDPLUS_fFlags
export _CSDPLUS_fFlags
export  CSDPLUS_bIdacValue
export _CSDPLUS_bIdacValue
export  CSDPLUS_bCompIdacValue
export _CSDPLUS_bCompIdacValue

export  CSDPLUS_wADC_Result
export _CSDPLUS_wADC_Result

IF (CSDPLUS_AUTOCAL_ENABLE)
export _CSDPLUS_baDAC
export  CSDPLUS_baDAC
export _CSDPLUS_baCompensationDAC
export  CSDPLUS_baCompensationDAC
ENDIF

; Tables
export  CSDPLUS_Sensor_Table
export _CSDPLUS_Sensor_Table
AREA bss

;@PSoC_UserCode_INIT@ (Do not change this line.)
;---------------------------------------------------
; Insert your custom declarations below this banner
;---------------------------------------------------

;------------------------
; User Includes
;------------------------


;------------------------
; User Constant Definitions
;------------------------


;------------------------
; User Variable Allocation
;------------------------


;---------------------------------------------------
; Insert your custom declarations above this banner
;---------------------------------------------------
;@PSoC_UserCode_END@ (Do not change this line.)


;-----------------------------------------------
; Variable Allocation
;-----------------------------------------------
AREA bss
_CSDPLUS_waSnsResult:                           ; Current raw results
 CSDPLUS_waSnsResult:                   BLK  (2*CSDPLUS_TOTALSENSORCOUNT)

AREA InterruptRAM (RAM, REL, CON)
CSDPLUS_wADC_Result:
_CSDPLUS_wADC_Result:                   BLK  2  ; 
 CSDPLUS_fFlags:                              
_CSDPLUS_fFlags:	                       BLK  1  ; Capsense Flags variable
 CSDPLUS_bBitMask:                      BLK  1  ; Temp bitmask byte
 CSDPLUS_bSensorNum:
_CSDPLUS_bSensorNum:                    BLK  1  ; Current sensor to scan
 CSDPLUS_bIdacValue:
_CSDPLUS_bIdacValue:                    BLK  1  ; Regular IDAC variable
 CSDPLUS_bCompIdacValue:
_CSDPLUS_bCompIdacValue:                BLK  1  ; Compwnsation IDAC variable

 CSDPLUS_bResolution:                   BLK  1  ; Scan Resolution 
 CSDPLUS_bScanSpeed:                    BLK  1  ; Scan Speed
 CSDPLUS_bPrescaler:                    BLK  1  ; Prescaler value
 CSDPLUS_bScanCnt:                      BLK  1  ; Counter variable 

IF (CSDPLUS_AUTOCAL_ENABLE)
_CSDPLUS_baDAC:                                  ; regular iDAC calibration values array
 CSDPLUS_baDAC:                             BLK  CSDPLUS_TOTALSENSORCOUNT
_CSDPLUS_baCompensationDAC:            ; Compensation iDAC calibration values array
 CSDPLUS_baCompensationDAC:             BLK  CSDPLUS_TOTALSENSORCOUNT
 CSDPLUS_wTmp1:                             BLK 2  ; Temp variables for calibration
 CSDPLUS_wTmp2:                             BLK 2  ; 
ENDIF

AREA UserModules (ROM, REL, CON)

.LITERAL
;---------------------------------
; Tables below generated by Wizard
;---------------------------------
; The Sensor Table consists of two bytes for each sensor.  The first byte is the
; port number and the second is the bit mask for the bit not to be confused with
; the bit number.  For example an entry for port 2 bit 3 (P2[3])  would be
; "dw 0x0208".  This table consist of 0x1 sensors.
 CSDPLUS_Sensor_Table:
_CSDPLUS_Sensor_Table:
	dw	0x0208	// Port 2 Bit 3

.ENDLITERAL

LSB:  equ  1
MSB:  equ  0

.LITERAL

CSDPLUS_PRS_CR_Table:
  db    0x98, 0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97  ;  Values for PRS_CR reg initialization

CSDPLUS_MUX_Table:                                  ; Amux registers table. Used for enable and disable capsense sensor
  db    MUX_CR0, MUX_CR1, MUX_CR2, MUX_CR3, MUX_CR4

CSDPLUS_MaxADC_Table:                               ; High (2^resolution-1)
  DB    0x00, 0x01, 0x03, 0x07, 0x0F, 0x1F, 0x3F, 0x7F, 0xFF

.ENDLITERAL

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_Start(void)
;
;  DESCRIPTION:
;  Connects external cap; sets up comparator,
;  disables all possible analog mux bus
;  connections; shunts all sensor pins to ground.
;
;  ARGUMENTS:
;    None
;
;  RETURNS:      None.
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------

 CSDPLUS_Start:
_CSDPLUS_Start:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   RAM_SETPAGE_IDX >CSDPLUS_baSnsOnMask
   ; Get size of CSDPLUS_baSnsOnMask array. If 8 sensors then 1 byte needed if 9-16 two bytes etc.
   mov   X, (CSDPLUS_TOTALSENSORCOUNT-1)/8  
.NullingCycle:
   mov   [X + <CSDPLUS_baSnsOnMask], 00h ; Clear CSDPLUS_baSnsOnMask array
   dec   X   ; decrement counter
   jnc   .NullingCycle
   RAM_SETPAGE_IDX >CSDPLUS_baSnsDebounce
   mov   X, (CSDPLUS_TOTALSENSORCOUNT-1) ; Get total sensor counts
.NullDbnc:
   mov   [X + CSDPLUS_baSnsDebounce], CSDPLUS_DEBOUNCE ; Initialize Debounce array
   mov   [X + <CSDPLUS_baLowBaselineReset], CSDPLUS_LOWBASELINERESET ; Initialize CSDPLUS_baLowBaselineReset array
   dec   X  ; decrement counter
   jnc   .NullDbnc
   RAM_EPILOGUE RAM_USE_CLASS_3
   mov   [CSDPLUS_bNoiseThreshold], CSDPLUS_NOISE_THRESHOLD ; Initialize Noise Threshold variable
   mov   [CSDPLUS_bNegativeNoiseThreshold], CSDPLUS_NEGATIVE_NOISE_THRESHOLD ; Initialize Negative Noise Threshold variable 
   mov   [CSDPLUS_bBaselineUpdateThreshold], CSDPLUS_BASELINE_UPDATE_THRESHOLD ; Initialize Baseline update Threshold variable
   mov   [CSDPLUS_bHysteresis], CSDPLUS_HYSTERESIS ; Initialize Hesteresis variable
   mov   [CSDPLUS_bDebounce], CSDPLUS_DEBOUNCE ; Initialize Debounce variable
   mov   [CSDPLUS_bLowBaselineReset], CSDPLUS_LOWBASELINERESET ; Initialize Low Base Line Reset variable
   mov   [CSDPLUS_bPrescaler], CSDPLUS_PRESCALER ; Initialize Prescaler variable
   mov   [CSDPLUS_bIdacValue], CSDPLUS_IDAC     ; Set init IDAC value
   mov   [CSDPLUS_fFlags], 00h  ; Clear Flag variable
   mov   [CSDPLUS_bCompIdacValue], CSDPLUS_COMPIDAC ; Initialize Compensation IDAC array
   or    reg[CSDPLUS_AMUX_CR_REG], CSDPLUS_AMUX_CR_INIT  ; Connect Modulator Capacitor 
IF (CSDPLUS_CAPACITOR_PIN)
IF (CSDPLUS_CAPACITOR_PIN & CSDPLUS_CAPACITOR_P0_1)
    mov  A, 02h
ENDIF
IF (CSDPLUS_CAPACITOR_PIN & CSDPLUS_CAPACITOR_P0_3)
    mov  A, 08h
ENDIF
   mov   X, 00h                  ; connect modulator capacitor
   call  CSDPLUS_EnableSensor
ENDIF
   mov   A, CSDPLUS_PRESCALER ; Get prescaler value
   index CSDPLUS_PRS_CR_Table ; Get PRS value
   or    A, CSDPLUS_PRS_RES  ; Get PRS resolution value
   mov	 reg[CSDPLUS_CapSense_PRS_CR_REG], A  ; Set PRS resolution and Prescaler value
   mov	 reg[CSDPLUS_CapSense_CR0_REG], (08h | CSDPLUS_PRCH_SRC)   ; select clock source
   or	 reg[CSDPLUS_CapSense_CR2_REG], CSDPLUS_CS_CR2_INIT  ;Enable precharge switches on analog bus
   or	 reg[CSDPLUS_CapSense_CR3_REG], CSDPLUS_CS_CR3_INIT  ; Set VREF to 1V, Enable and connect it to bus
   or    reg[CSDPLUS_CMP_CR0_REG], 01h   ; Enable Comparator 0
M8C_EnableIntMask    CSDPLUS_INT_REG, CSDPLUS_INT_MASK ; Enable the timer's interrupt

IF (CSDPLUS_AUTOCAL_ENABLE)
    mov  A, CSDPLUS_FAST_SPEED
    mov  X, CSDPLUS_CALIBRATION_RESOLUTION    ; Set calibration scan Resolution
    call CSDPLUS_SetScanMode
    call CSDPLUS_ClearSensors                         ; Loop through all sensors and deactivate them
    mov  X, CSDPLUS_IDAC_CALIBRATION_MSB              ; Calibrate to 85% of calibration resolution scan
    mov  A, CSDPLUS_IDAC_CALIBRATION_LSB
    call CSDPLUS_CalibrateSensors
IF (CSDPLUS_SLIDERS_EXIST)
    call CSDPLUS_SetSliderIdac
ENDIF
ENDIF
    mov  A, CSDPLUS_SCANNING_SPEED
    mov  X, CSDPLUS_RESOLUTION
    call CSDPLUS_SetScanMode
    call CSDPLUS_ClearSensors                         ; Loop through all sensors and deactivate them
    RAM_EPILOGUE RAM_USE_CLASS_4
    ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_SetPrescaler
;
;  DESCRIPTION:
;  Sets the prescaler ratio and determines the precharge switch output frequency
;  INPUT:
;  A - BYTE bPrescaler  - new prescaler value. Allowed values are:
;     CSDPLUS_PRESCALER_1      0x00
;     CSDPLUS_PRESCALER_2      0x01
;     CSDPLUS_PRESCALER_4      0x02
;     CSDPLUS_PRESCALER_8      0x03
;     CSDPLUS_PRESCALER_16     0x04
;     CSDPLUS_PRESCALER_32     0x05
;     CSDPLUS_PRESCALER_64     0x06
;     CSDPLUS_PRESCALER_128    0x07
;     CSDPLUS_PRESCALER_256    0x08
;
;  RETURNS:      None.
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
;-----------------------------------------------------------------------------
_CSDPLUS_SetPrescaler:
 CSDPLUS_SetPrescaler:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR  0
   cmp   A, 09h   ; Check input value
   jc    .ValueOk
   mov   A, 08h   ; if more than 8 then set prescaler to 8
.ValueOk:
   mov   [CSDPLUS_bPrescaler], A  ; Copy Prescaler value to global variable
   index CSDPLUS_PRS_CR_Table  ; Get PRS value
   or    A, CSDPLUS_PRS_RES
   mov	 reg[CSDPLUS_CapSense_PRS_CR_REG], A  ; Set PRS resolution and Prescaler value
   mov   A, [CSDPLUS_bScanSpeed]
   mov   X, [CSDPLUS_bResolution]
   call  CSDPLUS_SetScanMode
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_SetScanMode
;
;  DESCRIPTION:
;  Sets Capsense clock and Timer value according to required Scan Speed and Resolution
;  INPUT:
;  A - BYTE bSpeed  - scan speed code (see  Constants for Scan Speed values)
;  X - BYTE bResolution - resolution [9..16]
;
;  RETURNS:      None.
;
;-----------------------------------------------------------------------------

CHAIN_BIT:       equ 80h
SPEED_MASK:      equ 03h
RESOLUTION_MASK:  equ 0fh

_CSDPLUS_SetScanMode:
 CSDPLUS_SetScanMode:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR  0
   and   A, SPEED_MASK                            ; clear unused bits
   mov   [CSDPLUS_bScanSpeed], A
   asl   A
   asl   A
   asl   A
   asl   A
   asl   A
   or    A, CHAIN_BIT                                  ; Set Chain bit
   mov   reg[CSDPLUS_CapSense_CR1_REG], A                           ; Set ClkSel bits according to selected ScanSpeed
   mov   A, X                                    ; Copy Resolution to A
   dec   A
   and   A, RESOLUTION_MASK                     ; clear unused bits
   or    A, 08h                                 ; be sure the resolution is in 9..16 range
   inc   A
   mov   [CSDPLUS_bResolution], A
   sub   A, [CSDPLUS_bPrescaler]
   add   A, [CSDPLUS_bScanSpeed]
.L0:
   mov  X, A
   mov  A, 00h
   mov  [CSDPLUS_bBitMask], A
   mov  [CSDPLUS_bScanCnt], A
.L1:
   or   A, 01h
   dec  X
   jz   .L2
   asl  A
   rlc  [CSDPLUS_bBitMask]
   rlc  [CSDPLUS_bScanCnt]
   jmp  .L1
.L2:
   mov  reg[CSDPLUS_DATA0_REG], A
   mov  A, [CSDPLUS_bBitMask]
   mov  reg[CSDPLUS_DATA1_REG], A
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_SetIdacValue
;
;  DESCRIPTION:
;
;  INPUT:
;  A - BYTE bIdacValue;  
;  X - BYTE bCompensationIdacValue
;
;  RETURNS:      None.
;  SIDE EFFECTS: None.
;
;-----------------------------------------------------------------------------
_CSDPLUS_SetIdacValue:
 CSDPLUS_SetIdacValue:
    RAM_PROLOGUE RAM_USE_CLASS_4
    RAM_SETPAGE_CUR  0
   mov   [CSDPLUS_bIdacValue], A
   mov   [CSDPLUS_bCompIdacValue], X ; Set Compensation IDAC variable
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_ClearSensors(void)
;
;  DESCRIPTION:
;    Clears all sensor connections to the analog mux bus and shunts all sensor
;    pins to ground.
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------
 CSDPLUS_ClearSensors:
_CSDPLUS_ClearSensors:
   RAM_PROLOGUE RAM_USE_CLASS_4
   mov   A, (CSDPLUS_TOTALSENSORCOUNT - 1) ; Get total sensor count
.InitLoop:                         ; Loop through all sensors and deactivate
   push  A      ; Save A
   call  CSDPLUS_wGetPortPin ; Get sensor Port Pin 
   call  CSDPLUS_DisableSensor ; Disable current sensor
   pop   A   ; Restore A
   dec   A   ; decrement sensor number
   jnc   .InitLoop
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_Stop(void)
;
;  DESCRIPTION:
;
;  Disables the CapSense interrupt, disconnects the external capacitor, disables
;  internal capacitor, disbales precharge switching, disconnects IDAC, disconnects VRef buffer
;  disables PRS
;
;  ARGUMENTS:    None.
;  RETURNS:      None.
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------
 CSDPLUS_Stop:
_CSDPLUS_Stop:
   RAM_PROLOGUE RAM_USE_CLASS_1
   M8C_DisableIntMask    CSDPLUS_INT_REG, CSDPLUS_INT_MASK ; Disable the CapSense Timer interrupt
   M8C_SetBank1
IF (CSDPLUS_CAPACITOR_PIN & CSDPLUS_CAPACITOR_P0_1)
   and   reg[CSDPLUS_P0_MUX_REG], ~02h		;Disconnect external capacitor
ENDIF
IF (CSDPLUS_CAPACITOR_PIN & CSDPLUS_CAPACITOR_P0_3)
   and   reg[CSDPLUS_P0_MUX_REG], ~08h		;Disconnect external capacitor
ENDIF
   M8C_SetBank0
   ; and     reg[AMUXCFG], ~0ch		; Disconnect internal capacitor
   and   reg[CSDPLUS_CapSense_CR2_REG], ~CSDPLUS_CS_CR2_INIT		; Disable precharge switching and disconnect IDAC
   and   reg[CSDPLUS_CapSense_CR0_REG], ~08h		; Disable CSDPLUS mode
   and   reg[CSDPLUS_CapSense_CR3_REG], ~CSDPLUS_CS_CR3_INIT	; Power down and disconnect VRef Buffer
   mov	 reg[CSDPLUS_CapSense_PRS_CR_REG], 00h   ; Disable PRS
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_Resume(void)
;
;  DESCRIPTION:
;
;    Resumes CSDPLUS operation after Stop() call
;
;  ARGUMENTS:    None.
;  RETURNS:      None.
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------

CSDPLUS_MODE_BIT_MASK:       equ 08h

 CSDPLUS_Resume:
_CSDPLUS_Resume:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0
   mov   [CSDPLUS_fFlags], 00h  ; Clear Flag variable
   or	 reg[CSDPLUS_CapSense_CR3_REG], 50h  		; Power up VRef Buffer
   mov   A, [CSDPLUS_bPrescaler]
   index CSDPLUS_PRS_CR_Table
   or    A, CSDPLUS_PRS_RES
   mov	 reg[CSDPLUS_CapSense_PRS_CR_REG], A  ; Set PRS resolution and Prescaler value
   or    reg[CSDPLUS_AMUX_CR_REG], CSDPLUS_AMUX_CR_INIT  ; Connect Modulator Capacitor 
IF (CSDPLUS_CAPACITOR_PIN)
IF (CSDPLUS_CAPACITOR_PIN & CSDPLUS_CAPACITOR_P0_1)
   mov  A, 02h
ENDIF
IF (CSDPLUS_CAPACITOR_PIN & CSDPLUS_CAPACITOR_P0_3)
   mov  A, 08h
ENDIF
   mov  X, 00h                  ; connect modulator capacitor
   call  CSDPLUS_EnableSensor
ENDIF
   or	reg[CSDPLUS_CapSense_CR3_REG], 20h		; Connect VRef Buffer
   or   reg[CSDPLUS_CapSense_CR2_REG], CSDPLUS_CS_CR2_INIT		; Enable precharge switching and reconnect iDAC
   or   reg[CSDPLUS_CapSense_CR0_REG], CSDPLUS_MODE_BIT_MASK		; Enable CSDPLUS mode
   M8C_EnableIntMask    CSDPLUS_INT_REG, CSDPLUS_INT_MASK ; Enable the CapSense Timer interrupt
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_wGetPortPin(BYTE bSensor)
;
;  DESCRIPTION:
;      Returns the port and pin mask from a given key number.  This function
;      uses the table CSDPLUS_Sensor_Table to retrieve this
;      information.
;
;  ARGUMENTS:
;        A => Sensor Number  ( 0 to n )
;  RETURNS:
;        A  <=  Sensor Bitmap
;        X  <=  Port Number
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------
 CSDPLUS_wGetPortPin:
_CSDPLUS_wGetPortPin:
   RAM_PROLOGUE RAM_USE_CLASS_1
   asl   A                                       ; multiply key by 2 since table is 2 bytes per key
   mov   X, A                                    ; Copy index*2 in x for next value
   index CSDPLUS_Sensor_Table                    ; A contains the port value
   swap  A, X                                    ; Place port value in X and index*2 in A
   inc   A                                       ; Advance to next value (bitMask)
   index CSDPLUS_Sensor_Table                    ; A contains bitMask, X has port number
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_EnableSensor(BYTE bSensorMask, BYTE bPort)
;
;  DESCRIPTION:
;    Configures sensor to be an input to be measured during next measurement
;    cycle; places sensor pin's drive mode in Analog Hi-Z mode and connects
;    to the analog mux bus.
;
;    This function does not do anything with the previous sensor.
;
;  ARGUMENTS:
;          X =>  Port Number for given sensor
;          A =>  Bit mask for given sensor
;
;  RETURNS:      None
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------
 CSDPLUS_EnableSensor:
_CSDPLUS_EnableSensor:
	RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   ; Setup Mux for sensor
   mov   [CSDPLUS_bBitMask], A                             ; Store bit mask in temp location
   push  X                                                ; Save Port Number for given sensor
   mov   A, X                                              ; Multiply port number by four for register addresses
   asl   A
   asl   A
   mov   X, A                                              ; Restore Port address in X
   ; Set mode to 10 (Hi-Z Analog) and connect to analog mux bus
   M8C_SetBank1
   mov   A, reg[X+CSDPLUS_DM1_OFFSET]                            ; Set DM1 to 1
   or    A, [CSDPLUS_bBitMask]
   mov   reg[X+CSDPLUS_DM1_OFFSET], A
   xor   [CSDPLUS_bBitMask], FFh                           ; Invert bitmask
   mov   A, reg[X+CSDPLUS_DM0_OFFSET]                            ; Clear DM0 bit to 0
   and   A, [CSDPLUS_bBitMask]
   mov   reg[X+CSDPLUS_DM0_OFFSET], A
   xor   [CSDPLUS_bBitMask], FFh                           ; Invert bitmask to get original mask
   pop   A                                                ; Restore Port Number for given sensor
   index CSDPLUS_MUX_Table                      ; Get mux value
   mov   X, A                                             ; Copy to A
   mov   A, reg[X]                                        ; Get current AMUX value 
   or    A, [CSDPLUS_bBitMask]                   ; 
   mov   reg[X], A                                        ; Configure AMUX reg
   M8C_SetBank0
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_DisableSensor(BYTE bMask, BYTE bPort)
;
;  DESCRIPTION:
;    Disconnects the desired sensor from the analog mux bus and shunts to
;    ground.
;
;  ARGUMENTS:
;          X =>  Port Number for given sensor
;          A =>  Bit mask for given sensor
;
;  RETURNS:      none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------
 CSDPLUS_DisableSensor:
_CSDPLUS_DisableSensor:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   ; Disconnect sensor from mux
   push  X                                       ; Store Port Number
   cpl   A                                       ; Invert bitmask
   mov   [CSDPLUS_bBitMask], A                   ; Store bit mask in temp location
   M8C_SetBank1
   mov   A, X                                     ; get Port Number for given sensor
   index CSDPLUS_MUX_Table             ; Get AMUX value 
   mov   X, A                                     ; copy to X
   mov   A, reg[X]                                ; Get current AMUX value to A
   and   A, [CSDPLUS_bBitMask]           ; 
   mov   reg[X], A                                ; configure AMUX register 
   M8C_SetBank0
   pop   A                                       ; restore Port Number
   asl   A
   asl   A
   mov   X, A                                    ; Restore Port address in X
   ; Set mode to 01 (Digital Strong)
   M8C_SetBank1
   mov   A, reg[X+CSDPLUS_DM1_OFFSET]                     ; Set DM1 to 0
   and   A, [CSDPLUS_bBitMask]
   mov   reg[X+CSDPLUS_DM1_OFFSET], A
   xor   [CSDPLUS_bBitMask], FFh                 ; Invert bitmask back to normal
   mov   A, reg[X+CSDPLUS_DM0_OFFSET]                     ; Set DM0 bit to 1
   or    A, [CSDPLUS_bBitMask]
   mov   reg[X+CSDPLUS_DM0_OFFSET], A
   M8C_SetBank0
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_ScanSensor(BYTE bStrtIdx)
;
;  DESCRIPTION:
;  Uses the CapSense switching circuitry to charge to the starting voltage.
;  Then a fixed slope ramp is used to measure the starting voltage with a
;  16 bit timer.
;
;
;  ARGUMENTS:
;      A  => Sensor Index
;
;  RETURNS:      None
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------

ENABLE_TIMER:   equ 01h
AMUX_ENABLE:    equ 01h

 CSDPLUS_ScanSensor:
_CSDPLUS_ScanSensor:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0
   mov   [CSDPLUS_bSensorNum], A  ; Save sensor number
IF (CSDPLUS_AUTOCAL_ENABLE)
   mov   X, A
   RAM_SETPAGE_IDX >CSDPLUS_baDAC
   mov   A, [X+CSDPLUS_baDAC]  ; Get Calibrated IDAC value
   mov   [CSDPLUS_bIdacValue], A ; Replace user IDAC variable
   tst   [CSDPLUS_fFlags], CSDPLUS_CALIBRATION_FLAG ; Check calibrate flag.
   jnz   .SkipIDAC0
   mov   A, [X+CSDPLUS_baCompensationDAC] ; ; Get Calibrated Compensation IDAC value
   mov   [CSDPLUS_bCompIdacValue], A ; Replace user Compensation IDAC variable
.SkipIDAC0:
ENDIF
   mov   A, 00h
   mov   [CSDPLUS_wADC_Result+MSB], A
   mov   [CSDPLUS_wADC_Result+LSB], A
   or    reg[CSDPLUS_CapSense_CR0_REG], AMUX_ENABLE   ; Start capsense block (enable AMUX bus regulation with iDAC)
   mov   A, [CSDPLUS_bIdacValue]
   mov   reg[CSDPLUS_IDAC_1_REG], A              ; Load IDAC1 value
   tst   [CSDPLUS_fFlags], CSDPLUS_CALIBRATION_FLAG ; Check calibrate flag.
   jnz   .SkipIDAC0Set
   mov   A, [CSDPLUS_bCompIdacValue]      ; Get compensation IDAC value
   mov   reg[CSDPLUS_IDAC_0_REG], A              ; Load IDAC0 compensation DAC value
.SkipIDAC0Set:
   and   reg[CSDPLUS_CapSense_CR3_REG], ~20h          ; Disconnect VRef from AMUX bus
   mov	 A, [CSDPLUS_bSensorNum]	; Connect sensor to AMUX bus (switching is already enabled in CSDPLUS_Start)
   call  CSDPLUS_wGetPortPin
   call  CSDPLUS_EnableSensor
   tst   [CSDPLUS_fFlags], CSDPLUS_CALIBRATION_FLAG ; Check calibrate flag.
   jnz   .SkipIDACSplit
   or    reg[CSDPLUS_CapSense_TIMER_REG], CSDPLUS_SPLITIDAC_MASK ; Initialize dual IDAC mode 
.SkipIDACSplit:
   mov   X, [CSDPLUS_bScanCnt]      ; Slow and/or high resolution scan modes require several scans
   mov   A, CSDPLUS_SETTLING_DELAY                                    ; Delay for AMUX bus voltage settling
.SettlingLoop:
   dec   A
   jnc   .SettlingLoop
.L0:
   and  [CSDPLUS_fFlags], ~CSDPLUS_ADC_STATUS ; clear ADC status bits   
   mov   A, 00h
   mov   reg[CSDPLUS_CapSense_CNTH_REG], A
   mov   reg[CSDPLUS_CapSense_CNTL_REG], A
   or    reg[CSDPLUS_CONFIG_REG], ENABLE_TIMER  ; Start timer - enable measurement
.L1:
   tst   [CSDPLUS_fFlags], CSDPLUS_ADC_STATUS 
   jz    .L1                         ; Wait for timer's interrupt
   dec   X
   jnc   .L0                         ; Loop back to repeat scan if needed for slow and/or high resolution scan modes
   mov   A, [CSDPLUS_bSensorNum]    ; Disconnect sensor from AMUX bus
   call  CSDPLUS_wGetPortPin
   call  CSDPLUS_DisableSensor
   or    reg[CSDPLUS_CapSense_CR3_REG], 20h           ; Connect VRef to AMUX bus
   and   reg[CSDPLUS_CapSense_CR0_REG], ~AMUX_ENABLE          ; Stop capsense block
   mov   reg[CSDPLUS_IDAC_0_REG], 00h              ; Disable iDAC0
   mov   reg[CSDPLUS_IDAC_1_REG], 00h              ; Disable iDAC1
   and   reg[CSDPLUS_CapSense_TIMER_REG], ~CSDPLUS_SPLITIDAC_MASK ; Initialize Single IDAC mode 
   mov   A, FFh                     ; Result normalization - on touch raw count shall increase
   swap  A, [CSDPLUS_wADC_Result+LSB]
   sub   [CSDPLUS_wADC_Result+LSB], A
   mov   A, [CSDPLUS_bResolution]
   sub   A, 08h
   index CSDPLUS_MaxADC_Table
   swap  A, [CSDPLUS_wADC_Result+MSB]
   sbb   [CSDPLUS_wADC_Result+MSB], A
   jnc   .Cont
   mov   [CSDPLUS_wADC_Result+MSB], 00h
   mov   [CSDPLUS_wADC_Result+LSB], 00h
.Cont:
   mov   A, [CSDPLUS_bSensorNum]
   asl   A                             ; Multiply by two since results are INTs
   mov   X, A
   RAM_SETPAGE_IDX >CSDPLUS_waSnsResult
   mov   A, [CSDPLUS_wADC_Result + LSB]  ; Store result in waSnsResult array
   mov   [X+(CSDPLUS_waSnsResult+LSB)], A
   mov   A, [CSDPLUS_wADC_Result + MSB]
   mov   [X+(CSDPLUS_waSnsResult+MSB)], A
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_ScanAllSensors(void)
;
;  DESCRIPTION:
;    Scans all sensors to find their raw count values
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------
 CSDPLUS_ScanAllSensors:
_CSDPLUS_ScanAllSensors:
   RAM_PROLOGUE RAM_USE_CLASS_4
   mov   A, (CSDPLUS_TOTALSENSORCOUNT-1)              ; Check if key value in range.
.ScanLoop:                                            ; Loop through all sensors and scan
   push  A                              ; Save Sensor Index
   call  CSDPLUS_ScanSensor    ; Scan sensor
   pop   A                              ; Restore Sensor Index
   dec   A                              ; Decrement counter
   jnc   .ScanLoop
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_wReadSensor(BYTE bSensor)
;
;  DESCRIPTION:
;     Returns the sensor scan value in A (LSB) and X (MSB)
;
;  ARGUMENTS:
;    A = Sensor number
;  RETURNS:
;    Scan value of sensor LSB in A and MSB in X
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to preserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------
 CSDPLUS_wReadSensor:
_CSDPLUS_wReadSensor:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_IDX >CSDPLUS_waSnsResult
   asl   A                                            ; Multiply by two since results are INTs
   mov   X, A
   mov   A, [X+(CSDPLUS_waSnsResult+LSB)]
   mov   X, [X+(CSDPLUS_waSnsResult+MSB)]
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

IF (CSDPLUS_AUTOCAL_ENABLE)
.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_CalibrateSensors(wLevel)
;
;  DESCRIPTION:
;   Adjusts iDAC current to obtain raw count near wLevel value.
;
;  ARGUMENTS:    A - wLevel (LSB)
;                X - wLevel (MSB)
;  RETURNS:      None. Calibration setting are stored in the global array CSDPLUS_baDAC[]
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------
 CSDPLUS_CalibrateSensors:
_CSDPLUS_CalibrateSensors:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0
   mov   [CSDPLUS_wTmp1 + LSB], A                     ; Save Target LSB value
   mov   [CSDPLUS_wTmp1 + MSB], X                     ; Save Target MSB value
;--------------------------------
; Block for calculation (2^N-1)/2
;--------------------------------
   mov   A, [CSDPLUS_bResolution]                     ; Get current resolution value
   and   A, ~F8h                                      ; Clear bit to get correct offset  
   jnz   .Recalculate
   mov   A, FFh                                       ; Prepare MSB for 16 bit resolution case   
   jmp   .Res16bit
.Recalculate:   
   mov   X, A                                         ; Initialize counter
   mov   A, 00h                                       ; Prepare MSB part
.ShiftLoop:   
   or    F, 04h                                       ; set carry flag
   rlc   A
   dec   X                                            ; decrement counter
   jnz   .ShiftLoop   
.Res16bit:
   mov  [CSDPLUS_wTmp2+LSB], FFh                      ; LSB part will always FFh    
   and  F, FBh  ; clear carry flag
   rrc  A       ; divide by two
   mov  [CSDPLUS_wTmp2+MSB], A                        ; Initialize MSB part
;---------------------------------   
; END of (2^N-1)/2 calculation
;---------------------------------
; Target calibration value/2
;--------------------------------
   and   F, FBh  ; clear carry flag
   rrc   [CSDPLUS_wTmp1 + MSB]                        ; Restore Target MSB value
   rrc   [CSDPLUS_wTmp1 + LSB]                        ; Restore Target LSB value
;--------------------------------
   mov  A, [CSDPLUS_wTmp2+LSB]                        ; copy LSB to A
   add  [CSDPLUS_wTmp1 + LSB], A                      ; Add LSB part
   mov  A, [CSDPLUS_wTmp2+MSB]                        ; copy LSB to A
   adc  [CSDPLUS_wTmp1 + MSB], A                      ; Add MSB part
   
   ; Combine two separate IDACs in one DAC
   and   reg[CSDPLUS_CapSense_TIMER_REG], ~CSDPLUS_SPLITIDAC_MASK ; Initialize dual IDAC mode 
   mov   reg[CSDPLUS_IDAC_0_REG], 00h                 ; Disable iDAC0
   mov   [CSDPLUS_bSensorNum], (CSDPLUS_TOTALSENSORCOUNT-1)
   or    [CSDPLUS_fFlags], CSDPLUS_CALIBRATION_FLAG ; Set calibrate flag.
.ScanLoop:                                            ; Loop through all sensors and scan
   RAM_SETPAGE_IDX >CSDPLUS_baDAC
   mov   X, [CSDPLUS_bSensorNum]
   mov   [X+CSDPLUS_baDAC], 80h
   mov   [CSDPLUS_wTmp2+LSB], 08h
   mov   [CSDPLUS_wTmp2+MSB], 80h
.L0:
   mov   A, [CSDPLUS_bSensorNum]                      ; Get sensor index
   call  CSDPLUS_ScanSensor                           ; Get dummy sensor raw data
   mov   A, [CSDPLUS_bSensorNum]                      ; Get sensor index
   call  CSDPLUS_ScanSensor                           ; Get sensor raw data
   RAM_PROLOGUE RAM_USE_CLASS_3                       ; Restore paging mode after function call
   mov   X, [CSDPLUS_bSensorNum]                      ; get sensor index
   RAM_SETPAGE_IDX >CSDPLUS_baDAC
   mov   A, [CSDPLUS_wADC_Result+LSB]                 ; Get LSB part of current sensor raw data
   cmp   A, [CSDPLUS_wTmp1 + LSB]
   mov   A, [CSDPLUS_wADC_Result+MSB]                 ; Get LSB part of current sensor raw data
   sbb   A, [CSDPLUS_wTmp1 + MSB]                     ; if wADC_Result <= wLevel
   jnc   .L1
   mov   A, [CSDPLUS_wTmp2+MSB]                       ; below the target, clear the bit
   cpl   A
   and   [X+CSDPLUS_baDAC], A
.L1:
   asr   [CSDPLUS_wTmp2+MSB]                          ; above the target, keep the bit
   and   [CSDPLUS_wTmp2+MSB], ~80h
   mov   A, [CSDPLUS_wTmp2+MSB]
   or    [X+CSDPLUS_baDAC], A
   dec   [CSDPLUS_wTmp2+LSB]
   jnz   .L0
   dec   [CSDPLUS_bSensorNum]
   jnc   .ScanLoop
   and    [CSDPLUS_fFlags], ~CSDPLUS_CALIBRATION_FLAG ; Check calibrate flag.
   ; Divide Current IDAC1 value between two separate IDACs. Now each IDAC will have 50% of calibrated IDAC value.
   mov   X, (CSDPLUS_TOTALSENSORCOUNT - 1)            ; get sensor num
.UpdateDACloop: 
   RAM_SETPAGE_IDX >CSDPLUS_baDAC   
   mov   A, [X+CSDPLUS_baDAC]                         ; Get IDAC1 calibrated value
   asr   A                                            ; divide by two 
   mov   [X+CSDPLUS_baCompensationDAC], A             ; Update IDAC0 with new value
   sub   [X+CSDPLUS_baDAC], A                         ; Update IDAC1 with new value 
   dec   X                                            ; decrement loop counter
   jnc   .UpdateDACloop      
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

IF(CSDPLUS_SLIDERS_EXIST)

.LITERAL
;---------------------------------
; Tables below generated by Wizard
;---------------------------------
;-----------------------------------------------------------------------------
; The Group Table defines each of the groups of button sensors or sliders.
; There is one entry for each slider plus one for the free button sensors.
; The first entry is always the free sensors.  Each entry is four bytes.
;
; The first byte is the index in the Sensor Table where the group starts.
;
; The second byte is how many sensors are in that group.  For example, in a
; system where there are 8 free sensors and two sliders, the first with 8
; sensors and the second with 4, the table would look like the following.
;  db 0, 8
;  db 8, 8
;  db 16, 4
;
; The third byte signifies whether the slider is diplexed or not (non-zero is
; diplexed, 0 is not diplexed).
;
; The fourth, fifth, and sixth bytes are the fixed point multiplier that the
; slider's calculated centroid will be multiplied by to achieve the resolution
; desired in the CSD wizard.  The multiplier is three bytes containing the
; following bit definitions:
;  MSB:
;    bit 7   bit 6   bit 5   bit 4   bit 3   bit 2   bit 1   bit 0
;     x2^15	  x2^14   x2^13   x2^12   x2^11   x2^10   x2^9    x2^8
;  ISB:
;    bit 7   bit 6   bit 5   bit 4   bit 3   bit 2   bit 1   bit 0
;     x128	  x64     x32     x16     x8      x4      x2      x1
;  LSB:
;    bit 7   bit 6   bit 5   bit 4   bit 3   bit 2   bit 1   bit 0
;     x1/2	  x1/4    x1/8    x1/16   x1/32   x1/64   x1/128  x1/256
;
; The formula for the Multiplier is:
; Multiplier = ((Resolution-1) * 256) / (SensorsInSlider - 1)
;
; For example, if you had a 10 sensor slider and you wanted a resolution of
; 100, the multiplier would need to be 0x000B00:
; MSB 00h
; ISB 0Bh
; LSB 00h
; The GUI automatically calculates these values based on the resolution needed.
;
; There are 0x0 groups counting the free sensors.
;-----------------------------------------------------------------------------
 CSDPLUS_Group_Table2:
_CSDPLUS_Group_Table2:
; Group Table:
;    Origin    Count    Diplex?    DivBtwSw(wholeMSB, wholeLSB, fractByte)
 db   0x0,      0x01,	 0x00,	 0x00,	 0x00,	 0x00 ; Buttons

.ENDLITERAL

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSDPLUS_SetSliderIdac(void)
;
;  DESCRIPTION:
;   Sets iDAC current for slider elements to the highest for each slider group.
;
;  ARGUMENTS:    None.
;  RETURNS:      None.
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------
 CSDPLUS_SetSliderIdac:
_CSDPLUS_SetSliderIdac:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   RAM_SETPAGE_IDX >CSDPLUS_baDAC
   mov   A, CSDPLUS_SLIDERCOUNT
.StartSliderAdjustment:
   push  A                                          ;Store Slider Count Index
   asl   A
   mov   [CSDPLUS_wTmp1+MSB], A
   asl   A
   add   A, [CSDPLUS_wTmp1+MSB]                         ;A contains Slider Count multiplied by 6
   mov   X, A
   index CSDPLUS_Group_Table2                            ;Get the Slider Start Position
   mov   [CSDPLUS_wTmp2+LSB], A                         ;[CSDPLUS_wTmp2+LSB] contains the start of this slider group
   mov   [CSDPLUS_wTmp2+MSB], A
   mov   A, X
   inc   A                                          ;Increment to get the slider size
   index CSDPLUS_Group_Table2
   add   [CSDPLUS_wTmp2+MSB], A                         ;[CSDPLUS_wTmp2+MSB] contains the end of this slider group
   mov   [CSDPLUS_bCurPos], 00h                           ;[CSDPLUS_bCurPos] used as temp to store max iDAC setting found.  Clear variable.
   mov   A, [CSDPLUS_wTmp2+MSB]                         ;[CSDPLUS_wTmp2+MSB] contains the end of this slider group
.StartIDACSearch:
   push  A
   dec   A
   mov   X, A
   mov   A, [X+CSDPLUS_baDAC]
   cmp   A, [CSDPLUS_bCurPos]                           ;Is [CSDPLUS_baDAC+X] < [CSDPLUS_bCurPos]
   jc    .NoStore
   mov   [CSDPLUS_bCurPos], A                           ;Store current iDAC as highest
.NoStore:
   pop   A
   dec   A
   cmp   A, [CSDPLUS_wTmp2+LSB]
   jnz   .StartIDACSearch
   mov   A, [CSDPLUS_wTmp2+MSB]                         ;[CSDPLUS_wTmp2+MSB] contains the end of this slider group
.StartSetIDAC:
   push  A
   dec   A
   mov   X, A
   mov   A, [CSDPLUS_bCurPos]                           ;Set all iDAC settings to highest.
   mov   [X+CSDPLUS_baDAC], A
   pop   A
   dec   A
   cmp   A, [CSDPLUS_wTmp2+LSB]
   jnz   .StartSetIDAC
.EndSliderSdjustment:
   pop   A                                          ;Get the Slider Count Index
   dec   A
   jnz   .StartSliderAdjustment
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION
ENDIF
ENDIF
