//*****************************************************************************
//*****************************************************************************
//  FILENAME: CSDPLUS.h
//   Version: 1.10, Updated on 2012/9/21 at 11:58:32
//  Generated by PSoC Designer 5.3.2710
//
//  DESCRIPTION: CSDPLUS User Module C Language interface file
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef CSDPLUS_INCLUDE
#define CSDPLUS_INCLUDE

#include <m8c.h>

//--------------------------------------------------
// Constants for CSDPLUS
//--------------------------------------------------
#define CSDPLUS_TOTALSENSORCOUNT                  0x1
#define CSDPLUS_BUTTONCOUNT                       0x1
#define CSDPLUS_SLIDERCOUNT                       0x0 + 0x0 
#define CSDPLUS_SLIDERS_EXIST                     0x0 | 0x0
#define CSDPLUS_RADIAL_SLIDERS_EXIST              0x0
#define CSDPLUS_LINEAR_SLIDERS_EXIST              0x0
#define CSDPLUS_AUTOCAL_ENABLE                    0x1

//--------------------------------------------------
// Constants for Scan Speed values
//--------------------------------------------------
#define CSDPLUS_ULTRA_FAST_SPEED                  0x00
#define CSDPLUS_FAST_SPEED                        0x01
#define CSDPLUS_NORMAL_SPEED                      0x02
#define CSDPLUS_SLOW_SPEED                        0x03
#define CSDPLUS_SCANNING_SPEED                    0x2

//--------------------------------------------------
// Constants for Prescaler values
//--------------------------------------------------
#define CSDPLUS_PRESCALER                         0x1
#define CSDPLUS_PRESCALER_1                       0x00
#define CSDPLUS_PRESCALER_2                       0x01
#define CSDPLUS_PRESCALER_4                       0x02
#define CSDPLUS_PRESCALER_8                       0x03
#define CSDPLUS_PRESCALER_16                      0x04
#define CSDPLUS_PRESCALER_32                      0x05
#define CSDPLUS_PRESCALER_64                      0x06
#define CSDPLUS_PRESCALER_128                     0x07
#define CSDPLUS_PRESCALER_256                     0x08

//--------------------------------------------------
// Constants for Thresholds values
//--------------------------------------------------
#define CSDPLUS_FINGER_THRESHOLD                  0x20
#define CSDPLUS_NOISE_THRESHOLD                   0x14
#define CSDPLUS_BASELINE_UPDATE_THRESHOLD         0x32
#define CSDPLUS_HYSTERESIS                        0x8

//--------------------------------------------------
// Constants for Resolution values
//--------------------------------------------------
#define CSDPLUS_MIN_RESOLUTION                    9
#define CSDPLUS_9_BIT_RESOLUTION                  9
#define CSDPLUS_10_BIT_RESOLUTION                 10
#define CSDPLUS_11_BIT_RESOLUTION                 11
#define CSDPLUS_12_BIT_RESOLUTION                 12
#define CSDPLUS_13_BIT_RESOLUTION                 13
#define CSDPLUS_14_BIT_RESOLUTION                 14
#define CSDPLUS_15_BIT_RESOLUTION                 15
#define CSDPLUS_16_BIT_RESOLUTION                 16
#define CSDPLUS_MAX_RESOLUTION                    16
#define CSDPLUS_RESOLUTION                       0xc

// Definitions below are for consistency with old CapSense UMs
// Not Recommended for using in new designs 
#define CSDPLUS_TotalSensorCount                  0x1
#define CSDPLUS_ButtonCount                       0x1
#define CSDPLUS_SliderCount                       0x0 + 0x0 
//End of old definitions

//--------------------------------------------------
// Variables for CSDPLUS.
//--------------------------------------------------
extern WORD CSDPLUS_waSnsResult[];
extern WORD CSDPLUS_waSnsBaseline[];
extern WORD CSDPLUS_waSnsDiff[];
extern BYTE CSDPLUS_baSnsOnMask[];
extern BYTE CSDPLUS_baBtnFThreshold[];
extern BYTE CSDPLUS_bNoiseThreshold;                   
extern BYTE CSDPLUS_bNegativeNoiseThreshold;           
extern BYTE CSDPLUS_bBaselineUpdateThreshold;          
extern BYTE CSDPLUS_bHysteresis;                       
extern BYTE CSDPLUS_bDebounce;                         
extern BYTE CSDPLUS_bLowBaselineReset;                 

#if(CSDPLUS_AUTOCAL_ENABLE)
extern BYTE CSDPLUS_baDAC[];
extern BYTE CSDPLUS_baCompensationDAC[];
#endif
extern BYTE CSDPLUS_fFlags; // This variable store all necessary flags for CSDPLUS

// Low Level scan API
#pragma fastcall16 CSDPLUS_Start
#pragma fastcall16 CSDPLUS_Stop
#pragma fastcall16 CSDPLUS_Resume
#pragma fastcall16 CSDPLUS_ScanSensor
#pragma fastcall16 CSDPLUS_ScanAllSensors
#pragma fastcall16 CSDPLUS_ClearSensors
#pragma fastcall16 CSDPLUS_wReadSensor
#pragma fastcall16 CSDPLUS_wGetPortPin
#pragma fastcall16 CSDPLUS_EnableSensor
#pragma fastcall16 CSDPLUS_DisableSensor
#pragma fastcall16 CSDPLUS_SetScanMode
#pragma fastcall16 CSDPLUS_SetIdacValue
#pragma fastcall16 CSDPLUS_SetPrescaler
#if(CSDPLUS_AUTOCAL_ENABLE)
#pragma fastcall16 CSDPLUS_CalibrateSensors
#pragma fastcall16 CSDPLUS_SetSliderIdac
#endif

// High Level API
#pragma fastcall16 CSDPLUS_UpdateSensorBaseline
#pragma fastcall16 CSDPLUS_bIsSensorActive
#pragma fastcall16 CSDPLUS_bIsAnySensorActive
#if (CSDPLUS_BUTTONCOUNT)
#pragma fastcall16 CSDPLUS_SetDefaultFingerThresholds
#endif
#pragma fastcall16 CSDPLUS_InitializeSensorBaseline
#pragma fastcall16 CSDPLUS_InitializeBaselines
#pragma fastcall16 CSDPLUS_UpdateAllBaselines

#if CSDPLUS_LINEAR_SLIDERS_EXIST
#pragma fastcall16 CSDPLUS_wGetCentroidPos
#endif
#if CSDPLUS_RADIAL_SLIDERS_EXIST 
#pragma fastcall16 CSDPLUS_wGetRadialPos
#pragma fastcall16 CSDPLUS_wGetRadialInc
#endif

//-------------------------------------------------
// C prototypes of the CSDPLUS API.
//-------------------------------------------------
extern void CSDPLUS_Start(void);
extern void CSDPLUS_Stop(void);
extern void CSDPLUS_Resume(void);
extern void CSDPLUS_ScanSensor(BYTE bSensor);
extern void CSDPLUS_ScanAllSensors(void);
extern void CSDPLUS_ClearSensors(void);
extern WORD CSDPLUS_wReadSensor(BYTE bSensor);
extern WORD CSDPLUS_wGetPortPin(BYTE bSensor);
extern void CSDPLUS_EnableSensor(BYTE bMask, BYTE bPort);
extern void CSDPLUS_DisableSensor(BYTE bMask, BYTE bPort);
extern void CSDPLUS_SetScanMode(BYTE bSpeed, BYTE bResolution);
extern void CSDPLUS_SetIdacValue(BYTE bIdacValue, BYTE bCompensationIDACValue);
extern void CSDPLUS_SetPrescaler(BYTE bPrescaler);
#if(CSDPLUS_AUTOCAL_ENABLE)
extern void CSDPLUS_CalibrateSensors(WORD wValue);
extern void CSDPLUS_SetSliderIdac(void);
#endif

//-------------------------------------------------
// High level functions
//-------------------------------------------------
extern void CSDPLUS_UpdateSensorBaseline(BYTE bSensorNum);
extern BYTE CSDPLUS_bIsSensorActive(BYTE bSensorNum);
extern BYTE CSDPLUS_bIsAnySensorActive(void);
#if (CSDPLUS_BUTTONCOUNT)
extern void CSDPLUS_SetDefaultFingerThresholds(void);
#endif
extern void CSDPLUS_InitializeSensorBaseline(BYTE bSensorNum);
extern void CSDPLUS_InitializeBaselines(void);
extern void CSDPLUS_UpdateAllBaselines(void);
#if CSDPLUS_LINEAR_SLIDERS_EXIST
  extern WORD CSDPLUS_wGetCentroidPos(BYTE bSnsGroup);
#endif
#if CSDPLUS_RADIAL_SLIDERS_EXIST 
  extern WORD CSDPLUS_wGetRadialPos(BYTE bSnsGroup);
  extern WORD CSDPLUS_wGetRadialInc(BYTE bSnsGroup);
#endif

//-------------------------------------------------
// Register Addresses for CSDPLUS
//-------------------------------------------------
#pragma ioport  CSDPLUS_CapSense_CR0_REG:   0x0a0          // CS block control Register 0
BYTE            CSDPLUS_CapSense_CR0_REG;
#pragma ioport  CSDPLUS_CapSense_CR1_REG:   0x0a1          // CS block control Register 1
BYTE            CSDPLUS_CapSense_CR1_REG;
#pragma ioport  CSDPLUS_CapSense_CR2_REG:   0x0a2          // CS block control Register 2
BYTE            CSDPLUS_CapSense_CR2_REG;
#pragma ioport  CSDPLUS_CapSense_CR3_REG:   0x0a3          // CS block control Register 3
BYTE            CSDPLUS_CapSense_CR3_REG;
#pragma ioport  CSDPLUS_CapSense_STAT_REG:  0x0a6           // CS_Stat Register
BYTE            CSDPLUS_CapSense_STAT_REG;
#pragma ioport  CSDPLUS_CapSense_CNTH_REG:  0x0a5           // CapSense Counter MSB register
BYTE            CSDPLUS_CapSense_CNTH_REG;
#pragma ioport  CSDPLUS_CapSense_CNTL_REG:  0x0a4           // CapSense Counter LSB register
BYTE            CSDPLUS_CapSense_CNTL_REG;
#pragma ioport  CSDPLUS_CapSense_SLEW_REG:  0x0a8          
BYTE            CSDPLUS_CapSense_SLEW_REG;
#pragma ioport  CSDPLUS_CapSense_PRS_CR_REG:    0x0a9        // PRS control register
BYTE            CSDPLUS_CapSense_PRS_CR_REG;
#pragma ioport  CSDPLUS_CMP_CR0_REG:    0x07a                // Comparator Control register 0
BYTE            CSDPLUS_CMP_CR0_REG;
#pragma ioport  CSDPLUS_CMP_CR1_REG:    0x07b                // Comparator Control register 1
BYTE            CSDPLUS_CMP_CR1_REG;
#pragma ioport  CSDPLUS_CMP_MUX_REG:    0x079                // Comparator MUX register 
BYTE            CSDPLUS_CMP_MUX_REG;
#pragma ioport  CSDPLUS_P0_MUX_REG: 0x1d8                    // MUX_CR0 Register
BYTE            CSDPLUS_P0_MUX_REG;
#pragma ioport  CSDPLUS_P1_MUX_REG: 0x1d9                    // MUX_CR1 Register
BYTE            CSDPLUS_P1_MUX_REG;
#pragma ioport  CSDPLUS_P2_MUX_REG: 0x1da                    // MUX_CR2 Register
BYTE            CSDPLUS_P2_MUX_REG;
#pragma ioport  CSDPLUS_P3_MUX_REG: 0x1db                    // MUX_CR3 Register
BYTE            CSDPLUS_P3_MUX_REG;
#pragma ioport  CSDPLUS_P4_MUX_REG: 0x1df                    // MUX_CR4 Register
BYTE            CSDPLUS_P4_MUX_REG;
#pragma ioport  CSDPLUS_CapSense_TIMER_REG: 0x0a7            // Timer Data Register
BYTE            CSDPLUS_CapSense_TIMER_REG;
#pragma ioport  CSDPLUS_AMUX0_REG:  0x031                   // IDAC_0 (Compensation iDAC) register
BYTE            CSDPLUS_AMUX0_REG;
#pragma ioport  CSDPLUS_AMUX_REG:   0x0fd                    // IDAC_1 (Regular iDAC) register
BYTE            CSDPLUS_AMUX_REG;
#pragma ioport  CSDPLUS_AMUX_CR_REG:    0x061                // AMUX configuration Register
BYTE            CSDPLUS_AMUX_CR_REG;
#pragma ioport  CSDPLUS_CMP_RC_REG: 0x078                    // CMP_RDC Register
BYTE            CSDPLUS_CMP_RC_REG;
#pragma ioport  CSDPLUS_CMP_LUT_REG:    0x07c                // Comparator LUT register
BYTE            CSDPLUS_CMP_LUT_REG;
#pragma ioport  CSDPLUS_CONFIG_REG: 0x0b3                  // Timer config
BYTE            CSDPLUS_CONFIG_REG;
#pragma ioport  CSDPLUS_DATA_1_REG: 0x0b4                  // Timer Data Hi
BYTE            CSDPLUS_DATA_1_REG;
#pragma ioport  CSDPLUS_DATA_0_REG: 0x0b5                  // Timer Data Lo
BYTE            CSDPLUS_DATA_0_REG;
#endif
