;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME:   CSDPLUS.inc
;;   Version: 1.10, Updated on 2012/9/21 at 11:58:32
;;  Generated by PSoC Designer 5.3.2710
;;
;;  DESCRIPTION:
;;    Assembler declarations for the CSDPLUS user module interface.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "GlobalParams.inc"

; This part of code is used to determine whether the wizards was called
; after place, rename or update operation
CSDPLUS_WIZARD_PROCESSED:                   equ 1
IF CSDPLUS_WIZARD_PROCESSED^1
"Wizard_was_not_called_after_place_rename_or_update_Open_Chip_Editor_open_Wizard_press_OK_button_and_generate_project"
ENDIF

CSDPLUS_CAPACITOR_PIN:                 equ 2h
CSDPLUS_CAPACITOR_NONE:                equ 00h
CSDPLUS_CAPACITOR_P0_1:                equ 01h
CSDPLUS_CAPACITOR_P0_3:                equ 02h

CSDPLUS_AUTORESET:                     equ 0
CSDPLUS_DIPLEXUSED:                    equ 0
;--------------------------------------------------
; Constants for AutoCalibration 
;--------------------------------------------------
CSDPLUS_AUTOCAL_ENABLE:                equ 1
CSDPLUS_IDAC_CALIBRATION_MSB:          equ 0dh
CSDPLUS_IDAC_CALIBRATION_LSB:          equ 99h
CSDPLUS_CALIBRATION_RESOLUTION:        equ 12

; delay constant for 9 cycles, generated by .JS file
CSDPLUS_SETTLING_DELAY:                equ 50h  ; 30uS delay

;--------------------------------------------------
; Flag Constants  
;--------------------------------------------------
CSDPLUS_BUTTON_PRESSED:                equ 01h
CSDPLUS_ADC_STATUS:                    equ 02h
CSDPLUS_CALIBRATION_FLAG:              equ 04h
;CSDPLUS_INITIALIZATION_FLAG:          equ 04h

;--------------------------------------------------
; Constants for CSDPLUS_Start function
;--------------------------------------------------
CSDPLUS_AMUX_CR_INIT:                  equ CSDPLUS_CAPACITOR_PIN 
CSDPLUS_CS_CR2_INIT:                   equ 04h
CSDPLUS_CS_CR3_INIT:                   equ 70h  
CSDPLUS_SPLITIDAC_MASK:                equ 80h  

;--------------------------------------------------
; Constants for Scan Speed values
;--------------------------------------------------
CSDPLUS_SCANNING_SPEED:                equ 2h
CSDPLUS_ULTRA_FAST_SPEED:              equ 00h
CSDPLUS_FAST_SPEED:                    equ 01h
CSDPLUS_NORMAL_SPEED:                  equ 02h
CSDPLUS_SLOW_SPEED:                    equ 03h

;--------------------------------------------------
; Constants for Prescaler values
;--------------------------------------------------
CSDPLUS_PRESCALER:                     equ 1h
CSDPLUS_PRESCALER_1:                   equ 00h
CSDPLUS_PRESCALER_2:                   equ 01h
CSDPLUS_PRESCALER_4:                   equ 02h
CSDPLUS_PRESCALER_8:                   equ 03h
CSDPLUS_PRESCALER_16:                  equ 04h
CSDPLUS_PRESCALER_32:                  equ 05h
CSDPLUS_PRESCALER_64:                  equ 06h
CSDPLUS_PRESCALER_128:                 equ 07h
CSDPLUS_PRESCALER_256:                 equ 08h

;--------------------------------------------------
; Constants for Resolution values
;--------------------------------------------------
CSDPLUS_MIN_RESOLUTION:                equ 9
CSDPLUS_9_BIT_RESOLUTION:              equ 9
CSDPLUS_10_BIT_RESOLUTION:             equ 10
CSDPLUS_11_BIT_RESOLUTION:             equ 11
CSDPLUS_12_BIT_RESOLUTION:             equ 12
CSDPLUS_13_BIT_RESOLUTION:             equ 13
CSDPLUS_14_BIT_RESOLUTION:             equ 14
CSDPLUS_15_BIT_RESOLUTION:             equ 15
CSDPLUS_16_BIT_RESOLUTION:             equ 16
CSDPLUS_MAX_RESOLUTION:                equ 16
CSDPLUS_RESOLUTION:                    equ ch

;--------------------------------------------------
; Constants for Precharge clock source values
;--------------------------------------------------
CSDPLUS_PRCH_SRC:                      equ 20h
CSDPLUS_PRCH_IMO_P:                    equ 00h
CSDPLUS_PRCH_PRS:                      equ 20h

;--------------------------------------------------
; Constants for PRS values
;--------------------------------------------------
CSDPLUS_PRS_RES:                       equ 0h
CSDPLUS_PRCH_PRS8:                     equ 00h
CSDPLUS_PRCH_PRS12:                    equ 20h

;--------------------------------------------------
; Constants for CSDPLUS API's
;--------------------------------------------------
CSDPLUS_BUTTONCOUNT:                   equ 1h
CSDPLUS_SLIDERCOUNT:                   equ 0h  + 0h
CSDPLUS_TOTALSENSORCOUNT:              equ 1h
CSDPLUS_SLIDERS_EXIST:                 equ 0h | 0h
CSDPLUS_LINEAR_SLIDERS_EXIST:          equ 0h
CSDPLUS_RADIAL_SLIDERS_EXIST:          equ 0h
CSDPLUS_HYSTERESIS:                    equ 8h
CSDPLUS_DEBOUNCE:                      equ 3h
CSDPLUS_LOWBASELINERESET:              equ 32h
CSDPLUS_FINGER_THRESHOLD:              equ 20h
CSDPLUS_NOISE_THRESHOLD:               equ 14h
CSDPLUS_NEGATIVE_NOISE_THRESHOLD:      equ 14h
CSDPLUS_BASELINE_UPDATE_THRESHOLD:     equ 32h

CSDPLUS_IDAC:                          equ 14h
CSDPLUS_COMPIDAC:                      equ 0h
CSDPLUS_PRESCALER:                     equ 1h

CSDPLUS_INT_REG:                       equ 0x0df
CSDPLUS_INT_MASK:                      equ 0x01

;; Definitions below are for consistency with old CapSense UMs
;; Not Recommended for using in new designs 
CSDPLUS_DiplexUsed:                    equ 0
CSDPLUS_ButtonCount:                   equ 1h
CSDPLUS_SliderCount:                   equ 0h  + 0h
CSDPLUS_TotalSensorCount:              equ 1h  
CSDPLUS_Debounce:                      equ 3h
CSDPLUS_LowBaselineReset:              equ 32h
;; End of old definitions

;--------------------------------------------------
; Registers Address Constants for CSDPLUS
;--------------------------------------------------
CSDPLUS_CapSense_CR0_REG:                        equ a0h              ; CS_CR0 Reg
CSDPLUS_CapSense_CR1_REG:                        equ a1h              ; CS_CR1 Reg
CSDPLUS_CapSense_CR2_REG:                        equ a2h              ; CS_CR2 Reg
CSDPLUS_CapSense_CR3_REG:                        equ a3h              ; CS_CR3 Reg
CSDPLUS_CapSense_CNTH_REG:                       equ a5h              ; CS_Counter Reg
CSDPLUS_CapSense_CNTL_REG:                       equ a4h              ; CS_Counter Reg
CSDPLUS_CapSense_STAT_REG:                       equ a6h              ; CS_Stat Reg
CSDPLUS_CapSense_PRS_CR_REG:                     equ a9h              ; PRS_CR Reg
CSDPLUS_CONFIG_REG:                              equ b3h              ; Timer Control register
CSDPLUS_CMP_CR0_REG:                             equ 7ah              ; CMP_CR0 Reg
CSDPLUS_CMP_CR1_REG:                             equ 7bh              ; CMP_CR1 Reg
CSDPLUS_CMP_MUX_REG:                             equ 79h              ; CMP_MUX Reg
CSDPLUS_P0_MUX_REG:                              equ d8h              ; MUX_CR0 Reg
CSDPLUS_P1_MUX_REG:                              equ d9h              ; MUX_CR1 Reg
CSDPLUS_P2_MUX_REG:                              equ dah              ; MUX_CR2 Reg
CSDPLUS_P3_MUX_REG:                              equ dbh              ; MUX_CR3 Reg
CSDPLUS_P4_MUX_REG:                              equ dfh              ; MUX_CR4 Reg
CSDPLUS_CapSense_TIMER_REG:                      equ a7h              ; CS_TIMER Reg
CSDPLUS_IDAC_0_REG:                              equ 31h              ; IDAC_0 Reg
CSDPLUS_IDAC_1_REG:                              equ fdh              ; IDAC_1 Reg
CSDPLUS_AMUX_CR_REG:                             equ 61h              ; AMUX_CFG Reg
CSDPLUS_CMP_RC_REG:                              equ 78h              ; CMP_RDC Reg
CSDPLUS_CMP_LUT_REG:                             equ 7ch              ; CMP_LUT Reg
CSDPLUS_CONFIG_REG:                              equ b3h              ; Timer Control register
CSDPLUS_DATA0_REG:                               equ b5h              ; Timer Data Lo Reg
CSDPLUS_DATA1_REG:                               equ b4h              ; Timer Data Hi Reg
CSDPLUS_DR_OFFSET:                               equ 00h
CSDPLUS_DM0_OFFSET:                              equ 00h              ; Bank 1
CSDPLUS_DM1_OFFSET:                              equ 01h              ; Bank 1
; end of file CSDPLUS.inc
