
#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include "filter.h"

// I2C buffer structure
struct I2C_Regs
{
    BYTE Index;
	
	
	int RawCount;
	int Baseline;
	int DiffCount;
	
	
}MyI2C_Regs;

WORD Average_value[CSDPLUS_TotalSensorCount];

void main(void)
{	
	BYTE i;
	
	M8C_EnableGInt; //Enable global interrupt
	
	//Set up RAM buffer
	EzI2Cs_SetRamBuffer(sizeof(MyI2C_Regs),1,(BYTE *)&MyI2C_Regs);
	EzI2Cs_Start(); //Turn ON I2C
	
	
	// start the CSDPLUS module and initialize the baselines.
	
	CSDPLUS_Start();
	CSDPLUS_SetDefaultFingerThresholds();
	CSDPLUS_InitializeBaselines();
	
	while(1)
	{			
		// scan the sensor and filter the rawcounts.
		//The filters can be enabled or disabled in the filter.h file.
		
	  for(i=0;i<CSDPLUS_TotalSensorCount;i++)
	  { 
	  CSDPLUS_ScanSensor(i);
	  
	   // First apply the median filter,then apply the averaging and IIR filters.
	   
		if(MEDIAN_FILTER_ENABLE)
		      CSDPLUS_waSnsResult[i] = ApplyMedianfilter(CSDPLUS_waSnsResult[i]);
			  
	    if(AVERAGE_FILTER_ENABLE)		  
	         {
			  Average_value[i] = ApplyAveragingFilter(i);
			  CSDPLUS_waSnsResult[i]=Average_value[i];
			 }
			 
		 if(IIR_FILTER_ENABLE)	 
	            CSDPLUS_waSnsResult[i] = ApplyIIRFilter(i,CSDPLUS_waSnsResult[i]);
				
	    CSDPLUS_UpdateSensorBaseline(i); 
		
		// If the wire sensor is active, turn on the board LED or else turn it off.
		
		if(CSDPLUS_bIsSensorActive(MyI2C_Regs.Index))
		  LED_On();
		 else
		  LED_Off();
	   }
		
	    EzI2Cs_DisableInt(); //Disable I2C interrupt while the buffer is being updated		
		
		// send the sensor parameters such as rawcount and baseline to the EZI2C host
		
		if(!(EzI2Cs_bBusy_Flag == EzI2Cs_I2C_BUSY_RAM_READ))
		{			
		   MyI2C_Regs.RawCount = CSDPLUS_waSnsResult[MyI2C_Regs.Index]; // Storing Sensor RawCounts
		   MyI2C_Regs.Baseline = CSDPLUS_waSnsBaseline[MyI2C_Regs.Index]; // Storing Sensor Baseline
		   MyI2C_Regs.DiffCount = CSDPLUS_waSnsDiff[MyI2C_Regs.Index]; // Storing Sensor DiffCounts
		   
			
		}		
		EzI2Cs_ResumeInt(); //Re-enable the I2C interrupt
	}
}


	













