//*****************************************************************************
//*****************************************************************************
//  FILENAME: EzI2Cs_1.h
//   Version: 1.40, Updated on 2012/3/2 at 9:10:28
//  Generated by PSoC Designer 5.2.2551
//
//  DESCRIPTION: EzI2Cs User Module C Language interface file
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef EzI2Cs_1_INCLUDE
#define EzI2Cs_1_INCLUDE

#include <m8c.h>

#define EzI2Cs_1_SLAVE_ADDR              0x4
#define EzI2Cs_1_DYNAMIC_ADDR            0
#define EzI2Cs_1_ROM_ENABLE              0
#define EzI2Cs_1_HW_ADDR_REC             0
#define EzI2Cs_1_CY8C20xx7               1

/* Create pragmas to support proper argument and return value passing */
#pragma fastcall16  EzI2Cs_1_Start
#pragma fastcall16  EzI2Cs_1_DisableInt
#pragma fastcall16  EzI2Cs_1_EnableInt
#pragma fastcall16  EzI2Cs_1_ResumeInt
#pragma fastcall16  EzI2Cs_1_Stop
#pragma fastcall16  EzI2Cs_1_DisableSlave
#pragma fastcall16  EzI2Cs_1_SetRamBuffer
#pragma fastcall16  EzI2Cs_1_GetAddr
#pragma fastcall16  EzI2Cs_1_GetActivity

#if ( EzI2Cs_1_DYNAMIC_ADDR )
#pragma fastcall16  EzI2Cs_1_SetAddr
#endif

#if ( EzI2Cs_1_ROM_ENABLE )
#pragma fastcall16  EzI2Cs_1_SetRomBuffer
#endif

#if ( EzI2Cs_1_CY8C20xx7 )
#pragma fastcall16  EzI2Cs_1_SetAutoNACK
#pragma fastcall16  EzI2Cs_1_ClearAutoNACK
#pragma fastcall16  EzI2Cs_1_bCheckStatus
#endif
//-------------------------------------------------
// Constants for EzI2Cs_1_bBusy_Flag
//-------------------------------------------------
//
//
#define EzI2Cs_1_I2C_FREE                0x00    // No transaction at the current moment
#define EzI2Cs_1_I2C_BUSY_RAM_READ       0x01    // RAM read transaction in progress
#define EzI2Cs_1_I2C_BUSY_RAM_WRITE      0x02    // RAM write transaction in progress
#define EzI2Cs_1_I2C_BUSY_ROM_READ       0x04    // ROM read transaction in progress
#define EzI2Cs_1_I2C_BUSY_ROM_WRITE      0x08    // ROM write transaction in progress

//-------------------------------------------------
// Constants for EzI2Cs_1 API's.
//-------------------------------------------------
//
//
#define EzI2Cs_1_ACTIVITY_MASK   0xB0
#define EzI2Cs_1_ANY_ACTIVITY    0x80
#define EzI2Cs_1_READ_ACTIVITY   0x20
#define EzI2Cs_1_WRITE_ACTIVITY  0x10

#if ( EzI2Cs_1_CY8C20xx7 )
//For EzI2Cs_1_bCheckStatus
#define  EzI2Cs_1_BUS_BUSY                        0x80 // This bit will be SET only if there is an ongoing I2C traffic on bus 
#define  EzI2Cs_1_AUTO_NACK_ON                    0x04 // This bit will be SET only if auto NACK feature is activated by I2C block
#define  EzI2Cs_1_LAST_TX_RD                      0x20 // This bit will be SET if last I2C transaction by host is a read operation
#define  EzI2Cs_1_LAST_TX_WR                      0x40 // This bit will be SET if last I2C transaction by host is a write operation
#endif

// #pragma  ioport   I2C_XCFG:   0x0C8   // I2C Extended Configuration Register
// BYTE              I2C_XCFG;

#pragma ioport  EzI2Cs_1_XCFG_REG:  0x0c8                  // I2C HW Extended Configuration Register (I2C_XCFG)
BYTE            EzI2Cs_1_XCFG_REG;
#pragma ioport  EzI2Cs_1_ADDR_REG:  0x0ca                  // I2C HW Extended Addres Register (I2C_ADDR)
BYTE            EzI2Cs_1_ADDR_REG;

//-------------------------------------------------
// Prototypes of the EzI2Cs_1 API.
//-------------------------------------------------
extern void  EzI2Cs_1_Start(void);                                         // Proxy Class 1, if Static Address
                                                                                   // Proxy Class 4, if Dynamic Address
extern void  EzI2Cs_1_DisableInt(void);                                    // Proxy Class 1
extern void  EzI2Cs_1_EnableInt(void);                                     // Proxy Class 1
extern void  EzI2Cs_1_ResumeInt(void);                                     // Proxy Class 1
extern void  EzI2Cs_1_Stop(void);                                          // Proxy Class 1
extern void  EzI2Cs_1_DisableSlave(void);                                  // Proxy Class 1
extern void  EzI2Cs_1_SetRamBuffer(BYTE bSize, BYTE bRWBoundary, BYTE * pAddr); // Proxy Class 4 
extern BYTE  EzI2Cs_1_GetAddr(void);                                       // Proxy Class 4
extern BYTE  EzI2Cs_1_GetActivity(void);                                   // Proxy Class 4

#if ( EzI2Cs_1_DYNAMIC_ADDR )
extern void  EzI2Cs_1_SetAddr(BYTE bAddr);                                 // Proxy Class 4
#endif

#if ( EzI2Cs_1_ROM_ENABLE )
extern void  EzI2Cs_1_SetRomBuffer(BYTE bSize, const BYTE * pAddr);        // Proxy Class 4
#endif

#if ( EzI2Cs_1_CY8C20xx7 )
extern void  EzI2Cs_1_SetAutoNACK(void);
extern void  EzI2Cs_1_ClearAutoNACK(void);
extern BYTE  EzI2Cs_1_bCheckStatus(void);
#endif

//-------------------------------------------------
// Define global variables.                 
//-------------------------------------------------
#if ( EzI2Cs_1_DYNAMIC_ADDR & ~EzI2Cs_1_HW_ADDR_REC)
extern   BYTE   EzI2Cs_1_bAddr;                                            // Proxy Class 1
#endif

extern   BYTE   EzI2Cs_1_bBusy_Flag;

#endif
