//*****************************************************************************
//*****************************************************************************
//  FILENAME: SmartSense.h
//   Version: 1.00, Updated on 2012/3/2 at 9:15:19
//  Generated by PSoC Designer 5.3.2710
//
//  DESCRIPTION: SmartSense_EMCplus User Module C Language interface file
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
//*****************************************************************************
#ifndef SmartSense_INCLUDE
#define SmartSense_INCLUDE

#include <m8c.h>

//--------------------------------------------------
// Constants for SmartSense
//--------------------------------------------------
#if (0x5)
#define SmartSense_TOTALSENSORCOUNT               0x5
#else
#define SmartSense_TOTALSENSORCOUNT               1
#endif
#define SmartSense_BUTTONCOUNT                    0x0
#define SmartSense_SLIDERCOUNT                    0x1 + 0x0
#define SmartSense_PROXIMITYCOUNT                 0x0

#define SmartSense_BUTTONS_EXIST                  0x0
#define SmartSense_SLIDERS_EXIST                  0x1 | 0x0
#define SmartSense_LIN_SLIDERS_EXIST              0x1
#define SmartSense_ROT_SLIDERS_EXIST              0x0

#define SmartSense_AUTOCAL_ENABLE                 0x2
#define SmartSense_AUTOCAL_NONE                   0x00
#define SmartSense_AUTOCAL_AUTORANGE              0x01
#define SmartSense_AUTOCAL_FULL                   0x02
#define SmartSense_AUTO_THRESHOLD_ENABLED         0x1

#define SmartSense_IMMUNITY_LEVEL                 1

//--------------------------------------------------
// Constants for Scan Speed values
//--------------------------------------------------
#define SmartSense_ULTRA_FAST_SPEED               0x00
#define SmartSense_FAST_SPEED                     0x01
#define SmartSense_NORMAL_SPEED                   0x02
#define SmartSense_SLOW_SPEED                     0x03
#define SmartSense_SCANNING_SPEED                 0x2

//--------------------------------------------------
// Constants for Prescaler values
//--------------------------------------------------
#define SmartSense_PRESCALER                      0x1
#define SmartSense_PRESCALER_1                    0x00
#define SmartSense_PRESCALER_2                    0x01
#define SmartSense_PRESCALER_4                    0x02
#define SmartSense_PRESCALER_8                    0x03
#define SmartSense_PRESCALER_16                   0x04
#define SmartSense_PRESCALER_32                   0x05
#define SmartSense_PRESCALER_64                   0x06
#define SmartSense_PRESCALER_128                  0x07
#define SmartSense_PRESCALER_256                  0x08

//--------------------------------------------------
// Constants for Resolution values
//--------------------------------------------------
#define SmartSense_RESOLUTION                    0xc
#define SmartSense_PROXIMITY_RESOLUTION          16

// Definitions below are for consistency with old CapSense UMs
// Not Recommended for using in new designs 
#define SmartSense_TotalSensorCount               0x5
#define SmartSense_ButtonCount                    0x0
#define SmartSense_SliderCount                    0x1 + 0x0 
#define SmartSense_ProximityCount                 0x0
//End of old definitions

//--------------------------------------------------
// Variables for SmartSense.
//--------------------------------------------------

extern WORD SmartSense_waSnsResult[];
extern WORD SmartSense_waSnsBaseline[];
extern WORD SmartSense_waSnsDiff[];
extern BYTE SmartSense_baSnsOnMask[];
extern BYTE SmartSense_baDAC[];
extern BYTE SmartSense_baCompensationDAC[];
extern BYTE SmartSense_baSnsSignal[];

extern BYTE baPrescaler[];
extern BYTE baN[];
extern BYTE baSpeed[];
extern BYTE baK[];
extern BYTE baSensorSensitivity[];
extern BYTE baNoiseEnvelope[];
extern WORD waPreviousSample[];
extern BYTE baNoiseResetCounter[];
extern BYTE baSignRegister[];
extern BYTE baRunningDifference[];
extern WORD waSampleMin[];
extern WORD waSampleMax[];
extern BYTE baNoiseThreshold[];
extern BYTE baBtnFThreshold[];

extern BYTE SmartSense_bLowBaselineReset;
extern BYTE SmartSense_bHysteresis;
extern BYTE SmartSense_bNoiseThreshold;
extern BYTE SmartSense_bNegativeNoiseThreshold;
extern BYTE SmartSense_bBaselineUpdateThreshold;
extern BYTE SmartSense_bHysteresis;
extern BYTE SmartSense_bDebounce;


// Low Level scan API
#pragma fastcall16 SmartSense_Start
#pragma fastcall16 SmartSense_Stop
#pragma fastcall16 SmartSense_Resume
#pragma fastcall16 SmartSense_ScanSensor
#pragma fastcall16 SmartSense_ScanAllSensors
#pragma fastcall16 SmartSense_ClearSensors
#pragma fastcall16 SmartSense_wReadSensor
#pragma fastcall16 SmartSense_wGetPortPin
#pragma fastcall16 SmartSense_EnableSensor
#pragma fastcall16 SmartSense_DisableSensor


// High Level API
#pragma fastcall16 SmartSense_UpdateSensorBaseline
#pragma fastcall16 SmartSense_UpdateSensorSignal
#pragma fastcall16 SmartSense_bIsSensorActive
#pragma fastcall16 SmartSense_bIsAnySensorActive
#pragma fastcall16 SmartSense_InitializeSensorBaseline
#pragma fastcall16 SmartSense_InitializeBaselines
#pragma fastcall16 SmartSense_UpdateAllBaselines
#pragma fastcall16 SmartSense_wGetCentroidPos
#pragma fastcall16 SmartSense_wGetRadialPos
#pragma fastcall16 SmartSense_wGetRadialInc

//-------------------------------------------------
// C prototypes of the SmartSense API.
//-------------------------------------------------

//-------------------------------------------------
// Low Level scan API
//-------------------------------------------------

extern void SmartSense_Start(void);
extern void SmartSense_Stop(void);
extern void SmartSense_Resume(void);
extern void SmartSense_ScanSensor(BYTE bSensor);
extern void SmartSense_ScanAllSensors(void);
extern void SmartSense_ClearSensors(void);
extern WORD SmartSense_wReadSensor(BYTE bSensor);
extern WORD SmartSense_wGetPortPin(BYTE bSensor);
extern void SmartSense_EnableSensor(BYTE bMask, BYTE bPort);
extern void SmartSense_DisableSensor(BYTE bMask, BYTE bPort);

//-------------------------------------------------
// High level functions
//-------------------------------------------------

extern void SmartSense_UpdateSensorBaseline(BYTE bSensorNum);
extern BYTE SmartSense_UpdateSensorSignal(BYTE bSensorNum);
extern BYTE SmartSense_bIsSensorActive(BYTE bSensorNum);
extern BYTE SmartSense_bIsAnySensorActive(void);
extern void SmartSense_InitializeSensorBaseline(BYTE bSensorNum);
extern void SmartSense_InitializeBaselines(void);
extern void SmartSense_UpdateAllBaselines(void);
#if SmartSense_LIN_SLIDERS_EXIST
  extern WORD SmartSense_wGetCentroidPos(BYTE bSnsGroup);
#endif  
#if SmartSense_ROT_SLIDERS_EXIST
  extern WORD SmartSense_wGetRadialPos(BYTE bSnsGroup);
  extern WORD SmartSense_wGetRadialInc(BYTE bSnsGroup);   
#endif

//-------------------------------------------------
// Register Addresses for SmartSense
//-------------------------------------------------
#pragma ioport  SmartSense_CapSense_CR0_REG:    0x0a0      // CS block control Register 0
BYTE            SmartSense_CapSense_CR0_REG;
#pragma ioport  SmartSense_CapSense_CR1_REG:    0x0a1      // CS block control Register 1
BYTE            SmartSense_CapSense_CR1_REG;
#pragma ioport  SmartSense_CapSense_CR2_REG:    0x0a2      // CS block control Register 2
BYTE            SmartSense_CapSense_CR2_REG;
#pragma ioport  SmartSense_CapSense_CR3_REG:    0x0a3      // CS block control Register 3
BYTE            SmartSense_CapSense_CR3_REG;
#pragma ioport  SmartSense_CapSense_STAT_REG:   0x0a6      
BYTE            SmartSense_CapSense_STAT_REG;
#pragma ioport  SmartSense_CapSense_CNTH_REG:   0x0a5      
BYTE            SmartSense_CapSense_CNTH_REG;
#pragma ioport  SmartSense_CapSense_CNTL_REG:   0x0a4      
BYTE            SmartSense_CapSense_CNTL_REG;
#pragma ioport  SmartSense_CapSense_SLEW_REG:   0x0a8      
BYTE            SmartSense_CapSense_SLEW_REG;
#pragma ioport  SmartSense_CapSense_PRS_CR_REG: 0x0a9      
BYTE            SmartSense_CapSense_PRS_CR_REG;
#pragma ioport  SmartSense_CMP_CR0_REG: 0x07a              
BYTE            SmartSense_CMP_CR0_REG;
#pragma ioport  SmartSense_CMP_CR1_REG: 0x07b              
BYTE            SmartSense_CMP_CR1_REG;
#pragma ioport  SmartSense_CMP_MUX_REG: 0x079              
BYTE            SmartSense_CMP_MUX_REG;
#pragma ioport  SmartSense_P0_MUX_REG:  0x1d8              
BYTE            SmartSense_P0_MUX_REG;
#pragma ioport  SmartSense_P1_MUX_REG:  0x1d9              
BYTE            SmartSense_P1_MUX_REG;
#pragma ioport  SmartSense_P2_MUX_REG:  0x1da              
BYTE            SmartSense_P2_MUX_REG;
#pragma ioport  SmartSense_P3_MUX_REG:  0x1db              
BYTE            SmartSense_P3_MUX_REG;
#pragma ioport  SmartSense_P4_MUX_REG:  0x1df              
BYTE            SmartSense_P4_MUX_REG;
#pragma ioport  SmartSense_CONFIG_REG:  0x0b3              // Timer config
BYTE            SmartSense_CONFIG_REG;
#pragma ioport  SmartSense_DATA_1_REG:  0x0b4              // Timer Data Hi
BYTE            SmartSense_DATA_1_REG;
#pragma ioport  SmartSense_DATA_0_REG:  0x0b5              // Timer Data Lo
BYTE            SmartSense_DATA_0_REG;

#endif
