;;*****************************************************************************
;;  FILENAME: SmartSenseHL.asm
;;   Version: 1.00, Updated on 2012/3/2 at 9:15:19
;;  Generated by PSoC Designer 5.3.2710
;;  DESCRIPTION: SmartSense_EMCplus User Module high level software
;;                implementation file.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "SmartSense.inc"

;-----------------------------------------------
; Global Symbols
;-----------------------------------------------

export _SmartSense_UpdateSensorBaseline
export  SmartSense_UpdateSensorBaseline
export  UpdateSingleSensorBaseline
export _SmartSense_InitializeSensorBaseline
export  SmartSense_InitializeSensorBaseline
export _SmartSense_bIsSensorActive
export  SmartSense_bIsSensorActive
export _SmartSense_bIsAnySensorActive
export  SmartSense_bIsAnySensorActive
export _SmartSense_InitializeBaselines
export  SmartSense_InitializeBaselines
export _SmartSense_UpdateAllBaselines
export  SmartSense_UpdateAllBaselines

IF (SmartSense_AUTO_THRESHOLD_ENABLED)
ELSE
export  SmartSense_LoadFixedParameters
ENDIF

export ProcessData
export _SmartSense_ProcessData
export  SmartSense_ProcessData

IF SmartSense_LIN_SLIDERS_EXIST
export _SmartSense_wGetCentroidPos
export  SmartSense_wGetCentroidPos
ENDIF
IF SmartSense_ROT_SLIDERS_EXIST
export _SmartSense_wGetRadialPos
export  SmartSense_wGetRadialPos
export _SmartSense_wGetRadialInc
export  SmartSense_wGetRadialInc
ENDIF

IF (SmartSense_AUTO_THRESHOLD_ENABLED)
ELSE
export _SmartSense_SetDefaultFingerThreshold
export  SmartSense_SetDefaultFingerThreshold
ENDIF
export _SmartSense_UpdateSensorSignal
export  SmartSense_UpdateSensorSignal

IF (SmartSense_IMMUNITY_LEVEL / 2)
export MedianFilter
export _SmartSense_MedianFilter
export  SmartSense_MedianFilter
ENDIF

export ProcessDiff
export _SmartSense_ProcessDiff
export  SmartSense_ProcessDiff


export _SmartSense_bNoiseThreshold
export  SmartSense_bNoiseThreshold
export _SmartSense_bNegativeNoiseThreshold
export  SmartSense_bNegativeNoiseThreshold
export _SmartSense_bBaselineUpdateThreshold
export  SmartSense_bBaselineUpdateThreshold
export _SmartSense_bHysteresis
export  SmartSense_bHysteresis
export _SmartSense_bDebounce
export  SmartSense_bDebounce
export _SmartSense_bLowBaselineReset
export  SmartSense_bLowBaselineReset

; Global variables
export _waSnsBaseline
export  waSnsBaseline
export _SmartSense_waSnsBaseline
export  SmartSense_waSnsBaseline
export _waSnsDiff
export _SmartSense_waSnsDiff
export  SmartSense_waSnsDiff
export _SmartSense_waDiffCountHoppChannel
export  SmartSense_waDiffCountHoppChannel

export _baBtnFThreshold
export _SmartSense_baBtnFThreshold
export  SmartSense_baBtnFThreshold

export _SmartSense_baSnsOnMask
export  SmartSense_baSnsOnMask

export _SmartSense_baSnsDebounce
export  SmartSense_baSnsDebounce

export _SmartSense_baLowBaselineReset
export  SmartSense_baLowBaselineReset

export _SmartSense_baSnsSignal
export  SmartSense_baSnsSignal

; Local variables
export _SmartSense_fIsPressed
export  SmartSense_fIsPressed
export _SmartSense_bCurPos
export  SmartSense_bCurPos

export _SmartSense_wCurPkValue
export  SmartSense_wCurPkValue
export _SmartSense_bCurPkPos
export  SmartSense_bCurPkPos
export _SmartSense_wDenom
export  SmartSense_wDenom
export _SmartSense_dMultTempX
export  SmartSense_dMultTempX
export _SmartSense_dMultTempY
export  SmartSense_dMultTempY

IF SmartSense_SLIDERS_EXIST
; Slider variables
export _SmartSense_bEndOfArray
export  SmartSense_bEndOfArray
export _SmartSense_bSnsMaskPtr
export  SmartSense_bSnsMaskPtr
export _SmartSense_wCtrdPos
export  SmartSense_wCtrdPos
export _SmartSense_dNumer
export  SmartSense_dNumer
export _SmartSense_bCurCtrdStartPos
export  SmartSense_bCurCtrdStartPos
export _SmartSense_bCurCtrdSize
export  SmartSense_bCurCtrdSize
export _SmartSense_bBiggestCtrdStartPos
export  SmartSense_bBiggestCtrdStartPos
export _SmartSense_bBiggestCtrdSize
export  SmartSense_bBiggestCtrdSize
export _SmartSense_bDiplexMSB
export  SmartSense_bDiplexMSB
export _SmartSense_bDiplexLSB
export  SmartSense_bDiplexLSB
export _SmartSense_wDivBtwSns
export  SmartSense_wDivBtwSns
ENDIF

export  wX1
export _SmartSense_wX1
export  SmartSense_wX1
IF (SmartSense_IMMUNITY_LEVEL / 2)
export  wX2
export _SmartSense_wX2
export  SmartSense_wX2
export  wX3
export _SmartSense_wX3
export  SmartSense_wX3
ENDIF

;-----------------------------------------------
; Variable Allocation
;-----------------------------------------------
AREA InterruptRAM (RAM, REL, CON)

_SmartSense_bNoiseThreshold:
 SmartSense_bNoiseThreshold:            BLK  1
_SmartSense_bNegativeNoiseThreshold:
 SmartSense_bNegativeNoiseThreshold:    BLK  1
_SmartSense_bBaselineUpdateThreshold:
 SmartSense_bBaselineUpdateThreshold:   BLK  1
_SmartSense_bHysteresis:
 SmartSense_bHysteresis:                BLK  1
_SmartSense_bDebounce:
 SmartSense_bDebounce:                  BLK  1
_SmartSense_bLowBaselineReset:
 SmartSense_bLowBaselineReset:          BLK  1

_SmartSense_fIsPressed:                                ; Temp variable for if any sensor is pressed
 SmartSense_fIsPressed:                 BLK  1
_SmartSense_bCurPos:                                   ; Temp position variable
 SmartSense_bCurPos:                    BLK  1
_SmartSense_wTmpBtnFThreshold:                         ; Temp Difference
 SmartSense_wTmpBtnFThreshold:          BLK  2
 
_SmartSense_wDenom:                                    ; Denominator is also the Ctrd Pos
 SmartSense_wDenom:                     BLK  2 
_SmartSense_dMultTempX:                                ; Temp multiplication register
 SmartSense_dMultTempX:                 BLK  4
_SmartSense_dMultTempY:                                ; Temp multiplication register
 SmartSense_dMultTempY:                 BLK  4
_SmartSense_bCurPkPos:                                 ; Temp current slider pointer
 SmartSense_bCurPkPos:                  BLK  1 
_SmartSense_wCurPkValue:                               ; Temp current peak
 SmartSense_wCurPkValue:                BLK  2
 
IF SmartSense_SLIDERS_EXIST
; Slider variables
_SmartSense_bEndOfArray:                               ; Temp pointer variable
 SmartSense_bEndOfArray:                BLK  1
_SmartSense_bSnsMaskPtr:                               ; Temp sensor mask pointer used in centroid calculation
 SmartSense_bSnsMaskPtr:                BLK  1 
_SmartSense_bStartIndex:                               ; Temp Start index
 SmartSense_bStartIndex:                BLK  1 
_SmartSense_dNumer:                                    ; Numerator also contains the Ctrd Pos
 SmartSense_dNumer:                     BLK  2
_SmartSense_wCtrdPos:                                  ; Ctrd Pos is LMSB and LLSB of the numerator
 SmartSense_wCtrdPos:                   BLK  2
_SmartSense_bCurSlider:
 SmartSense_bCurSlider:                 BLK  1
_SmartSense_bCurCtrdStartPos:                          ; Temp current centroid start position
 SmartSense_bCurCtrdStartPos:           BLK  1
_SmartSense_bCurCtrdSize:                              ; Temp current centroid size
 SmartSense_bCurCtrdSize:               BLK  1
_SmartSense_bBiggestCtrdStartPos:                      ; Temp biggest centroid start position
 SmartSense_bBiggestCtrdStartPos:       BLK  1
_SmartSense_bBiggestCtrdSize:                          ; Temp biggest centroid size
 SmartSense_bBiggestCtrdSize:           BLK  1
_SmartSense_bDiplexInfo:                               ; Temp flag for diplex of current group
 SmartSense_bDiplexInfo:                BLK  1
_SmartSense_bDiplexMSB:                                ; Temp that contains the address of the rom diplex table
 SmartSense_bDiplexMSB:                 BLK  1
_SmartSense_bDiplexLSB:
 SmartSense_bDiplexLSB:                 BLK  1
_SmartSense_wDivBtwSns:                                ; Temp divisions between sensors
 SmartSense_wDivBtwSns:                 BLK  2
_SmartSense_waCentroid:                                 ;array of Centroid and  two adjacent values (word array)
 SmartSense_waCentroid:                 BLK  6
ENDIF

 wX1:
_SmartSense_wX1:
 SmartSense_wX1:                        BLK  2  ; Temp Median Filter variable
IF (SmartSense_IMMUNITY_LEVEL / 2)
 wX2:
_SmartSense_wX2:
 SmartSense_wX2:                        BLK  2   ; Temp Median Filter variable
 wX3:
_SmartSense_wX3:
 SmartSense_wX3:                        BLK  2   ; Temp Median Filter variable
ENDIF

; Global variables
  
AREA SmartSense_SnsDiff (RAM, REL, CON)

_waSnsDiff:
_SmartSense_waSnsDiff:                         ; ABS Diff of raw and and baseline, one entry for each sensor
 SmartSense_waSnsDiff:                  BLK  (2*SmartSense_TOTALSENSORCOUNT)

_SmartSense_waDiffCountHoppChannel:           
 SmartSense_waDiffCountHoppChannel:     BLK  (2*SmartSense_TOTALSENSORCOUNT*SmartSense_IMMUNITY_LEVEL) 

 
AREA SmartSense_ramSnsBLine (RAM, REL, CON)
 
_waSnsBaseline:
 waSnsBaseline:
_SmartSense_waSnsBaseline:                     ; Baseline, one entry for each sensor
 SmartSense_waSnsBaseline:              BLK  (2*SmartSense_TOTALSENSORCOUNT*SmartSense_IMMUNITY_LEVEL)
 
AREA SmartSense_ramSnsParam (RAM, REL, CON) 

_SmartSense_baSnsBucket:                       ; Baseline difference accumulator, one entry for each sensor
 SmartSense_baSnsBucket:                BLK  (SmartSense_TOTALSENSORCOUNT*SmartSense_IMMUNITY_LEVEL)
  
IF (SmartSense_TOTALSENSORCOUNT)
_SmartSense_baSnsOnMask: 
 SmartSense_baSnsOnMask:                BLK  ((SmartSense_TOTALSENSORCOUNT-1)/8)+1
ELSE
_SmartSense_baSnsOnMask:
 SmartSense_baSnsOnMask:                BLK  1
ENDIF
_SmartSense_baSnsDebounce:
 SmartSense_baSnsDebounce:              BLK  (SmartSense_TOTALSENSORCOUNT)
 
_SmartSense_baLowBaselineReset:
 SmartSense_baLowBaselineReset:         BLK  (SmartSense_TOTALSENSORCOUNT*SmartSense_IMMUNITY_LEVEL)

IF SmartSense_SLIDERS_EXIST 
_SmartSense_waCtrdPkValue:                     ; Array containing peak value of centroid
 SmartSense_waCtrdPkValue:              BLK  (2*SmartSense_SLIDERCOUNT)
_SmartSense_waSliderPrevPos:                     ;
 SmartSense_waSliderPrevPos:            BLK  (2*SmartSense_SLIDERCOUNT)
_SmartSense_waSliderCurrPos:                     ;
 SmartSense_waSliderCurrPos:            BLK  (2*SmartSense_SLIDERCOUNT)
ENDIF

AREA SmartSense_ramSnSSig (RAM, REL, CON)

_SmartSense_baSnsSignal:                                ; normalized  Signal
 SmartSense_baSnsSignal:                BLK  (SmartSense_TOTALSENSORCOUNT) 

AREA SmartSense_ramBtnFThreshold (RAM, REL, CON)  

_baBtnFThreshold:
_SmartSense_baBtnFThreshold:                   ; Containing variable finger threshold for each button
 SmartSense_baBtnFThreshold:            BLK  (SmartSense_TOTALSENSORCOUNT)

;@PSoC_UserCode_INIT@ (Do not change this line.)
;---------------------------------------------------
; Insert your custom declarations below this banner
;---------------------------------------------------

;------------------------
; User Includes
;------------------------


;------------------------
; User Constant Definitions
;------------------------


;------------------------
; User Variable Allocation
;------------------------


;---------------------------------------------------
; Insert your custom declarations above this banner
;---------------------------------------------------
;@PSoC_UserCode_END@ (Do not change this line.)

;------------------------
;  Constant Definitions
;------------------------

; For using two byte variables
LSB:  equ  1
MSB:  equ  0

; For using four byte variables
MMSB: equ 0
MLSB: equ 1
LMSB: equ 2
LLSB: equ 3

IF (TOOLCHAIN & HITECH)
AREA text (ROM,REL,CON)
ELSE
AREA text (ROM,REL,CON,CODE)
ENDIF

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_UpdateSensorBaseline(BYTE bSensorNum)
;
;  DESCRIPTION:
;      Update baseline for one sensor. The algorithm is as follows:
;        If difference count is negative baseline become raw count
;        If difference count is above noise threshold do not update
;        Else difference count is positive and within noise threshold so
;        difference is halved and added to the bucket. When the bucket
;        reaches the threshold the baseline increments and the bucket resets
;-----------------------------------------------------------------------------
;  STACK USAGE: 0 BYTES
;
;  ARGUMENTS:
;      A => Sensor Number
;
;  RETURNS:
;      Nothing
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_UpdateSensorBaseline:
_SmartSense_UpdateSensorBaseline:
   RAM_PROLOGUE RAM_USE_CLASS_4   
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area   
   mov   [SmartSense_bSensorNum], A
   call SmartSense_UpdateSingleSensorBaseline 
   mov   A, [SmartSense_bSensorNum]   
   lcall  SmartSense_ProcessDiff
   
IF (SmartSense_IMMUNITY_LEVEL / 3) 
   lcall UpdateSBaselineHigh
   lcall SmartSense_MedianFilter
ELSE
IF (SmartSense_IMMUNITY_LEVEL / 2)                   
   lcall UpdateSBaselineMedium
   lcall SmartSense_MedianFilter   
ENDIF
ENDIF 

   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR >SmartSense_bSensorNum  
   mov   A, [SmartSense_bSensorNum]   
   asl   A
   mov   X, A  
   RAM_SETPAGE_CUR >SmartSense_wX1
   mov   A, [SmartSense_wX1 + LSB]               ; Store result in waSnsResult array
   RAM_SETPAGE_IDX >SmartSense_waSnsDiff   
   mov   [X +SmartSense_waSnsDiff + LSB], A   
   mov   A, [SmartSense_wX1 + MSB] 
   mov   [X +SmartSense_waSnsDiff + MSB], A   
   RAM_EPILOGUE RAM_USE_CLASS_3
   RAM_EPILOGUE RAM_USE_CLASS_4   
   ret
.ENDSECTION   
   
.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_UpdateSingleSensorBaseline(BYTE bSensorNum)
;
;  DESCRIPTION:
;      Update baseline for one sensor. The algorithm is as follows:
;        If difference count is negative baseline become raw count
;        If difference count is above noise threshold do not update
;        Else difference count is positive and within noise threshold so
;        difference is halved and added to the bucket. When the bucket
;        reaches the threshold the baseline increments and the bucket resets
;-----------------------------------------------------------------------------
;  STACK USAGE: 0 BYTES
;
;  ARGUMENTS:
;      A => Sensor Number
;
;  RETURNS:
;      Nothing
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
UpdateSingleSensorBaseline:
 SmartSense_UpdateSingleSensorBaseline:
_SmartSense_UpdateSingleSensorBaseline:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   push  A                                            ; Save bSensorNum for freq to stack  
IF (SmartSense_AUTO_THRESHOLD_ENABLED) 
   mov   A, [SmartSense_bSensorNum]                   ; Get sensor index
   push  A                                            ; Calling C function from asm requires parameter passing to A and stack 
   lcall _CalculateThresholds
   pop   A   
   lcall SmartSense_LoadParameters 
ELSE   
   mov   A, [SmartSense_bSensorNum]                   ; Get sensor index
   lcall SmartSense_LoadFixedParameters
ENDIF  
   pop   A                                            ; Get bSensorNum for freq from stack 
    
   asl   A                                            ; Multiply by two since vars are INTs
   mov   X, A
   RAM_PROLOGUE RAM_USE_CLASS_3
   
   ; Get the difference counts
   RAM_SETPAGE_IDX >SmartSense_waSnsResult
   mov   A, [X+SmartSense_waSnsResult+LSB]
   RAM_SETPAGE_IDX >SmartSense_waSnsBaseline
   sub   A, [X+SmartSense_waSnsBaseline+LSB]
   RAM_SETPAGE_IDX >SmartSense_waDiffCountHoppChannel
   mov   [X+SmartSense_waDiffCountHoppChannel+LSB], A
   RAM_SETPAGE_IDX >SmartSense_waSnsResult
   mov   A, [X+SmartSense_waSnsResult+MSB]
   RAM_SETPAGE_IDX >SmartSense_waSnsBaseline
   sbb   A, [X+SmartSense_waSnsBaseline+MSB]
   RAM_SETPAGE_IDX >SmartSense_waDiffCountHoppChannel
   mov   [X+SmartSense_waDiffCountHoppChannel+MSB], A

   tst   [X + SmartSense_waDiffCountHoppChannel+MSB], 80h	 ; Is difference negative?
   jnz   .IsNegative

IF (SmartSense_AUTORESET)
   cmp   [X + SmartSense_waDiffCountHoppChannel+MSB], 0
   jz    .AddBucketLSB
   mov   A, 255
   jmp   .AddBucketConst
ELSE
   ; Compare to Noise Threshold
   cmp   [X + SmartSense_waDiffCountHoppChannel+MSB], 0
   jnz   .InitLowBaselineReset
   mov   A, [SmartSense_bNoiseThreshold]
   cmp   A, [X + SmartSense_waDiffCountHoppChannel+LSB]
   jc	 .InitLowBaselineReset
ENDIF

   ; Add to the Bucket
.AddBucketLSB:
   mov   A, [X + SmartSense_waDiffCountHoppChannel+LSB]
   add   A, 0
   rrc   A                                            ; For slower tracking   
.AddBucketConst:
   swap  A, X
   asr   A                                            ; Divide by two since vars are BYTEs
   swap  A, X 
   RAM_SETPAGE_IDX >SmartSense_baSnsBucket
   add   [X+SmartSense_baSnsBucket], A
   jc    .DoInc
   mov   A, [SmartSense_bBaselineUpdateThreshold]
   cmp   A, [X+SmartSense_baSnsBucket]
   jnc   .EndBucket
   jz    .EndBucket
.DoInc:
   ; Increment Baseline
   mov   [X+SmartSense_baSnsBucket], 0
   mov   A, X
   asl   A                                              ; Multiply by two since vars are INTs
   mov   X, A
   RAM_SETPAGE_IDX >SmartSense_waSnsBaseline

   add   [X+SmartSense_waSnsBaseline+LSB], 1
   adc   [X+SmartSense_waSnsBaseline+MSB], 0
   
   mov   A, X
   asr   A                                              ; Divide by two since vars are BYTEs
   mov   X, A   
.EndBucket:

   swap  A, X
   asl   A                                              ; Multiply by two since vars are INTs
   swap  X, A
IF (SmartSense_AUTORESET)
   ; Compare to Noise Threshold
   RAM_SETPAGE_IDX >SmartSense_waDiffCountHoppChannel
   cmp   [X + SmartSense_waDiffCountHoppChannel+MSB], 0
   jnz   .InitLowBaselineReset
   mov   A, [SmartSense_bNoiseThreshold]
   cmp   A, [X + SmartSense_waDiffCountHoppChannel+LSB]
   jc	 .InitLowBaselineReset
ELSE
ENDIF
   jmp   .SetDifferenceToZero

.IsNegative:
   ; Compare to Negative Noise Threshold
   cmp   [X + SmartSense_waDiffCountHoppChannel+MSB], FFh
   jnz   .CheckLowBaseline
   mov   A, FFh
   sub   A, [SmartSense_bNegativeNoiseThreshold]
   cmp   A, [X + SmartSense_waDiffCountHoppChannel+LSB]
   jc	 .LowerBaseline
.CheckLowBaseline:
   ; Set difference to zero
   RAM_SETPAGE_IDX >SmartSense_waDiffCountHoppChannel
   mov   [X + SmartSense_waDiffCountHoppChannel+LSB], 0
   mov   [X + SmartSense_waDiffCountHoppChannel+MSB], 0
   ; Check Low Baseline Reset
   mov   A, X
   asr   A                                              ; Divide by two since vars are BYTEs
   mov   X, A
  
   RAM_SETPAGE_IDX >SmartSense_baLowBaselineReset
   mov   A, [X+SmartSense_baLowBaselineReset]
   dec   A
   jnc   .Gt0
   mov   A, 0
.Gt0:
   mov   [X+SmartSense_baLowBaselineReset], A
   push  A                                              ;  Save Zero Flag
   mov   A, X
   asl   A                                              ; Multiply by two since vars are INTs
   mov   X, A
   pop   A                                              ;  Get Zero Flag
   jnz   .EndofUpdateSensorBaseline
.LowerBaseline:
   RAM_SETPAGE_IDX >SmartSense_waSnsResult
   mov   A, [X+SmartSense_waSnsResult+LSB]
   RAM_SETPAGE_IDX >SmartSense_waSnsBaseline
   mov   [X+SmartSense_waSnsBaseline+LSB], A
   RAM_SETPAGE_IDX >SmartSense_waSnsResult
   mov   A, [X+SmartSense_waSnsResult+MSB]
   RAM_SETPAGE_IDX >SmartSense_waSnsBaseline
   mov   [X+SmartSense_waSnsBaseline+MSB], A

.SetDifferenceToZero:
   ; Set difference to zero
   RAM_SETPAGE_IDX >SmartSense_waDiffCountHoppChannel
   mov   [X + SmartSense_waDiffCountHoppChannel+LSB], 0
   mov   [X + SmartSense_waDiffCountHoppChannel+MSB], 0
.InitLowBaselineReset:
   mov   A, X
   asr   A
   mov   X, A  
   RAM_SETPAGE_IDX >SmartSense_baLowBaselineReset
   mov   A, [SmartSense_bLowBaselineReset]
   mov   [X+SmartSense_baLowBaselineReset], A
.EndofUpdateSensorBaseline:
   RAM_EPILOGUE RAM_USE_CLASS_3
   RAM_EPILOGUE RAM_USE_CLASS_4   
   ret
.ENDSECTION

IF (TOOLCHAIN & HITECH)
AREA text (ROM,REL,CON)
ELSE
AREA text (ROM,REL,CON,CODE)
ENDIF

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_bIsSensorActive(BYTE bSensorNum)
;
;  DESCRIPTION:
;      Returns state of one sensor.    Updates the baSnsOnMask array.
;      Implements hysteresis based on the Hysteresis parameter.
;-----------------------------------------------------------------------------
;  STACK USAGE: 3 BYTES
;
;  ARGUMENTS:
;      A => sensor index
;
;  RETURNS:
;      A => 1 if sensor is active, 0 otherwise
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_bIsSensorActive:
_SmartSense_bIsSensorActive:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   push  A
   mov   X,A
   RAM_SETPAGE_IDX >SmartSense_baBtnFThreshold
   mov   A, [X+SmartSense_baBtnFThreshold]
   mov   [SmartSense_wTmpBtnFThreshold+LSB], A
   mov   [SmartSense_wTmpBtnFThreshold+MSB], 0

   pop   A
   push  A
   call  SmartSense_GetOnMask
   RAM_SETPAGE_IDX >SmartSense_baSnsOnMask
   and   A, [X+SmartSense_baSnsOnMask]
   
   jnz   .WasOn

.WasOff:
   ; Check the difference counts against the threshold
   mov   A, [SmartSense_bHysteresis]
   add   [SmartSense_wTmpBtnFThreshold+LSB], A      ; Add Hysteresis
   adc   [SmartSense_wTmpBtnFThreshold+MSB], 0
   pop   A
   asl   A
   mov   X, A
   RAM_SETPAGE_IDX >SmartSense_waSnsDiff
   mov   A, [X+SmartSense_waSnsDiff+LSB]
   sub   A, [SmartSense_wTmpBtnFThreshold+LSB]
   mov   A, [X+SmartSense_waSnsDiff+MSB]
   sbb   A, [SmartSense_wTmpBtnFThreshold+MSB]
   jc    .NotActive
   mov   A, X
   asr   A
   mov   X, A
   RAM_SETPAGE_IDX >SmartSense_baSnsDebounce
   mov   A, [X+SmartSense_baSnsDebounce]
   dec   A
   mov   [X+SmartSense_baSnsDebounce], A
   push  A
   mov   A, X
   asl   A
   mov   X, A
   pop   A
   jnz   .NotActiveDebouncing
   jmp   .Active

.WasOn:
   ; Check the difference counts against the threshold
   mov   A, [SmartSense_bHysteresis]
   sub   [SmartSense_wTmpBtnFThreshold+LSB], A     ; Substruct Hysteresis
   sbb   [SmartSense_wTmpBtnFThreshold+MSB], 0
   pop   A
   asl   A
   mov   X, A
   RAM_SETPAGE_IDX >SmartSense_waSnsDiff
   mov   A, [X+SmartSense_waSnsDiff+LSB]
   sub   A, [SmartSense_wTmpBtnFThreshold+LSB]
   mov   A, [X+SmartSense_waSnsDiff+MSB]
   sbb   A, [SmartSense_wTmpBtnFThreshold+MSB]
   jc    .NotActive

.Active:
   mov   A, X
   asr   A
   call  SmartSense_GetOnMask
   RAM_SETPAGE_IDX >SmartSense_baSnsOnMask
   or    [X+SmartSense_baSnsOnMask], A
   mov   A, 1
   jmp   .EndIsSensorActive
.NotActive:
   mov   A, X
   asr   A
   push  A
   call  SmartSense_GetOnMask
   cpl   A
   RAM_SETPAGE_IDX >SmartSense_baSnsOnMask
   and   [X+SmartSense_baSnsOnMask], A
   RAM_SETPAGE_IDX >SmartSense_baSnsDebounce
   pop   X
   mov   A, [SmartSense_bDebounce]
   mov   [X+SmartSense_baSnsDebounce], A
   mov   A, 0
   jmp   .EndIsSensorActive
.NotActiveDebouncing:
   mov   A, X
   asr   A
   call  SmartSense_GetOnMask
   cpl   A
   RAM_SETPAGE_IDX >SmartSense_baSnsOnMask
   and   [X+SmartSense_baSnsOnMask], A
   mov   A, 0
.EndIsSensorActive:
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_GetOnMask(BYTE bSensorOffset)
;
;  DESCRIPTION:
;      Returns state of one sensor.	Updates the baSnsOnMask array.
;      Implements hysteresis based on the Hysteresis parameter.
;
;  STACK USAGE: 1 BYTE
;
;  ARGUMENTS:
;      A => Sensor offset
;
;  RETURNS:
;      A => 1 if sensor is active, 0 otherwise
;
 SmartSense_GetOnMask:
_SmartSense_GetOnMask:
   push  A
   asr   A
   asr   A
   asr   A
   mov   X, A
   pop   A
   and   A, 7h
   index SmartSense_bitlookup
   ret
.ENDSECTION

.LITERAL
SmartSense_bitlookup:
    db 01h, 02h, 04h, 08h, 10h, 20h, 40h, 80h
.ENDLITERAL

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_InitializeBaselines(void)
;
;  DESCRIPTION:
;    Scans all sensors to find their initial raw count values and loads these
;    into the baseline
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_InitializeBaselines:
_SmartSense_InitializeBaselines:
   RAM_PROLOGUE RAM_USE_CLASS_4   
   mov   A, (SmartSense_TOTALSENSORCOUNT-1)           ; Get sensor num
.BaselineLoop:                                        ; Loop through all sensors and scan
   push  A   
   call  SmartSense_InitializeSensorBaseline
   pop   A
   dec   A
   jnc   .BaselineLoop
   
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_InitializeSensorBaseline(BYTE bSensorNum)
;
;  DESCRIPTION:
;    Scans a sensor to find their initial raw count values and loads this
;    into the baseline
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    
;		A  => Sensor Index
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_InitializeSensorBaseline:
_SmartSense_InitializeSensorBaseline:
   RAM_PROLOGUE RAM_USE_CLASS_3
   
   mov   [SmartSense_bSensorNum], A
   lcall SmartSense_CopyIdacValue

   lcall SmartSense_ScanSingleSensor

   mov   A, [SmartSense_bSensorNum]                   ; Get sensor index
   lcall SmartSense_CopywADCResultToBaseline

IF (SmartSense_IMMUNITY_LEVEL / 3)                    ; Immunity Level = High
   lcall InitSBaselineMedium
   lcall InitSBaselineHigh
   lcall RestoreNormalScan
ELSE
IF (SmartSense_IMMUNITY_LEVEL / 2)                    ; Immunity Level = Medium  
   lcall InitSBaselineMedium
   lcall RestoreNormalScan
ENDIF
ENDIF
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_bIsAnySensorActive(void)
;
;  DESCRIPTION:
;    Checks to see if any sensor is currently active
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      1 if any active, 0 if none active
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_bIsAnySensorActive:
_SmartSense_bIsAnySensorActive:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   mov   [SmartSense_fIsPressed], 0
   mov   A, (SmartSense_TOTALSENSORCOUNT - 1)
.ThresholdLoop:                                       ; Loop through all sensors
   push  A
   call  SmartSense_bIsSensorActive
   cmp   A, 1
   jnz   .NotActive
   mov   [SmartSense_fIsPressed], 1
.NotActive:
   pop   A
   dec   A
   jnc   .ThresholdLoop
   mov   A, [SmartSense_fIsPressed]

.NoneActive:
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

IF (TOOLCHAIN & HITECH)
AREA text (ROM,REL,CON)
ELSE
AREA text (ROM,REL,CON,CODE)
ENDIF

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_UpdateAllBaselines(void)
;
;  DESCRIPTION:
;    Scans all sensors to find their raw count values
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_UpdateAllBaselines:
_SmartSense_UpdateAllBaselines:
   RAM_PROLOGUE RAM_USE_CLASS_4

   mov   A, (SmartSense_TOTALSENSORCOUNT-1)
.ThresholdLoop:                                       ; Loop through all sensors
   push  A
   call  SmartSense_UpdateSensorBaseline
   pop   A
   dec   A
   jnc   .ThresholdLoop

   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION


IF (SmartSense_LIN_SLIDERS_EXIST)

AREA UserModules (ROM, REL, CON)

.LITERAL
;-----------------------------------------------------------------------------
; Diplex table scan order data is produced for a group when it is a slider and
; is also diplexed.  Otherwise a label is created but no data is placed.  The
; data represents the physical representation of the sensors in their location
; on the PCB.  A label containing the pointer to the corresponding table is
; also produced for referencing in the high-level centroid calculation
; function.
;-----------------------------------------------------------------------------
 SmartSense_Diplex_Table:
_SmartSense_Diplex_Table:
	db >DiplexTable_0, <DiplexTable_0
	db >DiplexTable_1, <DiplexTable_1

.ENDLITERAL

IF	(TOOLCHAIN & HITECH)
  AREA lit (ROM,REL,CON)
ELSE
  AREA lit (ROM,REL,CON,LIT)
ENDIF

IF(SmartSense_DIPLEXUSED)
.LITERAL
ENDIF

DiplexTable_0:
; This group is not a diplexed slider
DiplexTable_1:
; This group is not a diplexed slider

IF(SmartSense_DIPLEXUSED)
.ENDLITERAL
ENDIF

ENDIF

AREA UserModules (ROM, REL, CON)

IF(SmartSense_SLIDERS_EXIST)
.LITERAL
;-----------------------------------------------------------------------------
; The Group Table defines each of the groups of button sensors or sliders.
; There is one entry for each slider plus one for the free button sensors.
; The first entry is always the free sensors.  Each entry is four bytes.
;
; The first byte is the index in the Sensor Table where the group starts.
;
; The second byte is how many sensors are in that group.  For example, in a
; system where there are 8 free sensors and two sliders, the first with 8
; sensors and the second with 4, the table would look like the following.
;  db 0, 8
;  db 8, 8
;  db 16, 4
;
; The third byte signifies whether the slider is diplexed or not (non-zero is
; diplexed, 0 is not diplexed).
;
; The fourth, fifth, and sixth bytes are the fixed point multiplier that the
; slider's calculated centroid will be multiplied by to achieve the resolution
; desired in the SmartSense wizard.  The multiplier is three bytes containing the
; following bit definitions:
;  MSB:
;    bit 7   bit 6   bit 5   bit 4   bit 3   bit 2   bit 1   bit 0
;     x2^15	  x2^14   x2^13   x2^12   x2^11   x2^10   x2^9    x2^8
;  ISB:
;    bit 7   bit 6   bit 5   bit 4   bit 3   bit 2   bit 1   bit 0
;     x128	  x64     x32     x16     x8      x4      x2      x1
;  LSB:
;    bit 7   bit 6   bit 5   bit 4   bit 3   bit 2   bit 1   bit 0
;     x1/2	  x1/4    x1/8    x1/16   x1/32   x1/64   x1/128  x1/256
;
; The formula for the Multiplier is:
;    Multiplier = ((Resolution-1) * 256) / (SensorsInSlider - 1)
;
; For example, if you had a 5 sensor slider and you wanted a resolution of
; 100, the multiplier would need to be 0x0018C0:
;    MSB 00h
;    ISB 18h
;    LSB C0h
; The GUI automatically calculates these values based on the resolution needed.
;
; There are 0x1 groups counting the free sensors.
;-----------------------------------------------------------------------------
 SmartSense_Group_Table:
_SmartSense_Group_Table:
; Group Table:
;    Origin    Count    Diplex?    DivBtwSw(wholeMSB, wholeLSB, fractByte)
 db   0x0,      0x00,	 0x00,	 0x00,	 0x00,	 0x00 ; Buttons
 db   0x00,	    0x05,	 0x00,	 0x00,	 0x18,	 0xC0 ; Slider 1

.ENDLITERAL
ENDIF

IF (SmartSense_LIN_SLIDERS_EXIST)
.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_wGetCentroidPos(BYTE bSnsGroup)
;
;  DESCRIPTION:
;      Checks the difference array for a centroid.  If one exists, the offset
;      (within the whole difference arrary) and length are placed in the
;      bCentroidLength and bCentroidStart variables.
;
;      Then the function finds and returns the position of the centroid in the
;      difference array.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;       A => Sensor Group
;       Sensor Group = 0 for the independent sensors group
;       Sensor Group = 1 for the first slider group
;       Sensor Group = 2 for the second slider group
;
;  RETURNS:
;      iCtrdPos -> position of the centroid
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;

;@PSoC_UserCode_CALC_THRESHOLD@ (Do not change this line.) 
SmartSense_CALC_THRESHOLD:              equ 5 
; You can customize this value. 
;@PSoC_UserCode_END@ (Do not change this line.)  

 SmartSense_wGetCentroidPos:
_SmartSense_wGetCentroidPos:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

; First get the starting location and size of this sensor group
   asl   A ; multiply by two to get diplex
   mov   X, A
   index SmartSense_Diplex_Table ; get the diplex table MSB and LSB
   mov   [SmartSense_bDiplexMSB], A
   mov   A, X
   inc   A
   index SmartSense_Diplex_Table
   mov   [SmartSense_bDiplexLSB], A
   mov   A, X
   mov   [SmartSense_bStartIndex], A ; Use bStartIndex as a temp storage byte
   asl   A
   add   [SmartSense_bStartIndex], A
   mov   A, [SmartSense_bStartIndex] ; A now has slider offset multiplied by six
   mov   X, A
   index SmartSense_Group_Table ; get first sensor index
   mov   [SmartSense_bEndOfArray], A
   mov   [SmartSense_bCurPos], A
   mov   [SmartSense_bStartIndex], A
   mov   A, X
   inc   A
   index SmartSense_Group_Table ; get size of group
   add   [SmartSense_bEndOfArray], A ; Store for later
   mov   A, X
   add   A, 2
   index SmartSense_Group_Table ; get if diplexed or not and max size of centroid (data = 0 if not diplexed)
   mov   [SmartSense_bDiplexInfo], A ; Store for later
   mov   A, X
   add   A, 3
   mov   [SmartSense_bSnsMaskPtr], A ; Store starting position in an unused temp SmartSense_bSnsMaskPtr

; First find the starting location and size of the largest centroid
   mov   A, 0
   mov   [SmartSense_bBiggestCtrdStartPos], A
   mov   [SmartSense_bBiggestCtrdSize], A
   mov   [SmartSense_bCurCtrdStartPos], A
   mov   [SmartSense_bCurCtrdSize], A

   mov   A, [SmartSense_bStartIndex]
   asl   A ; multiply by two because we are using ints
   mov   X, A

.LocateCtrd:
   RAM_SETPAGE_IDX >SmartSense_waSnsDiff
   mov   A, [X+SmartSense_waSnsDiff]
   jnz   .DiffIsNotZero
   mov   A, [X+SmartSense_waSnsDiff+1]
   jnz   .DiffIsNotZero
; The difference is zero, we either just ended a centroid or are between centroids
; First check the Current Size, if zero, we are in the middle of zeros, else, we just ended
.DifferenceIsZero:
   mov    A, [SmartSense_bCurCtrdSize]
   jz    .LocateCtrdNextSensor
; A centroid just ended.  Is it the largest centroid?
   cmp   A, [SmartSense_bBiggestCtrdSize]
   jc    .ClearCurCtrdSize
; It is the biggest so far, store as biggest
   mov   [SmartSense_bBiggestCtrdSize], [SmartSense_bCurCtrdSize]
   mov   [SmartSense_bBiggestCtrdStartPos], [SmartSense_bCurCtrdStartPos]
.ClearCurCtrdSize:
   mov   [SmartSense_bCurCtrdSize], 0
   jmp   .LocateCtrdNextSensor

;The difference is not zero, we either just started, or are in the middle of a centroid
.DiffIsNotZero:
   mov   A, [SmartSense_bCurCtrdSize]
   jnz   .IncCtrdSize
; Centroid just began, store the start pos
   mov   A, [SmartSense_bCurPos]
   mov   [SmartSense_bCurCtrdStartPos], A
.IncCtrdSize:
   inc   [SmartSense_bCurCtrdSize]
; Find out the next position
.LocateCtrdNextSensor:
   inc   X
   inc   X
   inc   [SmartSense_bCurPos]
   mov   A, [SmartSense_bCurPos]
   cmp   A, [SmartSense_bEndOfArray] ; Check for the end of the array
   jc    .LocateCtrd
; Either at end of array, or diplexed
   tst   [SmartSense_bDiplexInfo], ffh ; check if diplexed
   jz    .EndOfLocateCtrd
; Diplexed, so now find out if at end
   sub   A, [SmartSense_bEndOfArray] ; subtract the size of the array
   add   A, [SmartSense_bStartIndex] ; for comparison
   cmp   A, [SmartSense_bEndOfArray] ; Check for the end of the array
   jnc   .EndOfLocateCtrd
; Not the end of the diplexed array, find out offset of next position
   mov   A, [SmartSense_bCurPos]
   sub   A, [SmartSense_bStartIndex]
   add   A, [SmartSense_bDiplexLSB]
   mov   X, A
   mov   A, [SmartSense_bDiplexMSB]
   adc   A, 0 ; check if carry
   romx ; get the offset from the start
   add   A, [SmartSense_bStartIndex]
   asl   A ; because using ints
   mov   X, A
   jmp   .LocateCtrd
.EndOfLocateCtrd:
; Need to check if the current centroid is biggest
   mov   A, [SmartSense_bCurCtrdSize]
   jz    .CalculateCtrd
; There was a centroid at the end, is it biggest?
   cmp   A, [SmartSense_bBiggestCtrdSize]
   jc    .CalculateCtrd ; if two are the same size, last one wins
; It is the biggest so far, store as biggest
   mov   [SmartSense_bBiggestCtrdSize], [SmartSense_bCurCtrdSize]
   mov   [SmartSense_bBiggestCtrdStartPos], [SmartSense_bCurCtrdStartPos]

.CalculateCtrd:
   mov   A, [SmartSense_bBiggestCtrdSize]
   jz    .COM_Error
   mov   A, [SmartSense_bDiplexInfo] ; check if diplexed
   jz    .COM_Init
   cmp   [SmartSense_bBiggestCtrdSize], 2
   jc    .COM_Error ; for diplexing, one or less is too small
   cmp   A, [SmartSense_bBiggestCtrdSize]
   jc    .COM_Error ; for diplexing, check if centroid is too large

.COM_Init:
   mov   A, [SmartSense_bBiggestCtrdStartPos] ; Use for current position, may be diplexed
   mov   [SmartSense_bCurPos], A
   mov   A, 0
   mov   [SmartSense_wDenom+MSB], A ; Clear the numerator and denominator
   mov   [SmartSense_wDenom+LSB], A
   mov   [SmartSense_dNumer+MMSB], A
   mov   [SmartSense_dNumer+MLSB], A
   mov   [SmartSense_dNumer+LMSB], A
   mov   [SmartSense_dNumer+LLSB], A

.COM_NextPosition:
   mov   A, [SmartSense_bCurPos]
   cmp   A, [SmartSense_bEndOfArray]
   jnc   .COM_CheckDiplex
   asl   A
   mov   X, A
   jmp   .COM_AddElement
; Must be diplexed, check for safe measure
.COM_CheckDiplex:
   tst   [SmartSense_bDiplexInfo], ffh ; check if diplexed
   jz    .COM_Compute
; Find out offset of next position
   mov   A, [SmartSense_bCurPos]
   sub   A, [SmartSense_bStartIndex]
   add   A, [SmartSense_bDiplexLSB]
   mov   X, A
   mov   A, [SmartSense_bDiplexMSB]
   adc   A, 0 ; check if carry
   romx ; get the offset from the start
   add   A, [SmartSense_bStartIndex]
   asl   A ; because using ints
   mov   X, A
.COM_AddElement:
; Subtract the noise from the difference, this will yield a more accurate result
   RAM_SETPAGE_IDX >SmartSense_waSnsDiff
   sub   [X+SmartSense_waSnsDiff+LSB], SmartSense_CALC_THRESHOLD
   sbb   [X+SmartSense_waSnsDiff+MSB], 0
; Store a copy of the sensor difference in SmartSense_dMultTempX
   mov   A, [X+SmartSense_waSnsDiff+LSB]
   mov   [SmartSense_dMultTempX+LLSB], A
; Add LSB to denominator
   add   [SmartSense_wDenom+LSB], A
   mov   A, [X+SmartSense_waSnsDiff]
   mov   [SmartSense_dMultTempX+LMSB], A
   mov   [SmartSense_dMultTempX+MLSB], 0
   mov   [SmartSense_dMultTempX+MMSB], 0
; Add MSB to denominator
   adc   [SmartSense_wDenom], A
   mov   A, [SmartSense_bCurPos]
   sub   A, [SmartSense_bStartIndex] ; we need offset from beginning of group
   mov   [SmartSense_wDivBtwSns+MSB], 0
   mov   [SmartSense_wDivBtwSns+LSB], A

   call  .MultiplyNumeratorWhole

   inc   [SmartSense_bCurPos]
   dec   [SmartSense_bBiggestCtrdSize]
   jz    .COM_Compute
   jmp   .COM_NextPosition

.COM_Compute:
   mov   A, [SmartSense_dNumer+LLSB] ; Move numerator to temp
   mov   [SmartSense_dMultTempX+LLSB], A
   mov   [SmartSense_dMultTempY+LLSB], A
   mov   A, [SmartSense_dNumer+LMSB]
   mov   [SmartSense_dMultTempX+LMSB], A
   mov   [SmartSense_dMultTempY+LMSB], A
   mov   A, [SmartSense_dNumer+MLSB]
   mov   [SmartSense_dMultTempX+MLSB], A
   mov   [SmartSense_dMultTempY+MLSB], A
   mov   A, [SmartSense_dNumer+MMSB]
   mov   [SmartSense_dMultTempX+MMSB], A
   mov   [SmartSense_dMultTempY+MMSB], A
   
   mov   A, 0
   mov   [SmartSense_dNumer+MMSB], A ; Clear numerator
   mov   [SmartSense_dNumer+MLSB], A
   mov   [SmartSense_dNumer+LMSB], A
   mov   [SmartSense_dNumer+LLSB], A

   mov   A, [SmartSense_bSnsMaskPtr] ; Retrieve starting position in index of the DivBtwSns
   push  A
   index SmartSense_Group_Table ; get MSB of whole multiplier
   mov   [SmartSense_wDivBtwSns+MSB], A
   pop   A
   inc   A
   push  A
   index SmartSense_Group_Table ; get LSB of whole multiplier
   mov   [SmartSense_wDivBtwSns+LSB], A
   call  .MultiplyNumeratorWhole ; Multiplies by whole part
   pop   A
   inc   A
   index SmartSense_Group_Table ; get byte of fractional multiplier
   mov   [SmartSense_wDivBtwSns+LSB], A
   call  .MultiplyNumeratorFraction ; Multiplies by fractional part

; Now do the division of the numerator and denominator

; Round up the temp by half of the denominator (0.5 gets 1)
   mov   A, [SmartSense_wDenom+MSB]
   mov   [SmartSense_dMultTempX+MSB], A
   mov   A, [SmartSense_wDenom+LSB]
   mov   [SmartSense_dMultTempX+LSB], A
   and   F, ~04h ; Clear carry bit if set
   rrc   [SmartSense_dMultTempX+MSB] ; divide denominator by 2
   rrc   [SmartSense_dMultTempX+LSB]
   mov   A, [SmartSense_dMultTempX+LSB]
   add   [SmartSense_dNumer+LLSB], A ; add 1/2 denominator
   mov   A, [SmartSense_dMultTempX+MSB]
   adc   [SmartSense_dNumer+LMSB], A
   adc   [SmartSense_dNumer+MLSB], 0
   adc   [SmartSense_dNumer+MMSB], 0

; Compute the division of numerator divided by denominator
   asl   [SmartSense_dNumer+LLSB]
   rlc   [SmartSense_dNumer+LMSB]
   rlc   [SmartSense_dNumer+MLSB]
   rlc   [SmartSense_dNumer+MMSB]
   mov   X, 16
.DivideLoop:
; Subtract the divisor or denominator from the MMSB MLSB dividend or numerator
   mov   A, [SmartSense_wDenom+LSB]
   sub   [SmartSense_dNumer+MLSB], A
   mov   A, [SmartSense_wDenom+MSB]
   sbb   [SmartSense_dNumer+MMSB], A
; Check if less than zero
   jnc   .SetLSbToOneAndShift
.AddBackSetLSbToZeroAndShift:
; Less than zero so add back to dividend and shift a zero into the dividend
   mov   A, [SmartSense_wDenom+LSB]
   add   [SmartSense_dNumer+MLSB], A
   mov   A, [SmartSense_wDenom+MSB]
   adc   [SmartSense_dNumer+MMSB], A
   asl   [SmartSense_dNumer+LLSB]
   rlc   [SmartSense_dNumer+LMSB]
   rlc   [SmartSense_dNumer+MLSB]
   rlc   [SmartSense_dNumer+MMSB]
   dec   X
   jnz   .DivideLoop
   jmp   .EndOfDivide
.SetLSbToOneAndShift:
   asl   [SmartSense_dNumer+LLSB]
   or    [SmartSense_dNumer+LLSB], 01h
   rlc   [SmartSense_dNumer+LMSB]
   rlc   [SmartSense_dNumer+MLSB]
   rlc   [SmartSense_dNumer+MMSB]
   dec   X
   jnz   .DivideLoop
.EndOfDivide:
; MMSB and MLSB have carry after shifted right once
   rrc   [SmartSense_dNumer+MMSB]
   rrc   [SmartSense_dNumer+MLSB]
; Load return value
   mov   X, [SmartSense_wCtrdPos+MSB]
   mov   A, [SmartSense_wCtrdPos+LSB]
   jmp   .EndGetCtrdPos
.COM_Error:
; Load error return value
   mov   A, ffh
   mov   X, ffh
.EndGetCtrdPos:
; Algorithm is finished, position is in [SmartSense_wCtrdPos]
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret

; Multiplication algorithm (for whole numbers)
.MultiplyNumeratorWhole:
   mov   A, 01h
.CheckToAddNext2xLSB:
   push  A
   and   A, [SmartSense_wDivBtwSns+LSB] ; See if current 2^x needs added
   jz    .SkipAddAndShiftLeftLSB
   mov   A, [SmartSense_dMultTempX+LLSB]
   add   [SmartSense_dNumer+LLSB], A
   mov   A, [SmartSense_dMultTempX+LMSB]
   adc   [SmartSense_dNumer+LMSB], A
   mov   A, [SmartSense_dMultTempX+MLSB]
   adc   [SmartSense_dNumer+MLSB], A
   mov   A, [SmartSense_dMultTempX+MMSB]
   adc   [SmartSense_dNumer+MMSB], A
.SkipAddAndShiftLeftLSB:
   asl   [SmartSense_dMultTempX+LLSB]
   rlc   [SmartSense_dMultTempX+LMSB]
   rlc   [SmartSense_dMultTempX+MLSB]
   rlc   [SmartSense_dMultTempX+MMSB]
   pop   A
   asl   A
   jnc   .CheckToAddNext2xLSB
   mov   A, [SmartSense_wDivBtwSns+MSB]
   jz    .EndMultiplyNumeratorWhole ; only multiply by MSB if needed
   mov   A, 01h
.CheckToAddNext2xMSB:
   push  A
   and   A, [SmartSense_wDivBtwSns+MSB] ; See if current 2^x needs added
   jz    .SkipAddAndShiftLeftMSB
   mov   A, [SmartSense_dMultTempX+LLSB]
   add   [SmartSense_dNumer+LLSB], A
   mov   A, [SmartSense_dMultTempX+LMSB]
   adc   [SmartSense_dNumer+LMSB], A
   mov   A, [SmartSense_dMultTempX+MLSB]
   adc   [SmartSense_dNumer+MLSB], A
   mov   A, [SmartSense_dMultTempX+MMSB]
   adc   [SmartSense_dNumer+MMSB], A
.SkipAddAndShiftLeftMSB:
   asl   [SmartSense_dMultTempX+LLSB]
   rlc   [SmartSense_dMultTempX+LMSB]
   rlc   [SmartSense_dMultTempX+MLSB]
   rlc   [SmartSense_dMultTempX+MMSB]
   pop   A
   asl   A
   jnc   .CheckToAddNext2xMSB
.EndMultiplyNumeratorWhole:
   ret

; Multiplication algorithm (for fractional numbers)
.MultiplyNumeratorFraction:
   and   F, ~04h ; clear carry bit if set
   rrc   [SmartSense_dMultTempY+MMSB]
   rrc   [SmartSense_dMultTempY+MLSB]
   rrc   [SmartSense_dMultTempY+LMSB]
   rrc   [SmartSense_dMultTempY+LLSB]
   mov   A, 80h
.CheckToAddNextHalf:
   push  A
   and   A, [SmartSense_wDivBtwSns+LSB]
   jz    .SkipAddAndShiftRight
   mov   A, [SmartSense_dMultTempY+LLSB]
   add   [SmartSense_dNumer+LLSB], A
   mov   A, [SmartSense_dMultTempY+LMSB]
   adc   [SmartSense_dNumer+LMSB], A
   mov   A, [SmartSense_dMultTempY+MLSB]
   adc   [SmartSense_dNumer+MLSB], A
   mov   A, [SmartSense_dMultTempY+MMSB]
   adc   [SmartSense_dNumer+MMSB], A
.SkipAddAndShiftRight:
   asr   [SmartSense_dMultTempY+MMSB]
   rrc   [SmartSense_dMultTempY+MLSB]
   rrc   [SmartSense_dMultTempY+LMSB]
   rrc   [SmartSense_dMultTempY+LLSB]
   pop   A
   and   F, ~04h ; clear carry bit if set
   rrc   A
   jnc   .CheckToAddNextHalf
   ret
.ENDSECTION
ENDIF

IF (SmartSense_ROT_SLIDERS_EXIST)
.LITERAL
SmartSense_SLIDER_RESOLUTION_TABLE:
dw 0x64

.ENDLITERAL

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_wGetRadialInc(BYTE bSnsGroup)
;  DESCRIPTION:
;
;-----------------------------------------------------------------------------
;  ARGUMENTS:
;      A => Sensor Group
;      Sensor Group = 0 for the independent sensors group
;      Sensor Group = 1 for the first slider group
;      Sensor Group = 2 for the second slider group
;  RETURNS:
;     result - offset (positive or negative)  through X and A
;-----------------------------------------------------------------------------
;  SIDE EFFECTS:
;   The A and X registers may be modified by this or future implementations
;   of this function.  The same is true for all RAM page pointer registers in
;   the Large Memory Model.  When necessary, it is the calling function's
;   responsibility to perserve their values across calls to fastcall16
;   functions.
;-----------------------------------------------------------------------------
 SmartSense_wGetRadialInc:
_SmartSense_wGetRadialInc:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   dec   A
   asl   A
   mov   [SmartSense_bCurCtrdSize], A   ;saves slider number
   
   mov   X, A
   RAM_SETPAGE_IDX >SmartSense_waSliderPrevPos
   cmp   [X + SmartSense_waSliderPrevPos + 0], FFh
   jnz   .CurrCheck
   cmp   [X + SmartSense_waSliderPrevPos + 1], FFh
   jnz   .CurrCheck
   jmp   .ReturnValueToZero

.CurrCheck:
   RAM_SETPAGE_IDX >SmartSense_waSliderCurrPos
   cmp   [X + SmartSense_waSliderCurrPos + 0], FFh
   jnz   .Calculations
   cmp   [X + SmartSense_waSliderCurrPos + 1], FFh
   jnz   .Calculations
.ReturnValueToZero:
   mov   X, 00h
   mov   A, X
   jmp   .Done

.Calculations:
   ;getting A*6
   mov   A,  [SmartSense_bCurCtrdSize]
   index SmartSense_SLIDER_RESOLUTION_TABLE
   mov   [SmartSense_wCurPkValue + 0], A
   mov   A,  [SmartSense_bCurCtrdSize]
   inc   A
   index SmartSense_SLIDER_RESOLUTION_TABLE
   mov   [SmartSense_wCurPkValue + 1], A

   ;wDenom = Resolution/2
   mov   A, [SmartSense_wCurPkValue + 0]
   asr   A
   mov   [SmartSense_wDenom + 0], A
   mov   A, [SmartSense_wCurPkValue + 1]
   rrc   A
   mov   [SmartSense_wDenom + 1], A
        
   mov   X, [SmartSense_bCurCtrdSize]

   ;detect direction of the motion
   RAM_SETPAGE_IDX >SmartSense_waSliderCurrPos
   mov   A, [X + SmartSense_waSliderCurrPos + 1]
   RAM_SETPAGE_IDX >SmartSense_waSliderPrevPos
   sub   A, [X + SmartSense_waSliderPrevPos + 1]
   mov   [SmartSense_dMultTempY + 1], A

   RAM_SETPAGE_IDX >SmartSense_waSliderCurrPos
   mov   A, [X + SmartSense_waSliderCurrPos + 0]
   RAM_SETPAGE_IDX >SmartSense_waSliderPrevPos
   sbb   A, [X + SmartSense_waSliderPrevPos + 0]
   mov   [SmartSense_dMultTempY + 0], A
        
   tst   [SmartSense_dMultTempY + 0], 80h
   jnz   .DiffIsNegative ;negative

   ;positive
   mov   A, [SmartSense_dMultTempY + 0]
   cmp   A, [SmartSense_wDenom + 0]
   jc    .LessThenAHalfOfResol1
   jnz   .GreaterThenAHalfOfResol1

   mov   A, [SmartSense_dMultTempY + 1]
   cmp   A, [SmartSense_wDenom + 1]
   jc    .LessThenAHalfOfResol1
   jmp   .GreaterThenAHalfOfResol1

.LessThenAHalfOfResol1:
   ;Less than a half of resolution
   mov   X, [SmartSense_dMultTempY + 0]
   mov   A, [SmartSense_dMultTempY + 1]
   jmp   .Done

.GreaterThenAHalfOfResol1:
   mov   A, [SmartSense_dMultTempY + 1]
   sub   A, [SmartSense_wCurPkValue + 1]
   mov   X, A
   mov   A, [SmartSense_dMultTempY + 0]
   sbb   A, [SmartSense_wCurPkValue + 0]
   swap  A, X
   jmp   .Done

.DiffIsNegative:
   mov   A, [SmartSense_dMultTempY + 1]
   cpl   A
   inc   A
   mov   [SmartSense_dMultTempX + 1], A
   mov   A, [SmartSense_dMultTempY + 0]
   cpl   A
   adc   A, 0
        
   cmp   A, [SmartSense_wDenom + 0]
   jc    .LessThenAHalfOfResol1
   jnz   .GreaterThenAHalfOfResol2
      
   mov   A, [SmartSense_dMultTempX + 1]
   cmp   A, [SmartSense_wDenom + 1]
   jc    .LessThenAHalfOfResol1
   jmp   .GreaterThenAHalfOfResol2

.GreaterThenAHalfOfResol2:
   mov   A, [SmartSense_dMultTempY + 1]
   add   [SmartSense_wCurPkValue + 1], A
   mov   A, [SmartSense_dMultTempY + 0]
   adc   [SmartSense_wCurPkValue + 0], A
   mov   X, [SmartSense_wCurPkValue + 0]
   mov   A, [SmartSense_wCurPkValue + 1]

.Done:
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.LITERAL
SmartSense_RADIAL_SLIDER_RESOLUTION_MULTIPLIER_TABLE:
IF (5h)
  dw 64h * 256 / 5h
ENDIF 
 
IF (5h)
  dw 64h * 256 / 5h
ENDIF  

IF (5h)
  dw 64h * 256 / 5h
ENDIF  

IF (5h)
  dw 64h * 256 / 5h
ENDIF  

IF (5h)
  dw 64h * 256 / 5h
ENDIF

IF (5h)
  dw 64h * 256 / 5h
ENDIF
.ENDLITERAL

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_wGetRadialPos(BYTE bSnsGroup)
;  DESCRIPTION:
;      The function finds and returns the position of the centroid in the
;      difference array.
;-----------------------------------------------------------------------------
;  ARGUMENTS:
;       A => Sensor Group
;       Sensor Group = 0 for the independent sensors group
;       Sensor Group = 1 for the first slider group
;       Sensor Group = 2 for the second slider group
;  RETURNS:
;      result - centroid position (through X and A)
;-----------------------------------------------------------------------------
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------
 SmartSense_wGetRadialPos:
_SmartSense_wGetRadialPos:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   mov   [SmartSense_bCurCtrdSize], A  ;saves slider number
   dec   [SmartSense_bCurCtrdSize]
   asl   [SmartSense_bCurCtrdSize]

   ;getting A*6
   asl   A       ; A*2
   mov   [SmartSense_bCurSlider], A ;temporary saving A*2
   asl   A       ;A*4
   add   [SmartSense_bCurSlider], A ;A*6
   mov   A, [SmartSense_bCurSlider] ;now A points on bSnsgroup offset in Group table
   index SmartSense_Group_Table
   mov   [SmartSense_bStartIndex], A ;getting desired slider offset for waSnsDiff array
   mov   [SmartSense_bEndOfArray], A
   mov   A, [SmartSense_bCurSlider]
   inc   A
   index SmartSense_Group_Table
   add   [SmartSense_bEndOfArray], A ;getting final index in waSnsDiff for desired slider

   mov   A, [SmartSense_bCurCtrdSize]
   index SmartSense_RADIAL_SLIDER_RESOLUTION_MULTIPLIER_TABLE
   mov   [SmartSense_wCurPkValue + 0], A
   mov   A, [SmartSense_bCurCtrdSize]
   inc   A
   index SmartSense_RADIAL_SLIDER_RESOLUTION_MULTIPLIER_TABLE
   mov   [SmartSense_wCurPkValue + 1], A

   asl   [SmartSense_bEndOfArray]    ;*2 because we operating with WORDs
   asl   [SmartSense_bStartIndex]    ;*2 because we operating with WORDs
   sub   [SmartSense_bEndOfArray], 2 ;now it points on the last element

   ;These two variables contain required maximum
   mov   A, 0
   mov   [SmartSense_bBiggestCtrdSize], A        ;MSB
   mov   [SmartSense_bBiggestCtrdStartPos], A    ;LSB

   mov   [SmartSense_bCurPos], A                 ;this variable saves maximum position
   mov   X, [SmartSense_bStartIndex]             ;X - current position; access  will be performed through X (base+offset)

.IdentifyCtrd:
   RAM_SETPAGE_IDX >SmartSense_waSnsDiff
   mov   A, [X + SmartSense_waSnsDiff]
   jnz   .CheckIfMaximum
   mov   A, [X + SmartSense_waSnsDiff + 1]
   jnz   .DiffIsNotZero

;Difference is zero:
   jmp   .CheckNextSensor

.DiffIsNotZero:
   push  X
   mov   A, X
   asr   A
   mov   X, A
   RAM_SETPAGE_IDX >SmartSense_baBtnFThreshold
   mov   A, [X + SmartSense_baBtnFThreshold]
   pop   X
   RAM_SETPAGE_IDX >SmartSense_waSnsDiff
   cmp   A, [X + SmartSense_waSnsDiff + 1] ;Compare With FThreshold
   jnc   .CheckNextSensor
   jz    .CheckNextSensor

;waSnsDiff is greater than threshold
.CheckIfMaximum:
   ;Compare MSBs
   mov   A, [X + SmartSense_waSnsDiff]
   cmp   A, [SmartSense_bBiggestCtrdSize]
   jc    .CheckNextSensor
   jnz   .StoreNewMaximum

   ;Compare LSBs
   mov   A, [X + SmartSense_waSnsDiff + 1]
   cmp   A, [SmartSense_bBiggestCtrdStartPos]
   jc    .CheckNextSensor
   jz    .CheckNextSensor

;waSnsDiff is greater then stored maximum; saving new maximum
.StoreNewMaximum:
   mov   A, [X + SmartSense_waSnsDiff]
   mov   [SmartSense_bBiggestCtrdSize], A
   mov   A, [X + SmartSense_waSnsDiff + 1]
   mov   [SmartSense_bBiggestCtrdStartPos], A
   mov   [SmartSense_bCurPos], X ;this is a new maximum position

; Find out the next position
.CheckNextSensor:
   inc   X
   inc   X
   mov   A, X
   cmp   A, [SmartSense_bEndOfArray] ; Check for the end of the array
   jc    .IdentifyCtrd
   jz    .IdentifyCtrd

;---------Centroid calculation---------

   ;if there is no finger touch then return FFFFh
   mov   A, [SmartSense_bBiggestCtrdSize]
   jnz   .FillCentroidArray

   mov   A, [SmartSense_bBiggestCtrdStartPos]
   jnz   .FillCentroidArray

   ;There was no finger present: return FFFFh value through X, A
   ;and save the same in SmartSense_waSliderCurrPos
   mov   X, [SmartSense_bCurCtrdSize]

   ;Copy SmartSense_waSliderCurrPos to SmartSense_waSliderPrevPos
   RAM_SETPAGE_IDX >SmartSense_waSliderCurrPos
   mov   A, [X + SmartSense_waSliderCurrPos]
   RAM_SETPAGE_IDX >SmartSense_waSliderPrevPos
   mov   [X + SmartSense_waSliderPrevPos], A
   RAM_SETPAGE_IDX >SmartSense_waSliderCurrPos
   mov   A, [X + SmartSense_waSliderCurrPos + 1]
   RAM_SETPAGE_IDX >SmartSense_waSliderPrevPos
   mov   [X + SmartSense_waSliderPrevPos + 1], A

   ;set SmartSense_waSliderCurrPos to FFFFh
   RAM_SETPAGE_IDX >SmartSense_waSliderCurrPos
   mov   A, FFh
   mov   [X + SmartSense_waSliderCurrPos], A
   mov   [X + SmartSense_waSliderCurrPos + 1], A
   mov   X, A
   jmp   .Done

.FillCentroidArray:
   ;There was a finger present
   ;Fill waCentroid array with elements : centroid and its left and right adjacent values
   RAM_SETPAGE_IDX >SmartSense_waSnsDiff

   ;waCentroid[3] - array of three values: left adjacent, centroid, right adjacent
   ;waCentroid + 0  MSB of left adjacent
   ;waCentroid + 1  LSB of left adjacent
   ;waCentroid + 2  MSB of centroid
   ;waCentroid + 3  LSB of centroid
   ;waCentroid + 4  MSB of right adjacent
   ;waCentroid + 5  LSB of right adjacent

   ;1) left adjacent
   mov   A, [SmartSense_bCurPos]
   cmp   A, [SmartSense_bStartIndex]
   jnz   .CentriodIsNotInFirstPos

   ;Centroid is at first position
   mov   X, [SmartSense_bEndOfArray] ;left adjacent(i-1)
   jmp   .CopyingLeft

.CentriodIsNotInFirstPos:
   mov   X, [SmartSense_bCurPos] ;left adjacent(i-1)
   dec   X
   dec   X

.CopyingLeft:
   mov   A, [X + SmartSense_waSnsDiff + LSB]
   mov   [SmartSense_waCentroid + 1], A
   mov   A, [X + SmartSense_waSnsDiff + MSB]
   mov   [SmartSense_waCentroid + 0], A

   ;2) Maximum
   mov   X, [SmartSense_bCurPos] ;maximum(i)

.CopyingMaximum:
   mov   A, [X + SmartSense_waSnsDiff + LSB]
   mov   [SmartSense_waCentroid + 3], A
   mov   A, [X + SmartSense_waSnsDiff + MSB]
   mov   [SmartSense_waCentroid + 2], A

   ;3) right adjacent
   mov   A, [SmartSense_bCurPos]
   cmp   A, [SmartSense_bEndOfArray]
   jnz   .CentriodIsNotInLastPos

   ;Centroid is at last position
   mov   X, [SmartSense_bStartIndex] ;right adjacent(i+1)
   jmp   .CopyingRight

.CentriodIsNotInLastPos:
   mov   X, [SmartSense_bCurPos] ;right adjacent(i+1)
   inc   X
   inc   X

.CopyingRight:
   mov   A, [X + SmartSense_waSnsDiff + LSB]
   mov   [SmartSense_waCentroid + 5], A
   mov   A, [X + SmartSense_waSnsDiff + MSB]
   mov   [SmartSense_waCentroid + 4], A

   mov   A, [SmartSense_bNoiseThreshold]
.SubstractNoise0:
   mov   X, 00h
   sub   [SmartSense_waCentroid + 1], A
   sbb   [SmartSense_waCentroid + 0], 0
   jnc   .SubstractNoise1

   mov   [SmartSense_waCentroid + 1], X
   mov   [SmartSense_waCentroid + 0], X

.SubstractNoise1:
   sub   [SmartSense_waCentroid + 3], A
   sbb   [SmartSense_waCentroid + 2], 0
   jnc   .SubstractNoise2

   mov   [SmartSense_waCentroid + 3], X
   mov   [SmartSense_waCentroid + 2], X

.SubstractNoise2:
   sub   [SmartSense_waCentroid + 5], A
   sbb   [SmartSense_waCentroid + 4], 0
   jnc   .RestoreX

   mov   [SmartSense_waCentroid + 5], X
   mov   [SmartSense_waCentroid + 4], X

.RestoreX:
   mov   X, [SmartSense_bCurPos]

   call  CalcCentroid
   ;result is now in dMultTempY variable

   mov   X, [SmartSense_bCurCtrdSize]

   ;there was finger presence before (during last function call)
   RAM_SETPAGE_IDX >SmartSense_waSliderCurrPos
   mov   A, [X + SmartSense_waSliderCurrPos]
   RAM_SETPAGE_IDX >SmartSense_waSliderPrevPos
   mov   [X + SmartSense_waSliderPrevPos], A
   RAM_SETPAGE_IDX >SmartSense_waSliderCurrPos
   mov   A, [X + SmartSense_waSliderCurrPos + 1]
   RAM_SETPAGE_IDX >SmartSense_waSliderPrevPos
   mov   [X + SmartSense_waSliderPrevPos + 1], A

   mov   A, [SmartSense_dMultTempY + 0];MSB of result
   RAM_SETPAGE_IDX >SmartSense_waSliderCurrPos
   mov   [X + SmartSense_waSliderCurrPos], A

   mov   A, [SmartSense_dMultTempY + 1];LSB of result
   RAM_SETPAGE_IDX >SmartSense_waSliderCurrPos
   mov   [X + SmartSense_waSliderCurrPos + 1], A

   mov   X, [SmartSense_dMultTempY + 0]

.Done:
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: void CalcCentroid(WORD result)
;  DESCRIPTION:
;    Calculates touch position using centroid algorithm basing on 3 signals
;    (local maximum and adjacent)
;-----------------------------------------------------------------------------
;  ARGUMENTS:
;    None, signal values are taken from waCentroid global array
;  RETURNS:
;   calculated touch position
;-----------------------------------------------------------------------------
 CalcCentroid:
_CalcCentroid:
   ;Zeroing
   mov   A, 0
   mov   [SmartSense_dMultTempX + 0], A
   mov   [SmartSense_dMultTempX + 1], A
   mov   [SmartSense_dMultTempX + 3], A
   mov   [SmartSense_wDenom + 0], A

   ;---calculate denominator: (i- 1 ) + i + (i+1)
   mov   A, [SmartSense_waCentroid + 1]                 ;LSB(i-1)
   add   A, [SmartSense_waCentroid + 3]                 ;add LSB(i)
   adc   [SmartSense_wDenom + 0], 0                     ;save carry
   add   A, [SmartSense_waCentroid + 5]                 ;add LSB(i + 1)
   adc   [SmartSense_wDenom + 0], 0                     ;save carry
   mov   [SmartSense_wDenom + 1], A                     ;save result

   mov   A, [SmartSense_waCentroid + 0]                 ;MSB(i-1)
   add   A, [SmartSense_waCentroid + 2]                 ;add MSB(i)
   add   A, [SmartSense_waCentroid + 4]                 ;add MSB(i + 1)
   add   [SmartSense_wDenom + 0], A                     ;save result

   ;----- calculate numerator (i+1) - (i-1)
   mov   A, [SmartSense_waCentroid + 5]                 ;LSB(i+1)
   sub   A, [SmartSense_waCentroid + 1]                 ;sub LSB(i-1)
   sbb   [SmartSense_dMultTempX + 1], 0                 ;save borrow
   mov   [SmartSense_dMultTempX + 2], A                 ;save result

   mov   A, [SmartSense_waCentroid + 4]                 ;MSB(i+1)
   sub   A, [SmartSense_waCentroid + 0]                 ;sub MSB(i-1)
   add   [SmartSense_dMultTempX + 1], A                 ;save result

   call  SmartSense_div_24_16_24                        ; calculate Sum(Si*i)/Sum(Si)
   mov   A, X
   sub   A, [SmartSense_bStartIndex]
   asr   A
   add   [SmartSense_dMultTempX + 2], A                 ;

   tst   [SmartSense_dMultTempX + 2], 80h
   jz .Mult

   mov   A, [SmartSense_bEndOfArray]
   sub   A, [SmartSense_bStartIndex]
   asr   A
   inc   A
   add   [SmartSense_dMultTempX + 2], A                 ;

.Mult:
   call  SmartSense_mul_16x16_32                        ; dMultTempY contains calculated coordinate (two MSB)

   mov   A, [SmartSense_dMultTempY + 0]                ; Returns result through X an d A
   mov   X, A
   mov   A, [SmartSense_dMultTempY + 1]

   ret
.ENDSECTION
ENDIF

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_div_24_16_24
;  DESCRIPTION:
;  Applies 24-bit signed result of 24-bit signed operands division
;-----------------------------------------------------------------------------
;  ARGUMENTS:
;   (MSB)[dMultTempX+1][dMultTempX+2][dMultTempX+3](LSB) - first 24-bit signed operand of division
;                           (dividend)
;   (MSB)[wDenom][wDenom+1](LSB) - second 16-bit unsigned operand of division
;                            (divisor)
;  RETURNS:   (MSB)[dMultTempX+1][dMultTempX+2][dMultTempX+3](LSB) - 24-bit signed operand of division
;                           (dividend)
;-----------------------------------------------------------------------------
 SmartSense_div_24_16_24:
_SmartSense_div_24_16_24:
   mov   A,FFh
   cmp   [SmartSense_dMultTempX + 1],80h
   jc    .L1                   ;check sign of operand 1
   xor   [SmartSense_dMultTempX + 3],A         ;unsigned convertation of operand 1 (inversion + 1)
   inc   [SmartSense_dMultTempX + 3]
   xor   [SmartSense_dMultTempX + 2],A
   adc   [SmartSense_dMultTempX + 2],00h
   xor   [SmartSense_dMultTempX + 1],A
   adc   [SmartSense_dMultTempX + 1],00h
   mov   [SmartSense_dMultTempX + 0], A

.L1:
   mov   A,00h
   mov   [SmartSense_dMultTempY + 0],A  ;additional temporary memory for calculations
   mov   [SmartSense_dMultTempY + 1],A
   mov   [SmartSense_dMultTempY + 2],A
   mov   [SmartSense_dMultTempY + 3],A

   mov   [SmartSense_bCurPkPos], 24        ;amount of cycles divider procedure

   ;Begin of divider procedure
j4_1:
   asl   [SmartSense_dMultTempX + 3]
   rlc   [SmartSense_dMultTempX + 2]
   rlc   [SmartSense_dMultTempX + 1]

   rlc   [SmartSense_dMultTempY + 3]
   rlc   [SmartSense_dMultTempY + 2]
   rlc   [SmartSense_dMultTempY + 1]

   mov   A,[SmartSense_dMultTempY + 3]
   sbb   A,[SmartSense_wDenom + 1]
   mov   A,[SmartSense_dMultTempY + 2]
   sbb   A,[SmartSense_wDenom + 0]
   mov   A,[SmartSense_dMultTempY + 1]
   sbb   A, 0
   jc    j4_2
   mov   [SmartSense_dMultTempY + 1],A
   mov   A,[SmartSense_wDenom + 1]
   sub   [SmartSense_dMultTempY + 3],A
   mov   A,[SmartSense_wDenom + 0]
   sbb   [SmartSense_dMultTempY + 2],A
   inc   [SmartSense_dMultTempX + 3]
j4_2:
   dec   [SmartSense_bCurPkPos]
   jnz   j4_1

   ;End of divider procedure
   mov   A, FFh
   cmp   [SmartSense_dMultTempX + 0],80h
   jc    .L2                   ;check sign of result
   xor   [SmartSense_dMultTempX + 3],A         ;unsigned convertation of operand 1
   inc   [SmartSense_dMultTempX + 3]
   xor   [SmartSense_dMultTempX + 2],A
   adc   [SmartSense_dMultTempX + 2],00h
   xor   [SmartSense_dMultTempX + 1],A
   adc   [SmartSense_dMultTempX + 1],00h
   xor   [SmartSense_dMultTempX + 0],A
.L2:

   ret
.ENDSECTION

IF (SmartSense_SLIDERS_EXIST|(~SmartSense_AUTO_THRESHOLD_ENABLED))
.SECTION
;-----------------------------------------------------------------------------
;  FRAGMENT NAME: SmartSense_mul_16x16_32
;  DESCRIPTION:
;     Ancillary fragment for integer fastcall16 functions. Applies 32-bit
;     unsigned result of two 16-bit unsigned operands multiplication
;-----------------------------------------------------------------------------
;  ARGUMENTS:
;     (MSB)[dMultTempX+2][dMultTempX+3](LSB) - 16-bit unsigned multiplier (first operand)
;    wCurPkValue - 16-bit unsigned multiplicand (second operand)
;  RETURNS:
;     (MSB)[dMultTempY][dMultTempY+1][wCurPkValue + 0][wCurPkValue + 1](LSB) - 32-bit unsigned multiplication result
;-----------------------------------------------------------------------------
 SmartSense_mul_16x16_32:
_SmartSense_mul_16x16_32:
   mov   A,00h
   mov   [SmartSense_dMultTempY + 0],A             ; clear LSB of result
   mov   [SmartSense_dMultTempY + 1],A            ; clear MSB of result

   add   A,10h                                          ;clear CARRY-bit and
   mov   [SmartSense_bCurPkPos],A                 ;init loop counter

.jLab2:
   tst   [SmartSense_wCurPkValue + 1],01h
   jz    .jLab1
   mov   A,[SmartSense_dMultTempX+3]            ;if [wTmp2+LSB].0=1 then result+=first operand
   add   [SmartSense_dMultTempY+1],A
   mov   A,[SmartSense_dMultTempX+2]
   adc   [SmartSense_dMultTempY],A
.jLab1:
   rrc   [SmartSense_dMultTempY]             ; 1-bit right shift of second operand
   rrc   [SmartSense_dMultTempY+1]
   rrc   [SmartSense_wCurPkValue + 0]            ; 1-bit left shift of first operand
   rrc   [SmartSense_wCurPkValue + 1]
   dec   [SmartSense_bCurPkPos]            ; decrement loop counter
   jnz   .jLab2

   ret
.ENDSECTION
ENDIF

IF (SmartSense_IMMUNITY_LEVEL / 2)
.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_MedianFilter(void)
;
;  DESCRIPTION:
;      Applies a midian filter to 3 input values
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;      None. Input values are SmartSense_wX1, SmartSense_wX2 and SmartSense_wX3
;
;  RETURNS:
;      Nothing. Relult is in SmartSense_wX1
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
MedianFilter:
 SmartSense_MedianFilter:
_SmartSense_MedianFilter:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   mov   A, [SmartSense_wX1+LSB]                 ; if X1 > X2
   cmp   A, [SmartSense_wX2+LSB]
   mov   A, [SmartSense_wX1+MSB]
   sbb   A, [SmartSense_wX2+MSB]
   jc    .L1

   mov   A, [SmartSense_wX1+LSB]                 ; then  X1 <--> X2
   swap  A, [SmartSense_wX2+LSB]
   mov   [SmartSense_wX1+LSB], A
   mov   A, [SmartSense_wX1+MSB]
   swap  A, [SmartSense_wX2+MSB]
   mov   [SmartSense_wX1+MSB], A

.L1:
   mov   A, [SmartSense_wX2+LSB]                 ; if X2 > X3
   cmp   A, [SmartSense_wX3+LSB]
   mov   A, [SmartSense_wX2+MSB]
   sbb   A, [SmartSense_wX3+MSB]
   jc    .L2

   mov   [SmartSense_wX2+LSB], [SmartSense_wX3+LSB]  ; then  X2 := X3
   mov   [SmartSense_wX2+MSB], [SmartSense_wX3+MSB]

.L2:
   mov   A, [SmartSense_wX1+LSB]                 ; if X1 > X2
   cmp   A, [SmartSense_wX2+LSB]
   mov   A, [SmartSense_wX1+MSB]
   sbb   A, [SmartSense_wX2+MSB]
   jnc   .Done                                      ; then  result is in X1

   mov   [SmartSense_wX1+LSB], [SmartSense_wX2+LSB]  ; else  X1 := X2
   mov   [SmartSense_wX1+MSB], [SmartSense_wX2+MSB]

.Done:
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION
ENDIF

IF (SmartSense_AUTO_THRESHOLD_ENABLED)
ELSE
.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_LoadFixedParameters(BYTE bSensor)
;
;  DESCRIPTION:
;     Sets parameters for sensor scan
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;    A - Sensor Number
;  RETURNS:
;    None
;  SIDE EFFECTS:
;    The X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to preserve their values across calls to fastcall16
;    functions.
;
_SmartSense_LoadFixedParameters:
 SmartSense_LoadFixedParameters:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0
   mov   X, A 
   mov   [SmartSense_bLowBaselineReset], SmartSense_LOW_BASELINE_RESET       ; Init bLowBaselineReset

   RAM_SETPAGE_IDX >SmartSense_baBtnFThreshold
   mov   A, [X + SmartSense_baBtnFThreshold]

   asr   A
   and   A, 7Fh
   mov   [SmartSense_bNoiseThreshold], A                                           ; bNoiseThreshold = 50% of finger threshold
   mov   [SmartSense_bNegativeNoiseThreshold], [SmartSense_bNoiseThreshold]  ; bNegativeNoiseThreshold = 50% of finger threshold

   asr   A
   asr   A
   and   A, 1Fh
   mov   [SmartSense_bHysteresis], A                                               ; bHysteresis = 12.5 % of finger threshold
   mov   [SmartSense_bBaselineUpdateThreshold], A                                  ; bBaselineUpdateThreshold = 12.5 % of finger threshold

   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION
ENDIF

IF (SmartSense_AUTO_THRESHOLD_ENABLED)      
ELSE
.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_SetDefaultFingerThreshold()
;
;  DESCRIPTION:
;     Set default finger threshold based on the 80% of user finger 
;                     fingerthreshold with calculated sensitivity.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;    None
;  RETURNS:
;    None
;  SIDE EFFECTS:
;    The X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to preserve their values across calls to fastcall16
;    functions.
;
_SmartSense_SetDefaultFingerThreshold:
 SmartSense_SetDefaultFingerThreshold:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0
   
   mov   X, (SmartSense_TOTALSENSORCOUNT - 1)
.UpdateThresholdloop: 
   push  X 
   mov   A, X       
   mov   X, 0    ; Empty Carry flag   
   add   A, <SmartSense_Finger_Threshold_Table   ; Get string LSB address
   swap  A, X
   adc   A, >SmartSense_Finger_Threshold_Table   ; Get string MSB address   
   romx
   mov   [SmartSense_dMultTempX + 3], A   
   mov   [SmartSense_dMultTempX + 2], 0   
   pop   X 
   RAM_SETPAGE_IDX >_baK
   mov   A, [X + _baK]                                 ; Get sensitivity value  
   RAM_SETPAGE_CUR >SmartSense_wCurPkValue   
   mov   [SmartSense_wCurPkValue + 1], A  
   mov   [SmartSense_wCurPkValue + 0], 0  
   call  SmartSense_mul_16x16_32
   
   mov   A, 7
.div_128_loop:                                         ; Devide by 128
   asr   [SmartSense_wCurPkValue + 0]            ; MSB
   rrc   [SmartSense_wCurPkValue + 1]            ; LSB  
   dec   A
   jnz   .div_128_loop  
   mov   A, [SmartSense_wCurPkValue + 1]
   RAM_SETPAGE_IDX >SmartSense_baBtnFThreshold    
   mov   [X + SmartSense_baBtnFThreshold], A   

   dec   X
   jnc   .UpdateThresholdloop   
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION
ENDIF

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_UpdateSensorSignal(BYTE bSensorNum)
;
;  DESCRIPTION:
; Normalized difference count will be store to the SmartSense_baSnsSignal.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;      A  => Sensor Index
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 SmartSense_UpdateSensorSignal:
_SmartSense_UpdateSensorSignal:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0
   
   mov   [SmartSense_bSensorNum], A 
   asl   A                                            ; Multiply by two since vars are INTs
   mov   X, A
   RAM_SETPAGE_IDX >SmartSense_waSnsDiff
   mov   A, [X + SmartSense_waSnsDiff + LSB] 
   mov   [SmartSense_dMultTempX + 3], A  
   mov   A, [X + SmartSense_waSnsDiff + MSB]
   mov   [SmartSense_dMultTempX + 2], A   
   mov   [SmartSense_dMultTempX + 1], 0
   mov   [SmartSense_dMultTempX + 0], 0   
   mov   A, 7
.mul_128_loop:                                        ; Multiply on 128
   asl   [SmartSense_dMultTempX + 3]             ; LSB  
   rlc   [SmartSense_dMultTempX + 2]
   rlc   [SmartSense_dMultTempX + 1]
   rlc   [SmartSense_dMultTempX + 0]             ; MSB 
   dec   A
   jnz   .mul_128_loop

   mov   X, [SmartSense_bSensorNum]   
   
   RAM_SETPAGE_IDX >_baK
   mov   A, [X + _baK]                                ; Get sensitivity value
   jz    .skip_div                                    ; Check if null - do not devide on null
   mov   [SmartSense_wDenom + 1], A  
   mov   [SmartSense_wDenom + 0], 0              ; Init MSB Denominator
   call  SmartSense_div_24_16_24 
.skip_div:
   RAM_SETPAGE_IDX >SmartSense_baSnsSignal 
   mov   A, [SmartSense_dMultTempX + 2]          ; Check if baSnsSignal > 255
   jnz   .UpdateSnSSignal255
   mov   A, [SmartSense_dMultTempX + 1]   
   jnz   .UpdateSnSSignal255
   mov   A, [SmartSense_dMultTempX + 0]          ; MSB init
   jnz   .UpdateSnSSignal255
   mov   A, [SmartSense_dMultTempX + 3]  
   mov   [X + SmartSense_baSnsSignal], A   
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret   
.UpdateSnSSignal255:                                   ; baSnsSignal < 255
   mov   A, 255
   mov   [X + SmartSense_baSnsSignal], A         ; Set max value
   
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

IF (SmartSense_AUTO_THRESHOLD_ENABLED) 
.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_LoadParameters(BYTE bSensor)
;
;  DESCRIPTION:
;     Sets scan parameters for sensor scan. 
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;    A - Sensor Number
;  RETURNS:
;    None
;  SIDE EFFECTS:
;    The X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to preserve their values across calls to fastcall16
;    functions.
;
_SmartSense_LoadParameters:
 SmartSense_LoadParameters:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0
   
   mov   X, A
   mov   [SmartSense_bLowBaselineReset], SmartSense_LOW_BASELINE_RESET   ; Init bLowBaselineReset
   
   RAM_SETPAGE_IDX >SmartSense_baBtnFThreshold
   mov   A, [X + SmartSense_baBtnFThreshold]                                   ; Finger threshold -> A 
   asr   A
   asr   A
   asr   A
   and   A, 1Fh   
   mov   [SmartSense_bHysteresis], A                                           ; bHysteresis = 12.5 % of finger threshold
   mov   [SmartSense_bBaselineUpdateThreshold], A                              ; bBaselineUpdateThreshold = 12.5 % of finger threshold 

   RAM_SETPAGE_IDX >SmartSense_baNoiseThreshold
   mov   A, [X + SmartSense_baNoiseThreshold]   
   mov   [SmartSense_bNoiseThreshold], A                                       ; Get bNoiseThreshold for current scan 
   mov   [SmartSense_bNegativeNoiseThreshold], A   

   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION
ENDIF

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_ProcessData(BYTE bSensorIdx)
;
;  DESCRIPTION:
;    Scans all sensors to find their raw count values
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    A => Sensor index
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
ProcessData:
 SmartSense_ProcessData:
_SmartSense_ProcessData:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   asl   A   
   mov   X, A
   ; Store the data
   mov   A, [SmartSense_wADC_Result + LMSB]  ; Store result in waSnsResult array  
   RAM_SETPAGE_IDX >SmartSense_waSnsResult 
   mov   [X +SmartSense_waSnsResult + LSB], A 

   mov   A, [SmartSense_wADC_Result + MLSB]    
   mov   [X +SmartSense_waSnsResult + MSB], A  

   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: SmartSense_ProcessDiff(BYTE bSensorIdx)
;
;  DESCRIPTION:
;    Copies baDiffCountHoppChannel to wX1
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    A => Sensor index
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
ProcessDiff:
 SmartSense_ProcessDiff:
_SmartSense_ProcessDiff:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   asl   A    
   mov   X, A
   ; Store the data
   RAM_SETPAGE_IDX >SmartSense_waDiffCountHoppChannel
   mov   A, [X + SmartSense_waDiffCountHoppChannel+LSB]     
   mov   [SmartSense_wX1 + LSB], A   
   mov   A, [X + SmartSense_waDiffCountHoppChannel+MSB]    
   mov   [SmartSense_wX1 + MSB], A 

   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION
