;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: SmartSenseTABLE.asm
;;    Version: 1.00, Updated on 2012/3/2 at 9:15:19
;;  Generated by PSoC Designer 5.3.2710
;;  DESCRIPTION: SmartSense_EMCplus User Module Sensor Table
;;
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "SmartSense.inc"

;-----------------------------------------------
;  Global Labels
;-----------------------------------------------

; Exported table
export  SmartSense_Sensor_Table
export _SmartSense_Sensor_Table
export _Sensitivity_Level_Table
export SmartSense_Sensitivity_Level_Table
export _SmartSense_Sensitivity_Level_Table  
export SmartSense_Finger_Threshold_Table
export _SmartSense_Finger_Threshold_Table

AREA UserModules (ROM, REL, CON)

.LITERAL
;---------------------------------
; Tables below generated by Wizard
;---------------------------------
; The Sensor Table consists of two bytes for each sensor.  The first byte is the
; port number and the second is the bit mask for the bit not to be confused with
; the bit number.  For example an entry for port 2 bit 3 (P2[3])  would be
; "dw 0x0208".  This table consist of 0x5 sensors.
 SmartSense_Sensor_Table:
_SmartSense_Sensor_Table:
	dw	0x0104	// Port 1 Bit 2
	dw	0x0108	// Port 1 Bit 3
	dw	0x0110	// Port 1 Bit 4
	dw	0x0120	// Port 1 Bit 5
	dw	0x0180	// Port 1 Bit 7

.ENDLITERAL

IF	(TOOLCHAIN & HITECH)
  AREA lit (ROM,REL,CON)
ELSE
  AREA lit (ROM,REL,CON,LIT)
ENDIF

.LITERAL
;---------------------------------
; The Finger Threshold Table defines the Normalized Finger Threshold 
; for each sensor. 
 SmartSense_Finger_Threshold_Table:
_SmartSense_Finger_Threshold_Table:
db 30, 30, 30, 30, 30; Sliders


;---------------------------------
; The Sensitivity Level Table defines the Sensor Sensitivity  
; for each sensor.
 _Sensitivity_Level_Table: 
 SmartSense_Sensitivity_Level_Table:
_SmartSense_Sensitivity_Level_Table:
db 1, 1, 1, 1, 1; Sliders


.ENDLITERAL
